<?php

// imports
require_once 'GenericAdmin/GenericAdmin.php';
require_once 'util/Config.php';

class AlarmInterfaceAdministration extends GenericAdmin {

	function __construct() {
		// load common Configuration
		include  'AlarmInterface/Watchdog/ConfigurationData.php';
		Config::setConfiguration($configurationData);
		
		// Generic Administration configuration data
		include 'AlarmInterface/Watchdog/GenadData.php';
		parent::setDscrData($mocd_tab, $atdc_tab);
		$this->cur_app = "AlarmInterface";
	}
	
	function triggerWatchdog($xml) {
		require_once 'AlarmInterface/Watchdog/Watchdog.php';
		
		$logger = Logger::getInstance();
		$logger->log(__CLASS__, "function: triggerWatchdog");
		$logger->log(__CLASS__, "xml: " . $xml);
		
		$ta = null;
		
		try {

			// start transaction
			$ta = Transaction::getInstance("AlarmInterface");
			$ta->startTA();
		
			// call implementation
			require_once 'AlarmInterface/Watchdog/Watchdog.php';
			require_once 'AlarmManagement/DataTypes/InstAddr.php';
			$result = Watchdog::triggerXML($xml);
			
			// commit TA
			$ta->commitTA();
		}
		catch(Exception $e) {
			$logger->logException(__CLASS__, $e);
			
			// rollback TA
			if ($ta) $ta->rollbackTA();
			$result = "<error/>";
		}
		
		return $result;
		
	}

}
