<?php

// define user
$user = getenv("USER");
if ($user == "") putenv("USER=rest");

// includes
$path = preg_replace("/SysAl.*/", "SysAl", __FILE__);
set_include_path($path . PATH_SEPARATOR . get_include_path());
//require_once 'util/Logger.php';
require_once 'util/Config.php';

// load configuration + class loader
include 'REST/ConfigurationData.php';
Config::setConfiguration($configurationData);

// Logging
$logger = Logger::getInstance();
$requestMethod = $_SERVER["REQUEST_METHOD"];
$logger->log(__FILE__, $requestMethod);
/*
$logger->log(__FILE__, "GET-Variabeles:");
while ( list($key, $value) = each($_GET) ) {
	$logger->log(__FILE__, $key . " : " . $value);;
}
$logger->log(__FILE__, "POST-Variabeles:");
while ( list($key, $value) = each($_POST) ) {
	$logger->log(__FILE__, $key . " : " . $value);;
}
*/
$logger->log(__FILE__,"Redirect-URL:".$_SERVER["REDIRECT_URL"]);

// extract REST request
$req_type = $_SERVER["REQUEST_METHOD"];
$redirect_url = $_SERVER["REDIRECT_URL"];
$request = preg_replace("/.*rest\//", "", $redirect_url);

// extract input stream
$data = file_get_contents("php://input");
$logger->log(__FILE__,"Input data:".$data);

// call implementation
require_once 'REST/ProcessREST.php';
try {
	$result = ProcessREST::doIt($req_type, $request, $data);
}
catch (Exception $e) {
	$logger->logException(__FILE__, $e);	
	$result = "<html><body>Error occurred!</body></html>";
}

echo $result;
