<?php



/**
 * Skeleton subclass for performing query and update operations on the 'rem_wdog' table.
 *
 * 
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    propel.generator.propel
 */
class RemoteWatchdogQuery extends BaseRemoteWatchdogQuery {
	
	/**
	 * Get Watchdogs, where alarms have to be set
	 *
	 * @param      Current UNIX time stamp (int).
	 * @param      PropelPDO Optional Connection object.
	 * @return     PropelCollection|array Watchdog[] List of Watchdog objects
	 * @throws     PropelException
	 */
	static public function getWatchdogsToAlarm($time, PropelPDO $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(RemoteWatchdogPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}
		
		$query = "select * from rem_wdog where (:p1 - last_ping) > min_int AND NOT has_alarm AND NOT inactive";
		
		// execute query
		$stmt = $con->prepare($query);
		$stmt->bindValue(':p1', $time, PDO::PARAM_INT);
		$succ = $stmt->execute();
		if (!$succ) throw new Exception("Statement execution not succeeded");
		return RemoteWatchdogPeer::populateObjects($stmt);
	}
	
	static public function getWatchdogsToReset($time, PropelPDO $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(RemoteWatchdogPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}
		
		$query = "select * from rem_wdog where (:p1 - last_ping) < min_int AND has_alarm";
		
		// execute query
		$stmt = $con->prepare($query);
		$stmt->bindValue(':p1', $time, PDO::PARAM_INT);
		$succ = $stmt->execute();
		if (!$succ) throw new Exception("Statement execution not succeeded");
		return RemoteWatchdogPeer::populateObjects($stmt);
	}
	
	
} // RemoteWatchdogQuery
