#!/usr/bin/php
<?php
// cron job for periodic watchdog check

$path = preg_replace("/SysAl.*/", "SysAl", __FILE__);
set_include_path($path . PATH_SEPARATOR . get_include_path());
require_once 'util/Logger.php';
require_once 'util/Transaction.php';

// define user
$user = getenv("USER");
if ($user == "") putenv("USER=cron");

// load configuration
include  'AlarmInterface/Watchdog/ConfigurationData.php';
Config::setConfiguration($configurationData);

// Logging
$logger = Logger::getInstance();
$logger->log(__FILE__, "function: checkWathdog");
$ta = null;

try {

	// start transaction
	$ta = Transaction::getInstance("AlarmInterface");
	$ta->startTA();

	// call implementation
	require_once 'AlarmInterface/Watchdog/Watchdog.php';
	Watchdog::checkRemoteWatchdog();
	//Watchdog::checkPingWatchdog();
	
	$ta->commitTA();
}
catch(Exception $e) {

	// rollback TA
	$logger->logException(__CLASS__, $e);
	$ta->rollbackTA();
	exit(99);
}


