<?php

require_once 'AlarmManagement/DataTypes/AdminState.php';
require_once 'AlarmManagement/DataTypes/SelectMode.php';

/**
 * Skeleton subclass for representing a row from the 'alm_forw_inst' table.
 *
 * 
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    propel.generator.propel
 */
class AlarmForwardingInstruction extends BaseAlarmForwardingInstruction {

	/**
	 * Overrides parent methods to switch between db value and type class instance
	 */

	public function getAdminState() {
		return new AdminState($this->admin_state);
	} 

	public function setAdminState($admin_state) {
		parent::setAdminState($admin_state->getValue());
	} 

	public function getEvtSelMode() {
		return new SelectMode($this->evt_sel_mode);
	}

	public function setEvtSelMode($sel_mode) {
		parent::setEvtSelMode($sel_mode->getValue());
	}

	public function getForwEvtSel() {
		$fes_lst = $this->getFess();
		$aed_ids = array ();
		foreach ($fes_lst as $fes) {
			$aed_ids[] = $fes->getAlarmEventDescriptor()->getId();
		}
		return $aed_ids;
	} 

	public function setForwEvtSel($value) {
		$fes_lst = $this->getFess();
		foreach ($fes_lst as $fes) {
			$fes->delete();
		}
		$this->clearFess();  // this is necessary to erase the fes buffer
		foreach ($value as $aed_id) {
			$fes = new ForwardingEventSelector();
			$fes->setAfiId($this->getId());
			$fes->setAedId($aed_id);
			$fes->save();
		}
		return;
	} 

	public function getDestHostSel() {
		$dhs_lst = $this->getDhss();
		$amh_ids = array ();
		foreach ($dhs_lst as $dhs) {
			$amh_ids[] = $dhs->getAlarmingManagementHost()->getId();
		}
		return $amh_ids;
	} 

	public function setDestHostSel($value) {
		$dhs_lst = $this->getDhss();
		foreach ($dhs_lst as $dhs) {
			$dhs->delete();
		}
		$this->clearDhss();  // this is necessary to erase the dhs buffer
		foreach ($value as $amh_id) {
			$dhs = new DestinationHostSelector();
			$dhs->setAfiId($this->getId());
			$dhs->setAmhId($amh_id);
			$dhs->save();
		}
		return;
	} 

	/**
	 * Overrides parent method to maintain modification counting
	 */
	public function save(PropelPDO $con = null)
	{
		if ($this->isNew() || $this->mod >= 999999) {
			$this->setMod(0);
		} else {
			$this->setMod($this->mod + 1);
		}
		return parent::save($con);
	}

} // AlarmForwardingInstruction
