<?php

require_once 'AlarmManagement/DataTypes/AlarmSevty.php';
require_once 'AlarmManagement/DataTypes/SelectMode.php';

/**
 * Skeleton subclass for representing a row from the 'asev_asgt_rule' table.
 *
 * 
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    propel.generator.propel
 */
class AlarmSeverityAssignmentRule extends BaseAlarmSeverityAssignmentRule {

	/**
	 * Overrides parent methods to switch between db value and type class instance
	 */

	public function getSevServIndep() {
		return new AlarmSevty($this->sev_serv_indep);
	}

	public function setSevServIndep($alm_sev) {
		parent::setSevServIndep($alm_sev->getValue());
	}

	public function getSevServUnaff() {
		return new AlarmSevty($this->sev_serv_unaff);
	}
	
	public function setSevServUnaff($alm_sev) {
		parent::setSevServUnaff($alm_sev->getValue());
	}

	public function getSevServAff() {
		return new AlarmSevty($this->sev_serv_aff);
	}

	public function setSevServAff($alm_sev) {
		parent::setSevServAff($alm_sev->getValue());
	}

	public function getEvtSelMode() {
		return new SelectMode($this->evt_sel_mode);
	}

	public function setEvtSelMode($sel_mode) {
		parent::setEvtSelMode($sel_mode->getValue());
	}

	public function getAsgtEvtSel() {
		$aes_lst = $this->getAess();
		$aed_ids = array ();
		foreach ($aes_lst as $aes) {
			$aed_ids[] = $aes->getAlarmEventDescriptor()->getId();
		}
		return $aed_ids;
	} 

	public function setAsgtEvtSel($value) {
		$aes_lst = $this->getAess();
		foreach ($aes_lst as $aes) {
			$aes->delete();
		}
		$this->clearAess();  // this is necessary to erase the aes buffer
		foreach ($value as $aed_id) {
			$aes = new AssignmentEventSelector();
			$aes->setAlarmSeverityAssignmentRule($this);
			$aes->setAedId($aed_id);
			$aes->save();
		}
		return;
	} 

	/**
	 * Overrides parent method to maintain modification counting
	 */
	public function save(PropelPDO $con = null)
	{
		if ($this->isNew() || $this->mod >= 999999) {
			$this->setMod(0);
		} else {
			$this->setMod($this->mod + 1);
		}
		return parent::save($con);
	}

} // AlarmSeverityAssignmentRule
