<?php


/**
 * Base class that represents a row from the 'alm_evt_dscr' table.
 *
 *
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAlarmEventDescriptor extends BaseObject implements Persistent
{
    /**
     * Peer class name
     */
    const PEER = 'AlarmEventDescriptorPeer';

    /**
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var        AlarmEventDescriptorPeer
     */
    protected static $peer;

    /**
     * The flag var to prevent infinite loop in deep copy
     * @var       boolean
     */
    protected $startCopy = false;

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the mod field.
     * @var        int
     */
    protected $mod;

    /**
     * The value for the name field.
     * @var        string
     */
    protected $name;

    /**
     * The value for the evt_spec_sel field.
     * @var        int
     */
    protected $evt_spec_sel;

    /**
     * The value for the evt_spec_val field.
     * @var        string
     */
    protected $evt_spec_val;

    /**
     * @var        PropelObjectCollection|CurrentAlarmCondition[] Collection to store aggregation of CurrentAlarmCondition objects.
     */
    protected $collCacs;
    protected $collCacsPartial;

    /**
     * @var        PropelObjectCollection|AssignmentEventSelector[] Collection to store aggregation of AssignmentEventSelector objects.
     */
    protected $collAess;
    protected $collAessPartial;

    /**
     * @var        PropelObjectCollection|ThresholdAlarmSeverityAssignmentRule[] Collection to store aggregation of ThresholdAlarmSeverityAssignmentRule objects.
     */
    protected $collTasars;
    protected $collTasarsPartial;

    /**
     * @var        PropelObjectCollection|BalancingEventSelector[] Collection to store aggregation of BalancingEventSelector objects.
     */
    protected $collBess;
    protected $collBessPartial;

    /**
     * @var        PropelObjectCollection|ForwardingEventSelector[] Collection to store aggregation of ForwardingEventSelector objects.
     */
    protected $collFess;
    protected $collFessPartial;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInSave = false;

    /**
     * Flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInValidation = false;

    /**
     * Flag to prevent endless clearAllReferences($deep=true) loop, if this object is referenced
     * @var        boolean
     */
    protected $alreadyInClearAllReferencesDeep = false;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $cacsScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $aessScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $tasarsScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $bessScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $fessScheduledForDeletion = null;

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {

        return $this->id;
    }

    /**
     * Get the [mod] column value.
     *
     * @return int
     */
    public function getMod()
    {

        return $this->mod;
    }

    /**
     * Get the [name] column value.
     *
     * @return string
     */
    public function getName()
    {

        return $this->name;
    }

    /**
     * Get the [evt_spec_sel] column value.
     *
     * @return int
     */
    public function getEvtSpecSel()
    {

        return $this->evt_spec_sel;
    }

    /**
     * Get the [evt_spec_val] column value.
     *
     * @return string
     */
    public function getEvtSpecVal()
    {

        return $this->evt_spec_val;
    }

    /**
     * Set the value of [id] column.
     *
     * @param  int $v new value
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[] = AlarmEventDescriptorPeer::ID;
        }


        return $this;
    } // setId()

    /**
     * Set the value of [mod] column.
     *
     * @param  int $v new value
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function setMod($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->mod !== $v) {
            $this->mod = $v;
            $this->modifiedColumns[] = AlarmEventDescriptorPeer::MOD;
        }


        return $this;
    } // setMod()

    /**
     * Set the value of [name] column.
     *
     * @param  string $v new value
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function setName($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->name !== $v) {
            $this->name = $v;
            $this->modifiedColumns[] = AlarmEventDescriptorPeer::NAME;
        }


        return $this;
    } // setName()

    /**
     * Set the value of [evt_spec_sel] column.
     *
     * @param  int $v new value
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function setEvtSpecSel($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->evt_spec_sel !== $v) {
            $this->evt_spec_sel = $v;
            $this->modifiedColumns[] = AlarmEventDescriptorPeer::EVT_SPEC_SEL;
        }


        return $this;
    } // setEvtSpecSel()

    /**
     * Set the value of [evt_spec_val] column.
     *
     * @param  string $v new value
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function setEvtSpecVal($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->evt_spec_val !== $v) {
            $this->evt_spec_val = $v;
            $this->modifiedColumns[] = AlarmEventDescriptorPeer::EVT_SPEC_VAL;
        }


        return $this;
    } // setEvtSpecVal()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
        // otherwise, everything was equal, so return true
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
     * @param int $startcol 0-based offset column which indicates which resultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false)
    {
        try {

            $this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
            $this->mod = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
            $this->name = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
            $this->evt_spec_sel = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
            $this->evt_spec_val = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }
            $this->postHydrate($row, $startcol, $rehydrate);

            return $startcol + 5; // 5 = AlarmEventDescriptorPeer::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException("Error populating AlarmEventDescriptor object", $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {

    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param boolean $deep (optional) Whether to also de-associated any related objects.
     * @param PropelPDO $con (optional) The PropelPDO connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmEventDescriptorPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $stmt = AlarmEventDescriptorPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
        $row = $stmt->fetch(PDO::FETCH_NUM);
        $stmt->closeCursor();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->collCacs = null;

            $this->collAess = null;

            $this->collTasars = null;

            $this->collBess = null;

            $this->collFess = null;

        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param PropelPDO $con
     * @return void
     * @throws PropelException
     * @throws Exception
     * @see        BaseObject::setDeleted()
     * @see        BaseObject::isDeleted()
     */
    public function delete(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmEventDescriptorPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        try {
            $deleteQuery = AlarmEventDescriptorQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $con->commit();
                $this->setDeleted(true);
            } else {
                $con->commit();
            }
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @throws Exception
     * @see        doSave()
     */
    public function save(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmEventDescriptorPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        $isInsert = $this->isNew();
        try {
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                AlarmEventDescriptorPeer::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see        save()
     */
    protected function doSave(PropelPDO $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                } else {
                    $this->doUpdate($con);
                }
                $affectedRows += 1;
                $this->resetModified();
            }

            if ($this->cacsScheduledForDeletion !== null) {
                if (!$this->cacsScheduledForDeletion->isEmpty()) {
                    CurrentAlarmConditionQuery::create()
                        ->filterByPrimaryKeys($this->cacsScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->cacsScheduledForDeletion = null;
                }
            }

            if ($this->collCacs !== null) {
                foreach ($this->collCacs as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->aessScheduledForDeletion !== null) {
                if (!$this->aessScheduledForDeletion->isEmpty()) {
                    AssignmentEventSelectorQuery::create()
                        ->filterByPrimaryKeys($this->aessScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->aessScheduledForDeletion = null;
                }
            }

            if ($this->collAess !== null) {
                foreach ($this->collAess as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->tasarsScheduledForDeletion !== null) {
                if (!$this->tasarsScheduledForDeletion->isEmpty()) {
                    ThresholdAlarmSeverityAssignmentRuleQuery::create()
                        ->filterByPrimaryKeys($this->tasarsScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->tasarsScheduledForDeletion = null;
                }
            }

            if ($this->collTasars !== null) {
                foreach ($this->collTasars as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->bessScheduledForDeletion !== null) {
                if (!$this->bessScheduledForDeletion->isEmpty()) {
                    BalancingEventSelectorQuery::create()
                        ->filterByPrimaryKeys($this->bessScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->bessScheduledForDeletion = null;
                }
            }

            if ($this->collBess !== null) {
                foreach ($this->collBess as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->fessScheduledForDeletion !== null) {
                if (!$this->fessScheduledForDeletion->isEmpty()) {
                    ForwardingEventSelectorQuery::create()
                        ->filterByPrimaryKeys($this->fessScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->fessScheduledForDeletion = null;
                }
            }

            if ($this->collFess !== null) {
                foreach ($this->collFess as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param PropelPDO $con
     *
     * @throws PropelException
     * @see        doSave()
     */
    protected function doInsert(PropelPDO $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[] = AlarmEventDescriptorPeer::ID;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . AlarmEventDescriptorPeer::ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(AlarmEventDescriptorPeer::ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(AlarmEventDescriptorPeer::MOD)) {
            $modifiedColumns[':p' . $index++]  = '`mod`';
        }
        if ($this->isColumnModified(AlarmEventDescriptorPeer::NAME)) {
            $modifiedColumns[':p' . $index++]  = '`name`';
        }
        if ($this->isColumnModified(AlarmEventDescriptorPeer::EVT_SPEC_SEL)) {
            $modifiedColumns[':p' . $index++]  = '`evt_spec_sel`';
        }
        if ($this->isColumnModified(AlarmEventDescriptorPeer::EVT_SPEC_VAL)) {
            $modifiedColumns[':p' . $index++]  = '`evt_spec_val`';
        }

        $sql = sprintf(
            'INSERT INTO `alm_evt_dscr` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`mod`':
                        $stmt->bindValue($identifier, $this->mod, PDO::PARAM_INT);
                        break;
                    case '`name`':
                        $stmt->bindValue($identifier, $this->name, PDO::PARAM_STR);
                        break;
                    case '`evt_spec_sel`':
                        $stmt->bindValue($identifier, $this->evt_spec_sel, PDO::PARAM_INT);
                        break;
                    case '`evt_spec_val`':
                        $stmt->bindValue($identifier, $this->evt_spec_val, PDO::PARAM_STR);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param PropelPDO $con
     *
     * @see        doSave()
     */
    protected function doUpdate(PropelPDO $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();
        BasePeer::doUpdate($selectCriteria, $valuesCriteria, $con);
    }

    /**
     * Array of ValidationFailed objects.
     * @var        array ValidationFailed[]
     */
    protected $validationFailures = array();

    /**
     * Gets any ValidationFailed objects that resulted from last call to validate().
     *
     *
     * @return array ValidationFailed[]
     * @see        validate()
     */
    public function getValidationFailures()
    {
        return $this->validationFailures;
    }

    /**
     * Validates the objects modified field values and all objects related to this table.
     *
     * If $columns is either a column name or an array of column names
     * only those columns are validated.
     *
     * @param mixed $columns Column name or an array of column names.
     * @return boolean Whether all columns pass validation.
     * @see        doValidate()
     * @see        getValidationFailures()
     */
    public function validate($columns = null)
    {
        $res = $this->doValidate($columns);
        if ($res === true) {
            $this->validationFailures = array();

            return true;
        }

        $this->validationFailures = $res;

        return false;
    }

    /**
     * This function performs the validation work for complex object models.
     *
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggregated array of ValidationFailed objects will be returned.
     *
     * @param array $columns Array of column names to validate.
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objects otherwise.
     */
    protected function doValidate($columns = null)
    {
        if (!$this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;

            $failureMap = array();


            if (($retval = AlarmEventDescriptorPeer::doValidate($this, $columns)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }


                if ($this->collCacs !== null) {
                    foreach ($this->collCacs as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }

                if ($this->collAess !== null) {
                    foreach ($this->collAess as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }

                if ($this->collTasars !== null) {
                    foreach ($this->collTasars as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }

                if ($this->collBess !== null) {
                    foreach ($this->collBess as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }

                if ($this->collFess !== null) {
                    foreach ($this->collFess as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }


            $this->alreadyInValidation = false;
        }

        return (!empty($failureMap) ? $failureMap : true);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param string $name name
     * @param string $type The type of fieldname the $name is of:
     *               one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *               BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *               Defaults to BasePeer::TYPE_PHPNAME
     * @return mixed Value of field.
     */
    public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = AlarmEventDescriptorPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getMod();
                break;
            case 2:
                return $this->getName();
                break;
            case 3:
                return $this->getEvtSpecSel();
                break;
            case 4:
                return $this->getEvtSpecVal();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     *                    BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                    Defaults to BasePeer::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to true.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {
        if (isset($alreadyDumpedObjects['AlarmEventDescriptor'][$this->getPrimaryKey()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['AlarmEventDescriptor'][$this->getPrimaryKey()] = true;
        $keys = AlarmEventDescriptorPeer::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getMod(),
            $keys[2] => $this->getName(),
            $keys[3] => $this->getEvtSpecSel(),
            $keys[4] => $this->getEvtSpecVal(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->collCacs) {
                $result['Cacs'] = $this->collCacs->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collAess) {
                $result['Aess'] = $this->collAess->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collTasars) {
                $result['Tasars'] = $this->collTasars->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collBess) {
                $result['Bess'] = $this->collBess->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collFess) {
                $result['Fess'] = $this->collFess->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param string $name peer name
     * @param mixed $value field value
     * @param string $type The type of fieldname the $name is of:
     *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                     Defaults to BasePeer::TYPE_PHPNAME
     * @return void
     */
    public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = AlarmEventDescriptorPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);

        $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @param mixed $value field value
     * @return void
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setMod($value);
                break;
            case 2:
                $this->setName($value);
                break;
            case 3:
                $this->setEvtSpecSel($value);
                break;
            case 4:
                $this->setEvtSpecVal($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     * The default key type is the column's BasePeer::TYPE_PHPNAME
     *
     * @param array  $arr     An array to populate the object from.
     * @param string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
    {
        $keys = AlarmEventDescriptorPeer::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
        if (array_key_exists($keys[1], $arr)) $this->setMod($arr[$keys[1]]);
        if (array_key_exists($keys[2], $arr)) $this->setName($arr[$keys[2]]);
        if (array_key_exists($keys[3], $arr)) $this->setEvtSpecSel($arr[$keys[3]]);
        if (array_key_exists($keys[4], $arr)) $this->setEvtSpecVal($arr[$keys[4]]);
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(AlarmEventDescriptorPeer::DATABASE_NAME);

        if ($this->isColumnModified(AlarmEventDescriptorPeer::ID)) $criteria->add(AlarmEventDescriptorPeer::ID, $this->id);
        if ($this->isColumnModified(AlarmEventDescriptorPeer::MOD)) $criteria->add(AlarmEventDescriptorPeer::MOD, $this->mod);
        if ($this->isColumnModified(AlarmEventDescriptorPeer::NAME)) $criteria->add(AlarmEventDescriptorPeer::NAME, $this->name);
        if ($this->isColumnModified(AlarmEventDescriptorPeer::EVT_SPEC_SEL)) $criteria->add(AlarmEventDescriptorPeer::EVT_SPEC_SEL, $this->evt_spec_sel);
        if ($this->isColumnModified(AlarmEventDescriptorPeer::EVT_SPEC_VAL)) $criteria->add(AlarmEventDescriptorPeer::EVT_SPEC_VAL, $this->evt_spec_val);

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(AlarmEventDescriptorPeer::DATABASE_NAME);
        $criteria->add(AlarmEventDescriptorPeer::ID, $this->id);

        return $criteria;
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param  int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {

        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param object $copyObj An object of AlarmEventDescriptor (or compatible) type.
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setMod($this->getMod());
        $copyObj->setName($this->getName());
        $copyObj->setEvtSpecSel($this->getEvtSpecSel());
        $copyObj->setEvtSpecVal($this->getEvtSpecVal());

        if ($deepCopy && !$this->startCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);
            // store object hash to prevent cycle
            $this->startCopy = true;

            foreach ($this->getCacs() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addCac($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getAess() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addAes($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getTasars() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addTasar($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getBess() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addBes($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getFess() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addFes($relObj->copy($deepCopy));
                }
            }

            //unflag object copy
            $this->startCopy = false;
        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return AlarmEventDescriptor Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Returns a peer instance associated with this om.
     *
     * Since Peer classes are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     *
     * @return AlarmEventDescriptorPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new AlarmEventDescriptorPeer();
        }

        return self::$peer;
    }


    /**
     * Initializes a collection based on the name of a relation.
     * Avoids crafting an 'init[$relationName]s' method name
     * that wouldn't work when StandardEnglishPluralizer is used.
     *
     * @param string $relationName The name of the relation to initialize
     * @return void
     */
    public function initRelation($relationName)
    {
        if ('Cac' == $relationName) {
            $this->initCacs();
        }
        if ('Aes' == $relationName) {
            $this->initAess();
        }
        if ('Tasar' == $relationName) {
            $this->initTasars();
        }
        if ('Bes' == $relationName) {
            $this->initBess();
        }
        if ('Fes' == $relationName) {
            $this->initFess();
        }
    }

    /**
     * Clears out the collCacs collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return AlarmEventDescriptor The current object (for fluent API support)
     * @see        addCacs()
     */
    public function clearCacs()
    {
        $this->collCacs = null; // important to set this to null since that means it is uninitialized
        $this->collCacsPartial = null;

        return $this;
    }

    /**
     * reset is the collCacs collection loaded partially
     *
     * @return void
     */
    public function resetPartialCacs($v = true)
    {
        $this->collCacsPartial = $v;
    }

    /**
     * Initializes the collCacs collection.
     *
     * By default this just sets the collCacs collection to an empty array (like clearcollCacs());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initCacs($overrideExisting = true)
    {
        if (null !== $this->collCacs && !$overrideExisting) {
            return;
        }
        $this->collCacs = new PropelObjectCollection();
        $this->collCacs->setModel('CurrentAlarmCondition');
    }

    /**
     * Gets an array of CurrentAlarmCondition objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this AlarmEventDescriptor is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|CurrentAlarmCondition[] List of CurrentAlarmCondition objects
     * @throws PropelException
     */
    public function getCacs($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collCacsPartial && !$this->isNew();
        if (null === $this->collCacs || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collCacs) {
                // return empty collection
                $this->initCacs();
            } else {
                $collCacs = CurrentAlarmConditionQuery::create(null, $criteria)
                    ->filterByAlarmEventDescriptor($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collCacsPartial && count($collCacs)) {
                      $this->initCacs(false);

                      foreach ($collCacs as $obj) {
                        if (false == $this->collCacs->contains($obj)) {
                          $this->collCacs->append($obj);
                        }
                      }

                      $this->collCacsPartial = true;
                    }

                    $collCacs->getInternalIterator()->rewind();

                    return $collCacs;
                }

                if ($partial && $this->collCacs) {
                    foreach ($this->collCacs as $obj) {
                        if ($obj->isNew()) {
                            $collCacs[] = $obj;
                        }
                    }
                }

                $this->collCacs = $collCacs;
                $this->collCacsPartial = false;
            }
        }

        return $this->collCacs;
    }

    /**
     * Sets a collection of Cac objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $cacs A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function setCacs(PropelCollection $cacs, PropelPDO $con = null)
    {
        $cacsToDelete = $this->getCacs(new Criteria(), $con)->diff($cacs);


        $this->cacsScheduledForDeletion = $cacsToDelete;

        foreach ($cacsToDelete as $cacRemoved) {
            $cacRemoved->setAlarmEventDescriptor(null);
        }

        $this->collCacs = null;
        foreach ($cacs as $cac) {
            $this->addCac($cac);
        }

        $this->collCacs = $cacs;
        $this->collCacsPartial = false;

        return $this;
    }

    /**
     * Returns the number of related CurrentAlarmCondition objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related CurrentAlarmCondition objects.
     * @throws PropelException
     */
    public function countCacs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collCacsPartial && !$this->isNew();
        if (null === $this->collCacs || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collCacs) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getCacs());
            }
            $query = CurrentAlarmConditionQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByAlarmEventDescriptor($this)
                ->count($con);
        }

        return count($this->collCacs);
    }

    /**
     * Method called to associate a CurrentAlarmCondition object to this object
     * through the CurrentAlarmCondition foreign key attribute.
     *
     * @param    CurrentAlarmCondition $l CurrentAlarmCondition
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function addCac(CurrentAlarmCondition $l)
    {
        if ($this->collCacs === null) {
            $this->initCacs();
            $this->collCacsPartial = true;
        }

        if (!in_array($l, $this->collCacs->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddCac($l);

            if ($this->cacsScheduledForDeletion and $this->cacsScheduledForDeletion->contains($l)) {
                $this->cacsScheduledForDeletion->remove($this->cacsScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	Cac $cac The cac object to add.
     */
    protected function doAddCac($cac)
    {
        $this->collCacs[]= $cac;
        $cac->setAlarmEventDescriptor($this);
    }

    /**
     * @param	Cac $cac The cac object to remove.
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function removeCac($cac)
    {
        if ($this->getCacs()->contains($cac)) {
            $this->collCacs->remove($this->collCacs->search($cac));
            if (null === $this->cacsScheduledForDeletion) {
                $this->cacsScheduledForDeletion = clone $this->collCacs;
                $this->cacsScheduledForDeletion->clear();
            }
            $this->cacsScheduledForDeletion[]= clone $cac;
            $cac->setAlarmEventDescriptor(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this AlarmEventDescriptor is new, it will return
     * an empty collection; or if this AlarmEventDescriptor has previously
     * been saved, it will retrieve related Cacs from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in AlarmEventDescriptor.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @param string $join_behavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return PropelObjectCollection|CurrentAlarmCondition[] List of CurrentAlarmCondition objects
     */
    public function getCacsJoinAlarmingManagedObject($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $query = CurrentAlarmConditionQuery::create(null, $criteria);
        $query->joinWith('AlarmingManagedObject', $join_behavior);

        return $this->getCacs($query, $con);
    }

    /**
     * Clears out the collAess collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return AlarmEventDescriptor The current object (for fluent API support)
     * @see        addAess()
     */
    public function clearAess()
    {
        $this->collAess = null; // important to set this to null since that means it is uninitialized
        $this->collAessPartial = null;

        return $this;
    }

    /**
     * reset is the collAess collection loaded partially
     *
     * @return void
     */
    public function resetPartialAess($v = true)
    {
        $this->collAessPartial = $v;
    }

    /**
     * Initializes the collAess collection.
     *
     * By default this just sets the collAess collection to an empty array (like clearcollAess());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initAess($overrideExisting = true)
    {
        if (null !== $this->collAess && !$overrideExisting) {
            return;
        }
        $this->collAess = new PropelObjectCollection();
        $this->collAess->setModel('AssignmentEventSelector');
    }

    /**
     * Gets an array of AssignmentEventSelector objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this AlarmEventDescriptor is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|AssignmentEventSelector[] List of AssignmentEventSelector objects
     * @throws PropelException
     */
    public function getAess($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collAessPartial && !$this->isNew();
        if (null === $this->collAess || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collAess) {
                // return empty collection
                $this->initAess();
            } else {
                $collAess = AssignmentEventSelectorQuery::create(null, $criteria)
                    ->filterByAlarmEventDescriptor($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collAessPartial && count($collAess)) {
                      $this->initAess(false);

                      foreach ($collAess as $obj) {
                        if (false == $this->collAess->contains($obj)) {
                          $this->collAess->append($obj);
                        }
                      }

                      $this->collAessPartial = true;
                    }

                    $collAess->getInternalIterator()->rewind();

                    return $collAess;
                }

                if ($partial && $this->collAess) {
                    foreach ($this->collAess as $obj) {
                        if ($obj->isNew()) {
                            $collAess[] = $obj;
                        }
                    }
                }

                $this->collAess = $collAess;
                $this->collAessPartial = false;
            }
        }

        return $this->collAess;
    }

    /**
     * Sets a collection of Aes objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $aess A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function setAess(PropelCollection $aess, PropelPDO $con = null)
    {
        $aessToDelete = $this->getAess(new Criteria(), $con)->diff($aess);


        $this->aessScheduledForDeletion = $aessToDelete;

        foreach ($aessToDelete as $aesRemoved) {
            $aesRemoved->setAlarmEventDescriptor(null);
        }

        $this->collAess = null;
        foreach ($aess as $aes) {
            $this->addAes($aes);
        }

        $this->collAess = $aess;
        $this->collAessPartial = false;

        return $this;
    }

    /**
     * Returns the number of related AssignmentEventSelector objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related AssignmentEventSelector objects.
     * @throws PropelException
     */
    public function countAess(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collAessPartial && !$this->isNew();
        if (null === $this->collAess || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collAess) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getAess());
            }
            $query = AssignmentEventSelectorQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByAlarmEventDescriptor($this)
                ->count($con);
        }

        return count($this->collAess);
    }

    /**
     * Method called to associate a AssignmentEventSelector object to this object
     * through the AssignmentEventSelector foreign key attribute.
     *
     * @param    AssignmentEventSelector $l AssignmentEventSelector
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function addAes(AssignmentEventSelector $l)
    {
        if ($this->collAess === null) {
            $this->initAess();
            $this->collAessPartial = true;
        }

        if (!in_array($l, $this->collAess->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddAes($l);

            if ($this->aessScheduledForDeletion and $this->aessScheduledForDeletion->contains($l)) {
                $this->aessScheduledForDeletion->remove($this->aessScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	Aes $aes The aes object to add.
     */
    protected function doAddAes($aes)
    {
        $this->collAess[]= $aes;
        $aes->setAlarmEventDescriptor($this);
    }

    /**
     * @param	Aes $aes The aes object to remove.
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function removeAes($aes)
    {
        if ($this->getAess()->contains($aes)) {
            $this->collAess->remove($this->collAess->search($aes));
            if (null === $this->aessScheduledForDeletion) {
                $this->aessScheduledForDeletion = clone $this->collAess;
                $this->aessScheduledForDeletion->clear();
            }
            $this->aessScheduledForDeletion[]= clone $aes;
            $aes->setAlarmEventDescriptor(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this AlarmEventDescriptor is new, it will return
     * an empty collection; or if this AlarmEventDescriptor has previously
     * been saved, it will retrieve related Aess from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in AlarmEventDescriptor.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @param string $join_behavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return PropelObjectCollection|AssignmentEventSelector[] List of AssignmentEventSelector objects
     */
    public function getAessJoinAlarmSeverityAssignmentRule($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $query = AssignmentEventSelectorQuery::create(null, $criteria);
        $query->joinWith('AlarmSeverityAssignmentRule', $join_behavior);

        return $this->getAess($query, $con);
    }

    /**
     * Clears out the collTasars collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return AlarmEventDescriptor The current object (for fluent API support)
     * @see        addTasars()
     */
    public function clearTasars()
    {
        $this->collTasars = null; // important to set this to null since that means it is uninitialized
        $this->collTasarsPartial = null;

        return $this;
    }

    /**
     * reset is the collTasars collection loaded partially
     *
     * @return void
     */
    public function resetPartialTasars($v = true)
    {
        $this->collTasarsPartial = $v;
    }

    /**
     * Initializes the collTasars collection.
     *
     * By default this just sets the collTasars collection to an empty array (like clearcollTasars());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initTasars($overrideExisting = true)
    {
        if (null !== $this->collTasars && !$overrideExisting) {
            return;
        }
        $this->collTasars = new PropelObjectCollection();
        $this->collTasars->setModel('ThresholdAlarmSeverityAssignmentRule');
    }

    /**
     * Gets an array of ThresholdAlarmSeverityAssignmentRule objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this AlarmEventDescriptor is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|ThresholdAlarmSeverityAssignmentRule[] List of ThresholdAlarmSeverityAssignmentRule objects
     * @throws PropelException
     */
    public function getTasars($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collTasarsPartial && !$this->isNew();
        if (null === $this->collTasars || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collTasars) {
                // return empty collection
                $this->initTasars();
            } else {
                $collTasars = ThresholdAlarmSeverityAssignmentRuleQuery::create(null, $criteria)
                    ->filterByAlarmEventDescriptor($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collTasarsPartial && count($collTasars)) {
                      $this->initTasars(false);

                      foreach ($collTasars as $obj) {
                        if (false == $this->collTasars->contains($obj)) {
                          $this->collTasars->append($obj);
                        }
                      }

                      $this->collTasarsPartial = true;
                    }

                    $collTasars->getInternalIterator()->rewind();

                    return $collTasars;
                }

                if ($partial && $this->collTasars) {
                    foreach ($this->collTasars as $obj) {
                        if ($obj->isNew()) {
                            $collTasars[] = $obj;
                        }
                    }
                }

                $this->collTasars = $collTasars;
                $this->collTasarsPartial = false;
            }
        }

        return $this->collTasars;
    }

    /**
     * Sets a collection of Tasar objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $tasars A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function setTasars(PropelCollection $tasars, PropelPDO $con = null)
    {
        $tasarsToDelete = $this->getTasars(new Criteria(), $con)->diff($tasars);


        $this->tasarsScheduledForDeletion = $tasarsToDelete;

        foreach ($tasarsToDelete as $tasarRemoved) {
            $tasarRemoved->setAlarmEventDescriptor(null);
        }

        $this->collTasars = null;
        foreach ($tasars as $tasar) {
            $this->addTasar($tasar);
        }

        $this->collTasars = $tasars;
        $this->collTasarsPartial = false;

        return $this;
    }

    /**
     * Returns the number of related ThresholdAlarmSeverityAssignmentRule objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related ThresholdAlarmSeverityAssignmentRule objects.
     * @throws PropelException
     */
    public function countTasars(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collTasarsPartial && !$this->isNew();
        if (null === $this->collTasars || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collTasars) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getTasars());
            }
            $query = ThresholdAlarmSeverityAssignmentRuleQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByAlarmEventDescriptor($this)
                ->count($con);
        }

        return count($this->collTasars);
    }

    /**
     * Method called to associate a ThresholdAlarmSeverityAssignmentRule object to this object
     * through the ThresholdAlarmSeverityAssignmentRule foreign key attribute.
     *
     * @param    ThresholdAlarmSeverityAssignmentRule $l ThresholdAlarmSeverityAssignmentRule
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function addTasar(ThresholdAlarmSeverityAssignmentRule $l)
    {
        if ($this->collTasars === null) {
            $this->initTasars();
            $this->collTasarsPartial = true;
        }

        if (!in_array($l, $this->collTasars->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddTasar($l);

            if ($this->tasarsScheduledForDeletion and $this->tasarsScheduledForDeletion->contains($l)) {
                $this->tasarsScheduledForDeletion->remove($this->tasarsScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	Tasar $tasar The tasar object to add.
     */
    protected function doAddTasar($tasar)
    {
        $this->collTasars[]= $tasar;
        $tasar->setAlarmEventDescriptor($this);
    }

    /**
     * @param	Tasar $tasar The tasar object to remove.
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function removeTasar($tasar)
    {
        if ($this->getTasars()->contains($tasar)) {
            $this->collTasars->remove($this->collTasars->search($tasar));
            if (null === $this->tasarsScheduledForDeletion) {
                $this->tasarsScheduledForDeletion = clone $this->collTasars;
                $this->tasarsScheduledForDeletion->clear();
            }
            $this->tasarsScheduledForDeletion[]= clone $tasar;
            $tasar->setAlarmEventDescriptor(null);
        }

        return $this;
    }

    /**
     * Clears out the collBess collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return AlarmEventDescriptor The current object (for fluent API support)
     * @see        addBess()
     */
    public function clearBess()
    {
        $this->collBess = null; // important to set this to null since that means it is uninitialized
        $this->collBessPartial = null;

        return $this;
    }

    /**
     * reset is the collBess collection loaded partially
     *
     * @return void
     */
    public function resetPartialBess($v = true)
    {
        $this->collBessPartial = $v;
    }

    /**
     * Initializes the collBess collection.
     *
     * By default this just sets the collBess collection to an empty array (like clearcollBess());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initBess($overrideExisting = true)
    {
        if (null !== $this->collBess && !$overrideExisting) {
            return;
        }
        $this->collBess = new PropelObjectCollection();
        $this->collBess->setModel('BalancingEventSelector');
    }

    /**
     * Gets an array of BalancingEventSelector objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this AlarmEventDescriptor is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|BalancingEventSelector[] List of BalancingEventSelector objects
     * @throws PropelException
     */
    public function getBess($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collBessPartial && !$this->isNew();
        if (null === $this->collBess || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collBess) {
                // return empty collection
                $this->initBess();
            } else {
                $collBess = BalancingEventSelectorQuery::create(null, $criteria)
                    ->filterByAlarmEventDescriptor($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collBessPartial && count($collBess)) {
                      $this->initBess(false);

                      foreach ($collBess as $obj) {
                        if (false == $this->collBess->contains($obj)) {
                          $this->collBess->append($obj);
                        }
                      }

                      $this->collBessPartial = true;
                    }

                    $collBess->getInternalIterator()->rewind();

                    return $collBess;
                }

                if ($partial && $this->collBess) {
                    foreach ($this->collBess as $obj) {
                        if ($obj->isNew()) {
                            $collBess[] = $obj;
                        }
                    }
                }

                $this->collBess = $collBess;
                $this->collBessPartial = false;
            }
        }

        return $this->collBess;
    }

    /**
     * Sets a collection of Bes objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $bess A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function setBess(PropelCollection $bess, PropelPDO $con = null)
    {
        $bessToDelete = $this->getBess(new Criteria(), $con)->diff($bess);


        $this->bessScheduledForDeletion = $bessToDelete;

        foreach ($bessToDelete as $besRemoved) {
            $besRemoved->setAlarmEventDescriptor(null);
        }

        $this->collBess = null;
        foreach ($bess as $bes) {
            $this->addBes($bes);
        }

        $this->collBess = $bess;
        $this->collBessPartial = false;

        return $this;
    }

    /**
     * Returns the number of related BalancingEventSelector objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related BalancingEventSelector objects.
     * @throws PropelException
     */
    public function countBess(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collBessPartial && !$this->isNew();
        if (null === $this->collBess || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collBess) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getBess());
            }
            $query = BalancingEventSelectorQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByAlarmEventDescriptor($this)
                ->count($con);
        }

        return count($this->collBess);
    }

    /**
     * Method called to associate a BalancingEventSelector object to this object
     * through the BalancingEventSelector foreign key attribute.
     *
     * @param    BalancingEventSelector $l BalancingEventSelector
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function addBes(BalancingEventSelector $l)
    {
        if ($this->collBess === null) {
            $this->initBess();
            $this->collBessPartial = true;
        }

        if (!in_array($l, $this->collBess->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddBes($l);

            if ($this->bessScheduledForDeletion and $this->bessScheduledForDeletion->contains($l)) {
                $this->bessScheduledForDeletion->remove($this->bessScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	Bes $bes The bes object to add.
     */
    protected function doAddBes($bes)
    {
        $this->collBess[]= $bes;
        $bes->setAlarmEventDescriptor($this);
    }

    /**
     * @param	Bes $bes The bes object to remove.
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function removeBes($bes)
    {
        if ($this->getBess()->contains($bes)) {
            $this->collBess->remove($this->collBess->search($bes));
            if (null === $this->bessScheduledForDeletion) {
                $this->bessScheduledForDeletion = clone $this->collBess;
                $this->bessScheduledForDeletion->clear();
            }
            $this->bessScheduledForDeletion[]= clone $bes;
            $bes->setAlarmEventDescriptor(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this AlarmEventDescriptor is new, it will return
     * an empty collection; or if this AlarmEventDescriptor has previously
     * been saved, it will retrieve related Bess from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in AlarmEventDescriptor.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @param string $join_behavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return PropelObjectCollection|BalancingEventSelector[] List of BalancingEventSelector objects
     */
    public function getBessJoinAlarmBalanceMonitor($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $query = BalancingEventSelectorQuery::create(null, $criteria);
        $query->joinWith('AlarmBalanceMonitor', $join_behavior);

        return $this->getBess($query, $con);
    }

    /**
     * Clears out the collFess collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return AlarmEventDescriptor The current object (for fluent API support)
     * @see        addFess()
     */
    public function clearFess()
    {
        $this->collFess = null; // important to set this to null since that means it is uninitialized
        $this->collFessPartial = null;

        return $this;
    }

    /**
     * reset is the collFess collection loaded partially
     *
     * @return void
     */
    public function resetPartialFess($v = true)
    {
        $this->collFessPartial = $v;
    }

    /**
     * Initializes the collFess collection.
     *
     * By default this just sets the collFess collection to an empty array (like clearcollFess());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initFess($overrideExisting = true)
    {
        if (null !== $this->collFess && !$overrideExisting) {
            return;
        }
        $this->collFess = new PropelObjectCollection();
        $this->collFess->setModel('ForwardingEventSelector');
    }

    /**
     * Gets an array of ForwardingEventSelector objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this AlarmEventDescriptor is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|ForwardingEventSelector[] List of ForwardingEventSelector objects
     * @throws PropelException
     */
    public function getFess($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collFessPartial && !$this->isNew();
        if (null === $this->collFess || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collFess) {
                // return empty collection
                $this->initFess();
            } else {
                $collFess = ForwardingEventSelectorQuery::create(null, $criteria)
                    ->filterByAlarmEventDescriptor($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collFessPartial && count($collFess)) {
                      $this->initFess(false);

                      foreach ($collFess as $obj) {
                        if (false == $this->collFess->contains($obj)) {
                          $this->collFess->append($obj);
                        }
                      }

                      $this->collFessPartial = true;
                    }

                    $collFess->getInternalIterator()->rewind();

                    return $collFess;
                }

                if ($partial && $this->collFess) {
                    foreach ($this->collFess as $obj) {
                        if ($obj->isNew()) {
                            $collFess[] = $obj;
                        }
                    }
                }

                $this->collFess = $collFess;
                $this->collFessPartial = false;
            }
        }

        return $this->collFess;
    }

    /**
     * Sets a collection of Fes objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $fess A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function setFess(PropelCollection $fess, PropelPDO $con = null)
    {
        $fessToDelete = $this->getFess(new Criteria(), $con)->diff($fess);


        $this->fessScheduledForDeletion = $fessToDelete;

        foreach ($fessToDelete as $fesRemoved) {
            $fesRemoved->setAlarmEventDescriptor(null);
        }

        $this->collFess = null;
        foreach ($fess as $fes) {
            $this->addFes($fes);
        }

        $this->collFess = $fess;
        $this->collFessPartial = false;

        return $this;
    }

    /**
     * Returns the number of related ForwardingEventSelector objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related ForwardingEventSelector objects.
     * @throws PropelException
     */
    public function countFess(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collFessPartial && !$this->isNew();
        if (null === $this->collFess || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collFess) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getFess());
            }
            $query = ForwardingEventSelectorQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByAlarmEventDescriptor($this)
                ->count($con);
        }

        return count($this->collFess);
    }

    /**
     * Method called to associate a ForwardingEventSelector object to this object
     * through the ForwardingEventSelector foreign key attribute.
     *
     * @param    ForwardingEventSelector $l ForwardingEventSelector
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function addFes(ForwardingEventSelector $l)
    {
        if ($this->collFess === null) {
            $this->initFess();
            $this->collFessPartial = true;
        }

        if (!in_array($l, $this->collFess->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddFes($l);

            if ($this->fessScheduledForDeletion and $this->fessScheduledForDeletion->contains($l)) {
                $this->fessScheduledForDeletion->remove($this->fessScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	Fes $fes The fes object to add.
     */
    protected function doAddFes($fes)
    {
        $this->collFess[]= $fes;
        $fes->setAlarmEventDescriptor($this);
    }

    /**
     * @param	Fes $fes The fes object to remove.
     * @return AlarmEventDescriptor The current object (for fluent API support)
     */
    public function removeFes($fes)
    {
        if ($this->getFess()->contains($fes)) {
            $this->collFess->remove($this->collFess->search($fes));
            if (null === $this->fessScheduledForDeletion) {
                $this->fessScheduledForDeletion = clone $this->collFess;
                $this->fessScheduledForDeletion->clear();
            }
            $this->fessScheduledForDeletion[]= clone $fes;
            $fes->setAlarmEventDescriptor(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this AlarmEventDescriptor is new, it will return
     * an empty collection; or if this AlarmEventDescriptor has previously
     * been saved, it will retrieve related Fess from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in AlarmEventDescriptor.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @param string $join_behavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return PropelObjectCollection|ForwardingEventSelector[] List of ForwardingEventSelector objects
     */
    public function getFessJoinAlarmForwardingInstruction($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $query = ForwardingEventSelectorQuery::create(null, $criteria);
        $query->joinWith('AlarmForwardingInstruction', $join_behavior);

        return $this->getFess($query, $con);
    }

    /**
     * Clears the current object and sets all attributes to their default values
     */
    public function clear()
    {
        $this->id = null;
        $this->mod = null;
        $this->name = null;
        $this->evt_spec_sel = null;
        $this->evt_spec_val = null;
        $this->alreadyInSave = false;
        $this->alreadyInValidation = false;
        $this->alreadyInClearAllReferencesDeep = false;
        $this->clearAllReferences();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references to other model objects or collections of model objects.
     *
     * This method is a user-space workaround for PHP's inability to garbage collect
     * objects with circular references (even in PHP 5.3). This is currently necessary
     * when using Propel in certain daemon or large-volume/high-memory operations.
     *
     * @param boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep && !$this->alreadyInClearAllReferencesDeep) {
            $this->alreadyInClearAllReferencesDeep = true;
            if ($this->collCacs) {
                foreach ($this->collCacs as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collAess) {
                foreach ($this->collAess as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collTasars) {
                foreach ($this->collTasars as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collBess) {
                foreach ($this->collBess as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collFess) {
                foreach ($this->collFess as $o) {
                    $o->clearAllReferences($deep);
                }
            }

            $this->alreadyInClearAllReferencesDeep = false;
        } // if ($deep)

        if ($this->collCacs instanceof PropelCollection) {
            $this->collCacs->clearIterator();
        }
        $this->collCacs = null;
        if ($this->collAess instanceof PropelCollection) {
            $this->collAess->clearIterator();
        }
        $this->collAess = null;
        if ($this->collTasars instanceof PropelCollection) {
            $this->collTasars->clearIterator();
        }
        $this->collTasars = null;
        if ($this->collBess instanceof PropelCollection) {
            $this->collBess->clearIterator();
        }
        $this->collBess = null;
        if ($this->collFess instanceof PropelCollection) {
            $this->collFess->clearIterator();
        }
        $this->collFess = null;
    }

    /**
     * return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(AlarmEventDescriptorPeer::DEFAULT_STRING_FORMAT);
    }

    /**
     * return true is the object is in saving state
     *
     * @return boolean
     */
    public function isAlreadyInSave()
    {
        return $this->alreadyInSave;
    }

}
