<?php


/**
 * Base class that represents a query for the 'alm_evt_dscr' table.
 *
 *
 *
 * @method AlarmEventDescriptorQuery orderById($order = Criteria::ASC) Order by the id column
 * @method AlarmEventDescriptorQuery orderByMod($order = Criteria::ASC) Order by the mod column
 * @method AlarmEventDescriptorQuery orderByName($order = Criteria::ASC) Order by the name column
 * @method AlarmEventDescriptorQuery orderByEvtSpecSel($order = Criteria::ASC) Order by the evt_spec_sel column
 * @method AlarmEventDescriptorQuery orderByEvtSpecVal($order = Criteria::ASC) Order by the evt_spec_val column
 *
 * @method AlarmEventDescriptorQuery groupById() Group by the id column
 * @method AlarmEventDescriptorQuery groupByMod() Group by the mod column
 * @method AlarmEventDescriptorQuery groupByName() Group by the name column
 * @method AlarmEventDescriptorQuery groupByEvtSpecSel() Group by the evt_spec_sel column
 * @method AlarmEventDescriptorQuery groupByEvtSpecVal() Group by the evt_spec_val column
 *
 * @method AlarmEventDescriptorQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method AlarmEventDescriptorQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method AlarmEventDescriptorQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method AlarmEventDescriptorQuery leftJoinCac($relationAlias = null) Adds a LEFT JOIN clause to the query using the Cac relation
 * @method AlarmEventDescriptorQuery rightJoinCac($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Cac relation
 * @method AlarmEventDescriptorQuery innerJoinCac($relationAlias = null) Adds a INNER JOIN clause to the query using the Cac relation
 *
 * @method AlarmEventDescriptorQuery leftJoinAes($relationAlias = null) Adds a LEFT JOIN clause to the query using the Aes relation
 * @method AlarmEventDescriptorQuery rightJoinAes($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Aes relation
 * @method AlarmEventDescriptorQuery innerJoinAes($relationAlias = null) Adds a INNER JOIN clause to the query using the Aes relation
 *
 * @method AlarmEventDescriptorQuery leftJoinTasar($relationAlias = null) Adds a LEFT JOIN clause to the query using the Tasar relation
 * @method AlarmEventDescriptorQuery rightJoinTasar($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Tasar relation
 * @method AlarmEventDescriptorQuery innerJoinTasar($relationAlias = null) Adds a INNER JOIN clause to the query using the Tasar relation
 *
 * @method AlarmEventDescriptorQuery leftJoinBes($relationAlias = null) Adds a LEFT JOIN clause to the query using the Bes relation
 * @method AlarmEventDescriptorQuery rightJoinBes($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Bes relation
 * @method AlarmEventDescriptorQuery innerJoinBes($relationAlias = null) Adds a INNER JOIN clause to the query using the Bes relation
 *
 * @method AlarmEventDescriptorQuery leftJoinFes($relationAlias = null) Adds a LEFT JOIN clause to the query using the Fes relation
 * @method AlarmEventDescriptorQuery rightJoinFes($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Fes relation
 * @method AlarmEventDescriptorQuery innerJoinFes($relationAlias = null) Adds a INNER JOIN clause to the query using the Fes relation
 *
 * @method AlarmEventDescriptor findOne(PropelPDO $con = null) Return the first AlarmEventDescriptor matching the query
 * @method AlarmEventDescriptor findOneOrCreate(PropelPDO $con = null) Return the first AlarmEventDescriptor matching the query, or a new AlarmEventDescriptor object populated from the query conditions when no match is found
 *
 * @method AlarmEventDescriptor findOneByMod(int $mod) Return the first AlarmEventDescriptor filtered by the mod column
 * @method AlarmEventDescriptor findOneByName(string $name) Return the first AlarmEventDescriptor filtered by the name column
 * @method AlarmEventDescriptor findOneByEvtSpecSel(int $evt_spec_sel) Return the first AlarmEventDescriptor filtered by the evt_spec_sel column
 * @method AlarmEventDescriptor findOneByEvtSpecVal(string $evt_spec_val) Return the first AlarmEventDescriptor filtered by the evt_spec_val column
 *
 * @method array findById(int $id) Return AlarmEventDescriptor objects filtered by the id column
 * @method array findByMod(int $mod) Return AlarmEventDescriptor objects filtered by the mod column
 * @method array findByName(string $name) Return AlarmEventDescriptor objects filtered by the name column
 * @method array findByEvtSpecSel(int $evt_spec_sel) Return AlarmEventDescriptor objects filtered by the evt_spec_sel column
 * @method array findByEvtSpecVal(string $evt_spec_val) Return AlarmEventDescriptor objects filtered by the evt_spec_val column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAlarmEventDescriptorQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseAlarmEventDescriptorQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'AlarmEventDescriptor';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new AlarmEventDescriptorQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   AlarmEventDescriptorQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return AlarmEventDescriptorQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof AlarmEventDescriptorQuery) {
            return $criteria;
        }
        $query = new AlarmEventDescriptorQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   AlarmEventDescriptor|AlarmEventDescriptor[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = AlarmEventDescriptorPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(AlarmEventDescriptorPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AlarmEventDescriptor A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AlarmEventDescriptor A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `mod`, `name`, `evt_spec_sel`, `evt_spec_val` FROM `alm_evt_dscr` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new AlarmEventDescriptor();
            $obj->hydrate($row);
            AlarmEventDescriptorPeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return AlarmEventDescriptor|AlarmEventDescriptor[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|AlarmEventDescriptor[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(AlarmEventDescriptorPeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(AlarmEventDescriptorPeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(AlarmEventDescriptorPeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(AlarmEventDescriptorPeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmEventDescriptorPeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the mod column
     *
     * Example usage:
     * <code>
     * $query->filterByMod(1234); // WHERE mod = 1234
     * $query->filterByMod(array(12, 34)); // WHERE mod IN (12, 34)
     * $query->filterByMod(array('min' => 12)); // WHERE mod >= 12
     * $query->filterByMod(array('max' => 12)); // WHERE mod <= 12
     * </code>
     *
     * @param     mixed $mod The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function filterByMod($mod = null, $comparison = null)
    {
        if (is_array($mod)) {
            $useMinMax = false;
            if (isset($mod['min'])) {
                $this->addUsingAlias(AlarmEventDescriptorPeer::MOD, $mod['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($mod['max'])) {
                $this->addUsingAlias(AlarmEventDescriptorPeer::MOD, $mod['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmEventDescriptorPeer::MOD, $mod, $comparison);
    }

    /**
     * Filter the query on the name column
     *
     * Example usage:
     * <code>
     * $query->filterByName('fooValue');   // WHERE name = 'fooValue'
     * $query->filterByName('%fooValue%'); // WHERE name LIKE '%fooValue%'
     * </code>
     *
     * @param     string $name The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function filterByName($name = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($name)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $name)) {
                $name = str_replace('*', '%', $name);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AlarmEventDescriptorPeer::NAME, $name, $comparison);
    }

    /**
     * Filter the query on the evt_spec_sel column
     *
     * Example usage:
     * <code>
     * $query->filterByEvtSpecSel(1234); // WHERE evt_spec_sel = 1234
     * $query->filterByEvtSpecSel(array(12, 34)); // WHERE evt_spec_sel IN (12, 34)
     * $query->filterByEvtSpecSel(array('min' => 12)); // WHERE evt_spec_sel >= 12
     * $query->filterByEvtSpecSel(array('max' => 12)); // WHERE evt_spec_sel <= 12
     * </code>
     *
     * @param     mixed $evtSpecSel The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function filterByEvtSpecSel($evtSpecSel = null, $comparison = null)
    {
        if (is_array($evtSpecSel)) {
            $useMinMax = false;
            if (isset($evtSpecSel['min'])) {
                $this->addUsingAlias(AlarmEventDescriptorPeer::EVT_SPEC_SEL, $evtSpecSel['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($evtSpecSel['max'])) {
                $this->addUsingAlias(AlarmEventDescriptorPeer::EVT_SPEC_SEL, $evtSpecSel['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmEventDescriptorPeer::EVT_SPEC_SEL, $evtSpecSel, $comparison);
    }

    /**
     * Filter the query on the evt_spec_val column
     *
     * Example usage:
     * <code>
     * $query->filterByEvtSpecVal('fooValue');   // WHERE evt_spec_val = 'fooValue'
     * $query->filterByEvtSpecVal('%fooValue%'); // WHERE evt_spec_val LIKE '%fooValue%'
     * </code>
     *
     * @param     string $evtSpecVal The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function filterByEvtSpecVal($evtSpecVal = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($evtSpecVal)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $evtSpecVal)) {
                $evtSpecVal = str_replace('*', '%', $evtSpecVal);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AlarmEventDescriptorPeer::EVT_SPEC_VAL, $evtSpecVal, $comparison);
    }

    /**
     * Filter the query by a related CurrentAlarmCondition object
     *
     * @param   CurrentAlarmCondition|PropelObjectCollection $currentAlarmCondition  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmEventDescriptorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByCac($currentAlarmCondition, $comparison = null)
    {
        if ($currentAlarmCondition instanceof CurrentAlarmCondition) {
            return $this
                ->addUsingAlias(AlarmEventDescriptorPeer::ID, $currentAlarmCondition->getAedId(), $comparison);
        } elseif ($currentAlarmCondition instanceof PropelObjectCollection) {
            return $this
                ->useCacQuery()
                ->filterByPrimaryKeys($currentAlarmCondition->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByCac() only accepts arguments of type CurrentAlarmCondition or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Cac relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function joinCac($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Cac');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Cac');
        }

        return $this;
    }

    /**
     * Use the Cac relation CurrentAlarmCondition object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   CurrentAlarmConditionQuery A secondary query class using the current class as primary query
     */
    public function useCacQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinCac($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Cac', 'CurrentAlarmConditionQuery');
    }

    /**
     * Filter the query by a related AssignmentEventSelector object
     *
     * @param   AssignmentEventSelector|PropelObjectCollection $assignmentEventSelector  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmEventDescriptorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAes($assignmentEventSelector, $comparison = null)
    {
        if ($assignmentEventSelector instanceof AssignmentEventSelector) {
            return $this
                ->addUsingAlias(AlarmEventDescriptorPeer::ID, $assignmentEventSelector->getAedId(), $comparison);
        } elseif ($assignmentEventSelector instanceof PropelObjectCollection) {
            return $this
                ->useAesQuery()
                ->filterByPrimaryKeys($assignmentEventSelector->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByAes() only accepts arguments of type AssignmentEventSelector or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Aes relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function joinAes($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Aes');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Aes');
        }

        return $this;
    }

    /**
     * Use the Aes relation AssignmentEventSelector object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AssignmentEventSelectorQuery A secondary query class using the current class as primary query
     */
    public function useAesQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAes($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Aes', 'AssignmentEventSelectorQuery');
    }

    /**
     * Filter the query by a related ThresholdAlarmSeverityAssignmentRule object
     *
     * @param   ThresholdAlarmSeverityAssignmentRule|PropelObjectCollection $thresholdAlarmSeverityAssignmentRule  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmEventDescriptorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByTasar($thresholdAlarmSeverityAssignmentRule, $comparison = null)
    {
        if ($thresholdAlarmSeverityAssignmentRule instanceof ThresholdAlarmSeverityAssignmentRule) {
            return $this
                ->addUsingAlias(AlarmEventDescriptorPeer::ID, $thresholdAlarmSeverityAssignmentRule->getAedId(), $comparison);
        } elseif ($thresholdAlarmSeverityAssignmentRule instanceof PropelObjectCollection) {
            return $this
                ->useTasarQuery()
                ->filterByPrimaryKeys($thresholdAlarmSeverityAssignmentRule->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByTasar() only accepts arguments of type ThresholdAlarmSeverityAssignmentRule or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Tasar relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function joinTasar($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Tasar');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Tasar');
        }

        return $this;
    }

    /**
     * Use the Tasar relation ThresholdAlarmSeverityAssignmentRule object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   ThresholdAlarmSeverityAssignmentRuleQuery A secondary query class using the current class as primary query
     */
    public function useTasarQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinTasar($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Tasar', 'ThresholdAlarmSeverityAssignmentRuleQuery');
    }

    /**
     * Filter the query by a related BalancingEventSelector object
     *
     * @param   BalancingEventSelector|PropelObjectCollection $balancingEventSelector  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmEventDescriptorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByBes($balancingEventSelector, $comparison = null)
    {
        if ($balancingEventSelector instanceof BalancingEventSelector) {
            return $this
                ->addUsingAlias(AlarmEventDescriptorPeer::ID, $balancingEventSelector->getAedId(), $comparison);
        } elseif ($balancingEventSelector instanceof PropelObjectCollection) {
            return $this
                ->useBesQuery()
                ->filterByPrimaryKeys($balancingEventSelector->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByBes() only accepts arguments of type BalancingEventSelector or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Bes relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function joinBes($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Bes');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Bes');
        }

        return $this;
    }

    /**
     * Use the Bes relation BalancingEventSelector object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   BalancingEventSelectorQuery A secondary query class using the current class as primary query
     */
    public function useBesQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinBes($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Bes', 'BalancingEventSelectorQuery');
    }

    /**
     * Filter the query by a related ForwardingEventSelector object
     *
     * @param   ForwardingEventSelector|PropelObjectCollection $forwardingEventSelector  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmEventDescriptorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByFes($forwardingEventSelector, $comparison = null)
    {
        if ($forwardingEventSelector instanceof ForwardingEventSelector) {
            return $this
                ->addUsingAlias(AlarmEventDescriptorPeer::ID, $forwardingEventSelector->getAedId(), $comparison);
        } elseif ($forwardingEventSelector instanceof PropelObjectCollection) {
            return $this
                ->useFesQuery()
                ->filterByPrimaryKeys($forwardingEventSelector->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByFes() only accepts arguments of type ForwardingEventSelector or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Fes relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function joinFes($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Fes');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Fes');
        }

        return $this;
    }

    /**
     * Use the Fes relation ForwardingEventSelector object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   ForwardingEventSelectorQuery A secondary query class using the current class as primary query
     */
    public function useFesQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinFes($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Fes', 'ForwardingEventSelectorQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   AlarmEventDescriptor $alarmEventDescriptor Object to remove from the list of results
     *
     * @return AlarmEventDescriptorQuery The current query, for fluid interface
     */
    public function prune($alarmEventDescriptor = null)
    {
        if ($alarmEventDescriptor) {
            $this->addUsingAlias(AlarmEventDescriptorPeer::ID, $alarmEventDescriptor->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
