<?php


/**
 * Base class that represents a query for the 'alm_forw_inst' table.
 *
 *
 *
 * @method AlarmForwardingInstructionQuery orderById($order = Criteria::ASC) Order by the id column
 * @method AlarmForwardingInstructionQuery orderByMod($order = Criteria::ASC) Order by the mod column
 * @method AlarmForwardingInstructionQuery orderByName($order = Criteria::ASC) Order by the name column
 * @method AlarmForwardingInstructionQuery orderByAdminState($order = Criteria::ASC) Order by the admin_state column
 * @method AlarmForwardingInstructionQuery orderByEvtSelMode($order = Criteria::ASC) Order by the evt_sel_mode column
 * @method AlarmForwardingInstructionQuery orderByForwEvtSel($order = Criteria::ASC) Order by the forw_evt_sel column
 * @method AlarmForwardingInstructionQuery orderByDestHostSel($order = Criteria::ASC) Order by the dest_host_sel column
 *
 * @method AlarmForwardingInstructionQuery groupById() Group by the id column
 * @method AlarmForwardingInstructionQuery groupByMod() Group by the mod column
 * @method AlarmForwardingInstructionQuery groupByName() Group by the name column
 * @method AlarmForwardingInstructionQuery groupByAdminState() Group by the admin_state column
 * @method AlarmForwardingInstructionQuery groupByEvtSelMode() Group by the evt_sel_mode column
 * @method AlarmForwardingInstructionQuery groupByForwEvtSel() Group by the forw_evt_sel column
 * @method AlarmForwardingInstructionQuery groupByDestHostSel() Group by the dest_host_sel column
 *
 * @method AlarmForwardingInstructionQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method AlarmForwardingInstructionQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method AlarmForwardingInstructionQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method AlarmForwardingInstructionQuery leftJoinFes($relationAlias = null) Adds a LEFT JOIN clause to the query using the Fes relation
 * @method AlarmForwardingInstructionQuery rightJoinFes($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Fes relation
 * @method AlarmForwardingInstructionQuery innerJoinFes($relationAlias = null) Adds a INNER JOIN clause to the query using the Fes relation
 *
 * @method AlarmForwardingInstructionQuery leftJoinDhs($relationAlias = null) Adds a LEFT JOIN clause to the query using the Dhs relation
 * @method AlarmForwardingInstructionQuery rightJoinDhs($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Dhs relation
 * @method AlarmForwardingInstructionQuery innerJoinDhs($relationAlias = null) Adds a INNER JOIN clause to the query using the Dhs relation
 *
 * @method AlarmForwardingInstruction findOne(PropelPDO $con = null) Return the first AlarmForwardingInstruction matching the query
 * @method AlarmForwardingInstruction findOneOrCreate(PropelPDO $con = null) Return the first AlarmForwardingInstruction matching the query, or a new AlarmForwardingInstruction object populated from the query conditions when no match is found
 *
 * @method AlarmForwardingInstruction findOneByMod(int $mod) Return the first AlarmForwardingInstruction filtered by the mod column
 * @method AlarmForwardingInstruction findOneByName(string $name) Return the first AlarmForwardingInstruction filtered by the name column
 * @method AlarmForwardingInstruction findOneByAdminState(int $admin_state) Return the first AlarmForwardingInstruction filtered by the admin_state column
 * @method AlarmForwardingInstruction findOneByEvtSelMode(int $evt_sel_mode) Return the first AlarmForwardingInstruction filtered by the evt_sel_mode column
 * @method AlarmForwardingInstruction findOneByForwEvtSel(int $forw_evt_sel) Return the first AlarmForwardingInstruction filtered by the forw_evt_sel column
 * @method AlarmForwardingInstruction findOneByDestHostSel(int $dest_host_sel) Return the first AlarmForwardingInstruction filtered by the dest_host_sel column
 *
 * @method array findById(int $id) Return AlarmForwardingInstruction objects filtered by the id column
 * @method array findByMod(int $mod) Return AlarmForwardingInstruction objects filtered by the mod column
 * @method array findByName(string $name) Return AlarmForwardingInstruction objects filtered by the name column
 * @method array findByAdminState(int $admin_state) Return AlarmForwardingInstruction objects filtered by the admin_state column
 * @method array findByEvtSelMode(int $evt_sel_mode) Return AlarmForwardingInstruction objects filtered by the evt_sel_mode column
 * @method array findByForwEvtSel(int $forw_evt_sel) Return AlarmForwardingInstruction objects filtered by the forw_evt_sel column
 * @method array findByDestHostSel(int $dest_host_sel) Return AlarmForwardingInstruction objects filtered by the dest_host_sel column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAlarmForwardingInstructionQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseAlarmForwardingInstructionQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'AlarmForwardingInstruction';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new AlarmForwardingInstructionQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   AlarmForwardingInstructionQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return AlarmForwardingInstructionQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof AlarmForwardingInstructionQuery) {
            return $criteria;
        }
        $query = new AlarmForwardingInstructionQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   AlarmForwardingInstruction|AlarmForwardingInstruction[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = AlarmForwardingInstructionPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(AlarmForwardingInstructionPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AlarmForwardingInstruction A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AlarmForwardingInstruction A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `mod`, `name`, `admin_state`, `evt_sel_mode`, `forw_evt_sel`, `dest_host_sel` FROM `alm_forw_inst` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new AlarmForwardingInstruction();
            $obj->hydrate($row);
            AlarmForwardingInstructionPeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return AlarmForwardingInstruction|AlarmForwardingInstruction[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|AlarmForwardingInstruction[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(AlarmForwardingInstructionPeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(AlarmForwardingInstructionPeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmForwardingInstructionPeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the mod column
     *
     * Example usage:
     * <code>
     * $query->filterByMod(1234); // WHERE mod = 1234
     * $query->filterByMod(array(12, 34)); // WHERE mod IN (12, 34)
     * $query->filterByMod(array('min' => 12)); // WHERE mod >= 12
     * $query->filterByMod(array('max' => 12)); // WHERE mod <= 12
     * </code>
     *
     * @param     mixed $mod The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function filterByMod($mod = null, $comparison = null)
    {
        if (is_array($mod)) {
            $useMinMax = false;
            if (isset($mod['min'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::MOD, $mod['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($mod['max'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::MOD, $mod['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmForwardingInstructionPeer::MOD, $mod, $comparison);
    }

    /**
     * Filter the query on the name column
     *
     * Example usage:
     * <code>
     * $query->filterByName('fooValue');   // WHERE name = 'fooValue'
     * $query->filterByName('%fooValue%'); // WHERE name LIKE '%fooValue%'
     * </code>
     *
     * @param     string $name The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function filterByName($name = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($name)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $name)) {
                $name = str_replace('*', '%', $name);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AlarmForwardingInstructionPeer::NAME, $name, $comparison);
    }

    /**
     * Filter the query on the admin_state column
     *
     * Example usage:
     * <code>
     * $query->filterByAdminState(1234); // WHERE admin_state = 1234
     * $query->filterByAdminState(array(12, 34)); // WHERE admin_state IN (12, 34)
     * $query->filterByAdminState(array('min' => 12)); // WHERE admin_state >= 12
     * $query->filterByAdminState(array('max' => 12)); // WHERE admin_state <= 12
     * </code>
     *
     * @param     mixed $adminState The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function filterByAdminState($adminState = null, $comparison = null)
    {
        if (is_array($adminState)) {
            $useMinMax = false;
            if (isset($adminState['min'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::ADMIN_STATE, $adminState['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($adminState['max'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::ADMIN_STATE, $adminState['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmForwardingInstructionPeer::ADMIN_STATE, $adminState, $comparison);
    }

    /**
     * Filter the query on the evt_sel_mode column
     *
     * Example usage:
     * <code>
     * $query->filterByEvtSelMode(1234); // WHERE evt_sel_mode = 1234
     * $query->filterByEvtSelMode(array(12, 34)); // WHERE evt_sel_mode IN (12, 34)
     * $query->filterByEvtSelMode(array('min' => 12)); // WHERE evt_sel_mode >= 12
     * $query->filterByEvtSelMode(array('max' => 12)); // WHERE evt_sel_mode <= 12
     * </code>
     *
     * @param     mixed $evtSelMode The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function filterByEvtSelMode($evtSelMode = null, $comparison = null)
    {
        if (is_array($evtSelMode)) {
            $useMinMax = false;
            if (isset($evtSelMode['min'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::EVT_SEL_MODE, $evtSelMode['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($evtSelMode['max'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::EVT_SEL_MODE, $evtSelMode['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmForwardingInstructionPeer::EVT_SEL_MODE, $evtSelMode, $comparison);
    }

    /**
     * Filter the query on the forw_evt_sel column
     *
     * Example usage:
     * <code>
     * $query->filterByForwEvtSel(1234); // WHERE forw_evt_sel = 1234
     * $query->filterByForwEvtSel(array(12, 34)); // WHERE forw_evt_sel IN (12, 34)
     * $query->filterByForwEvtSel(array('min' => 12)); // WHERE forw_evt_sel >= 12
     * $query->filterByForwEvtSel(array('max' => 12)); // WHERE forw_evt_sel <= 12
     * </code>
     *
     * @param     mixed $forwEvtSel The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function filterByForwEvtSel($forwEvtSel = null, $comparison = null)
    {
        if (is_array($forwEvtSel)) {
            $useMinMax = false;
            if (isset($forwEvtSel['min'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::FORW_EVT_SEL, $forwEvtSel['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($forwEvtSel['max'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::FORW_EVT_SEL, $forwEvtSel['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmForwardingInstructionPeer::FORW_EVT_SEL, $forwEvtSel, $comparison);
    }

    /**
     * Filter the query on the dest_host_sel column
     *
     * Example usage:
     * <code>
     * $query->filterByDestHostSel(1234); // WHERE dest_host_sel = 1234
     * $query->filterByDestHostSel(array(12, 34)); // WHERE dest_host_sel IN (12, 34)
     * $query->filterByDestHostSel(array('min' => 12)); // WHERE dest_host_sel >= 12
     * $query->filterByDestHostSel(array('max' => 12)); // WHERE dest_host_sel <= 12
     * </code>
     *
     * @param     mixed $destHostSel The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function filterByDestHostSel($destHostSel = null, $comparison = null)
    {
        if (is_array($destHostSel)) {
            $useMinMax = false;
            if (isset($destHostSel['min'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::DEST_HOST_SEL, $destHostSel['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($destHostSel['max'])) {
                $this->addUsingAlias(AlarmForwardingInstructionPeer::DEST_HOST_SEL, $destHostSel['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmForwardingInstructionPeer::DEST_HOST_SEL, $destHostSel, $comparison);
    }

    /**
     * Filter the query by a related ForwardingEventSelector object
     *
     * @param   ForwardingEventSelector|PropelObjectCollection $forwardingEventSelector  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmForwardingInstructionQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByFes($forwardingEventSelector, $comparison = null)
    {
        if ($forwardingEventSelector instanceof ForwardingEventSelector) {
            return $this
                ->addUsingAlias(AlarmForwardingInstructionPeer::ID, $forwardingEventSelector->getAfiId(), $comparison);
        } elseif ($forwardingEventSelector instanceof PropelObjectCollection) {
            return $this
                ->useFesQuery()
                ->filterByPrimaryKeys($forwardingEventSelector->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByFes() only accepts arguments of type ForwardingEventSelector or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Fes relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function joinFes($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Fes');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Fes');
        }

        return $this;
    }

    /**
     * Use the Fes relation ForwardingEventSelector object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   ForwardingEventSelectorQuery A secondary query class using the current class as primary query
     */
    public function useFesQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinFes($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Fes', 'ForwardingEventSelectorQuery');
    }

    /**
     * Filter the query by a related DestinationHostSelector object
     *
     * @param   DestinationHostSelector|PropelObjectCollection $destinationHostSelector  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmForwardingInstructionQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByDhs($destinationHostSelector, $comparison = null)
    {
        if ($destinationHostSelector instanceof DestinationHostSelector) {
            return $this
                ->addUsingAlias(AlarmForwardingInstructionPeer::ID, $destinationHostSelector->getAfiId(), $comparison);
        } elseif ($destinationHostSelector instanceof PropelObjectCollection) {
            return $this
                ->useDhsQuery()
                ->filterByPrimaryKeys($destinationHostSelector->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByDhs() only accepts arguments of type DestinationHostSelector or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Dhs relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function joinDhs($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Dhs');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Dhs');
        }

        return $this;
    }

    /**
     * Use the Dhs relation DestinationHostSelector object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   DestinationHostSelectorQuery A secondary query class using the current class as primary query
     */
    public function useDhsQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinDhs($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Dhs', 'DestinationHostSelectorQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   AlarmForwardingInstruction $alarmForwardingInstruction Object to remove from the list of results
     *
     * @return AlarmForwardingInstructionQuery The current query, for fluid interface
     */
    public function prune($alarmForwardingInstruction = null)
    {
        if ($alarmForwardingInstruction) {
            $this->addUsingAlias(AlarmForwardingInstructionPeer::ID, $alarmForwardingInstruction->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
