<?php


/**
 * Base class that represents a query for the 'alm_prof_entry' table.
 *
 * 
 *
 * @method     AlarmProfileEntryQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     AlarmProfileEntryQuery orderByServiceAffect($order = Criteria::ASC) Order by the service_affect column
 * @method     AlarmProfileEntryQuery orderBySeverity($order = Criteria::ASC) Order by the severity column
 *
 * @method     AlarmProfileEntryQuery groupById() Group by the id column
 * @method     AlarmProfileEntryQuery groupByServiceAffect() Group by the service_affect column
 * @method     AlarmProfileEntryQuery groupBySeverity() Group by the severity column
 *
 * @method     AlarmProfileEntryQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     AlarmProfileEntryQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     AlarmProfileEntryQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     AlarmProfileEntry findOne(PropelPDO $con = null) Return the first AlarmProfileEntry matching the query
 * @method     AlarmProfileEntry findOneOrCreate(PropelPDO $con = null) Return the first AlarmProfileEntry matching the query, or a new AlarmProfileEntry object populated from the query conditions when no match is found
 *
 * @method     AlarmProfileEntry findOneById(int $id) Return the first AlarmProfileEntry filtered by the id column
 * @method     AlarmProfileEntry findOneByServiceAffect(string $service_affect) Return the first AlarmProfileEntry filtered by the service_affect column
 * @method     AlarmProfileEntry findOneBySeverity(string $severity) Return the first AlarmProfileEntry filtered by the severity column
 *
 * @method     array findById(int $id) Return AlarmProfileEntry objects filtered by the id column
 * @method     array findByServiceAffect(string $service_affect) Return AlarmProfileEntry objects filtered by the service_affect column
 * @method     array findBySeverity(string $severity) Return AlarmProfileEntry objects filtered by the severity column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAlarmProfileEntryQuery extends ModelCriteria
{

	/**
	 * Initializes internal state of BaseAlarmProfileEntryQuery object.
	 *
	 * @param     string $dbName The dabase name
	 * @param     string $modelName The phpName of a model, e.g. 'Book'
	 * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
	 */
	public function __construct($dbName = 'alarm_balance', $modelName = 'AlarmProfileEntry', $modelAlias = null)
	{
		parent::__construct($dbName, $modelName, $modelAlias);
	}

	/**
	 * Returns a new AlarmProfileEntryQuery object.
	 *
	 * @param     string $modelAlias The alias of a model in the query
	 * @param     Criteria $criteria Optional Criteria to build the query from
	 *
	 * @return    AlarmProfileEntryQuery
	 */
	public static function create($modelAlias = null, $criteria = null)
	{
		if ($criteria instanceof AlarmProfileEntryQuery) {
			return $criteria;
		}
		$query = new AlarmProfileEntryQuery();
		if (null !== $modelAlias) {
			$query->setModelAlias($modelAlias);
		}
		if ($criteria instanceof Criteria) {
			$query->mergeWith($criteria);
		}
		return $query;
	}

	/**
	 * Find object by primary key
	 * Use instance pooling to avoid a database query if the object exists
	 * <code>
	 * $obj  = $c->findPk(12, $con);
	 * </code>
	 * @param     mixed $key Primary key to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    AlarmProfileEntry|array|mixed the result, formatted by the current formatter
	 */
	public function findPk($key, $con = null)
	{
		if ((null !== ($obj = AlarmProfileEntryPeer::getInstanceFromPool((string) $key))) && $this->getFormatter()->isObjectFormatter()) {
			// the object is alredy in the instance pool
			return $obj;
		} else {
			// the object has not been requested yet, or the formatter is not an object formatter
			$criteria = $this->isKeepQuery() ? clone $this : $this;
			$stmt = $criteria
				->filterByPrimaryKey($key)
				->getSelectStatement($con);
			return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
		}
	}

	/**
	 * Find objects by primary key
	 * <code>
	 * $objs = $c->findPks(array(12, 56, 832), $con);
	 * </code>
	 * @param     array $keys Primary keys to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    PropelObjectCollection|array|mixed the list of results, formatted by the current formatter
	 */
	public function findPks($keys, $con = null)
	{	
		$criteria = $this->isKeepQuery() ? clone $this : $this;
		return $this
			->filterByPrimaryKeys($keys)
			->find($con);
	}

	/**
	 * Filter the query by primary key
	 *
	 * @param     mixed $key Primary key to use for the query
	 *
	 * @return    AlarmProfileEntryQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKey($key)
	{
		return $this->addUsingAlias(AlarmProfileEntryPeer::ID, $key, Criteria::EQUAL);
	}

	/**
	 * Filter the query by a list of primary keys
	 *
	 * @param     array $keys The list of primary key to use for the query
	 *
	 * @return    AlarmProfileEntryQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKeys($keys)
	{
		return $this->addUsingAlias(AlarmProfileEntryPeer::ID, $keys, Criteria::IN);
	}

	/**
	 * Filter the query on the id column
	 * 
	 * @param     int|array $id The value to use as filter.
	 *            Accepts an associative array('min' => $minValue, 'max' => $maxValue)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AlarmProfileEntryQuery The current query, for fluid interface
	 */
	public function filterById($id = null, $comparison = null)
	{
		if (is_array($id) && null === $comparison) {
			$comparison = Criteria::IN;
		}
		return $this->addUsingAlias(AlarmProfileEntryPeer::ID, $id, $comparison);
	}

	/**
	 * Filter the query on the service_affect column
	 * 
	 * @param     string $serviceAffect The value to use as filter.
	 *            Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AlarmProfileEntryQuery The current query, for fluid interface
	 */
	public function filterByServiceAffect($serviceAffect = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($serviceAffect)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $serviceAffect)) {
				$serviceAffect = str_replace('*', '%', $serviceAffect);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(AlarmProfileEntryPeer::SERVICE_AFFECT, $serviceAffect, $comparison);
	}

	/**
	 * Filter the query on the severity column
	 * 
	 * @param     string $severity The value to use as filter.
	 *            Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AlarmProfileEntryQuery The current query, for fluid interface
	 */
	public function filterBySeverity($severity = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($severity)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $severity)) {
				$severity = str_replace('*', '%', $severity);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(AlarmProfileEntryPeer::SEVERITY, $severity, $comparison);
	}

	/**
	 * Exclude object from result
	 *
	 * @param     AlarmProfileEntry $alarmProfileEntry Object to remove from the list of results
	 *
	 * @return    AlarmProfileEntryQuery The current query, for fluid interface
	 */
	public function prune($alarmProfileEntry = null)
	{
		if ($alarmProfileEntry) {
			$this->addUsingAlias(AlarmProfileEntryPeer::ID, $alarmProfileEntry->getId(), Criteria::NOT_EQUAL);
	  }
	  
		return $this;
	}

} // BaseAlarmProfileEntryQuery
