<?php


/**
 * Base class that represents a query for the 'alm_prof' table.
 *
 * 
 *
 * @method     AlarmProfileQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     AlarmProfileQuery orderByName($order = Criteria::ASC) Order by the name column
 *
 * @method     AlarmProfileQuery groupById() Group by the id column
 * @method     AlarmProfileQuery groupByName() Group by the name column
 *
 * @method     AlarmProfileQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     AlarmProfileQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     AlarmProfileQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     AlarmProfile findOne(PropelPDO $con = null) Return the first AlarmProfile matching the query
 * @method     AlarmProfile findOneOrCreate(PropelPDO $con = null) Return the first AlarmProfile matching the query, or a new AlarmProfile object populated from the query conditions when no match is found
 *
 * @method     AlarmProfile findOneById(int $id) Return the first AlarmProfile filtered by the id column
 * @method     AlarmProfile findOneByName(string $name) Return the first AlarmProfile filtered by the name column
 *
 * @method     array findById(int $id) Return AlarmProfile objects filtered by the id column
 * @method     array findByName(string $name) Return AlarmProfile objects filtered by the name column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAlarmProfileQuery extends ModelCriteria
{

	/**
	 * Initializes internal state of BaseAlarmProfileQuery object.
	 *
	 * @param     string $dbName The dabase name
	 * @param     string $modelName The phpName of a model, e.g. 'Book'
	 * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
	 */
	public function __construct($dbName = 'alarm_balance', $modelName = 'AlarmProfile', $modelAlias = null)
	{
		parent::__construct($dbName, $modelName, $modelAlias);
	}

	/**
	 * Returns a new AlarmProfileQuery object.
	 *
	 * @param     string $modelAlias The alias of a model in the query
	 * @param     Criteria $criteria Optional Criteria to build the query from
	 *
	 * @return    AlarmProfileQuery
	 */
	public static function create($modelAlias = null, $criteria = null)
	{
		if ($criteria instanceof AlarmProfileQuery) {
			return $criteria;
		}
		$query = new AlarmProfileQuery();
		if (null !== $modelAlias) {
			$query->setModelAlias($modelAlias);
		}
		if ($criteria instanceof Criteria) {
			$query->mergeWith($criteria);
		}
		return $query;
	}

	/**
	 * Find object by primary key
	 * Use instance pooling to avoid a database query if the object exists
	 * <code>
	 * $obj  = $c->findPk(12, $con);
	 * </code>
	 * @param     mixed $key Primary key to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    AlarmProfile|array|mixed the result, formatted by the current formatter
	 */
	public function findPk($key, $con = null)
	{
		if ((null !== ($obj = AlarmProfilePeer::getInstanceFromPool((string) $key))) && $this->getFormatter()->isObjectFormatter()) {
			// the object is alredy in the instance pool
			return $obj;
		} else {
			// the object has not been requested yet, or the formatter is not an object formatter
			$criteria = $this->isKeepQuery() ? clone $this : $this;
			$stmt = $criteria
				->filterByPrimaryKey($key)
				->getSelectStatement($con);
			return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
		}
	}

	/**
	 * Find objects by primary key
	 * <code>
	 * $objs = $c->findPks(array(12, 56, 832), $con);
	 * </code>
	 * @param     array $keys Primary keys to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    PropelObjectCollection|array|mixed the list of results, formatted by the current formatter
	 */
	public function findPks($keys, $con = null)
	{	
		$criteria = $this->isKeepQuery() ? clone $this : $this;
		return $this
			->filterByPrimaryKeys($keys)
			->find($con);
	}

	/**
	 * Filter the query by primary key
	 *
	 * @param     mixed $key Primary key to use for the query
	 *
	 * @return    AlarmProfileQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKey($key)
	{
		return $this->addUsingAlias(AlarmProfilePeer::ID, $key, Criteria::EQUAL);
	}

	/**
	 * Filter the query by a list of primary keys
	 *
	 * @param     array $keys The list of primary key to use for the query
	 *
	 * @return    AlarmProfileQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKeys($keys)
	{
		return $this->addUsingAlias(AlarmProfilePeer::ID, $keys, Criteria::IN);
	}

	/**
	 * Filter the query on the id column
	 * 
	 * @param     int|array $id The value to use as filter.
	 *            Accepts an associative array('min' => $minValue, 'max' => $maxValue)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AlarmProfileQuery The current query, for fluid interface
	 */
	public function filterById($id = null, $comparison = null)
	{
		if (is_array($id) && null === $comparison) {
			$comparison = Criteria::IN;
		}
		return $this->addUsingAlias(AlarmProfilePeer::ID, $id, $comparison);
	}

	/**
	 * Filter the query on the name column
	 * 
	 * @param     string $name The value to use as filter.
	 *            Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AlarmProfileQuery The current query, for fluid interface
	 */
	public function filterByName($name = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($name)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $name)) {
				$name = str_replace('*', '%', $name);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(AlarmProfilePeer::NAME, $name, $comparison);
	}

	/**
	 * Exclude object from result
	 *
	 * @param     AlarmProfile $alarmProfile Object to remove from the list of results
	 *
	 * @return    AlarmProfileQuery The current query, for fluid interface
	 */
	public function prune($alarmProfile = null)
	{
		if ($alarmProfile) {
			$this->addUsingAlias(AlarmProfilePeer::ID, $alarmProfile->getId(), Criteria::NOT_EQUAL);
	  }
	  
		return $this;
	}

} // BaseAlarmProfileQuery
