<?php


/**
 * Base class that represents a row from the 'asev_asgt_rule' table.
 *
 *
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAlarmSeverityAssignmentRule extends BaseObject implements Persistent
{
    /**
     * Peer class name
     */
    const PEER = 'AlarmSeverityAssignmentRulePeer';

    /**
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var        AlarmSeverityAssignmentRulePeer
     */
    protected static $peer;

    /**
     * The flag var to prevent infinite loop in deep copy
     * @var       boolean
     */
    protected $startCopy = false;

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the mod field.
     * @var        int
     */
    protected $mod;

    /**
     * The value for the name field.
     * @var        string
     */
    protected $name;

    /**
     * The value for the precedence field.
     * @var        int
     */
    protected $precedence;

    /**
     * The value for the sev_serv_indep field.
     * @var        int
     */
    protected $sev_serv_indep;

    /**
     * The value for the sev_serv_unaff field.
     * @var        int
     */
    protected $sev_serv_unaff;

    /**
     * The value for the sev_serv_aff field.
     * @var        int
     */
    protected $sev_serv_aff;

    /**
     * The value for the evt_sel_mode field.
     * @var        int
     */
    protected $evt_sel_mode;

    /**
     * The value for the asgt_evt_sel field.
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $asgt_evt_sel;

    /**
     * @var        PropelObjectCollection|AssignmentEventSelector[] Collection to store aggregation of AssignmentEventSelector objects.
     */
    protected $collAess;
    protected $collAessPartial;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInSave = false;

    /**
     * Flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInValidation = false;

    /**
     * Flag to prevent endless clearAllReferences($deep=true) loop, if this object is referenced
     * @var        boolean
     */
    protected $alreadyInClearAllReferencesDeep = false;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $aessScheduledForDeletion = null;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see        __construct()
     */
    public function applyDefaultValues()
    {
        $this->asgt_evt_sel = 0;
    }

    /**
     * Initializes internal state of BaseAlarmSeverityAssignmentRule object.
     * @see        applyDefaults()
     */
    public function __construct()
    {
        parent::__construct();
        $this->applyDefaultValues();
    }

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {

        return $this->id;
    }

    /**
     * Get the [mod] column value.
     *
     * @return int
     */
    public function getMod()
    {

        return $this->mod;
    }

    /**
     * Get the [name] column value.
     *
     * @return string
     */
    public function getName()
    {

        return $this->name;
    }

    /**
     * Get the [precedence] column value.
     *
     * @return int
     */
    public function getPrecedence()
    {

        return $this->precedence;
    }

    /**
     * Get the [sev_serv_indep] column value.
     *
     * @return int
     */
    public function getSevServIndep()
    {

        return $this->sev_serv_indep;
    }

    /**
     * Get the [sev_serv_unaff] column value.
     *
     * @return int
     */
    public function getSevServUnaff()
    {

        return $this->sev_serv_unaff;
    }

    /**
     * Get the [sev_serv_aff] column value.
     *
     * @return int
     */
    public function getSevServAff()
    {

        return $this->sev_serv_aff;
    }

    /**
     * Get the [evt_sel_mode] column value.
     *
     * @return int
     */
    public function getEvtSelMode()
    {

        return $this->evt_sel_mode;
    }

    /**
     * Get the [asgt_evt_sel] column value.
     *
     * @return int
     */
    public function getAsgtEvtSel()
    {

        return $this->asgt_evt_sel;
    }

    /**
     * Set the value of [id] column.
     *
     * @param  int $v new value
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[] = AlarmSeverityAssignmentRulePeer::ID;
        }


        return $this;
    } // setId()

    /**
     * Set the value of [mod] column.
     *
     * @param  int $v new value
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function setMod($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->mod !== $v) {
            $this->mod = $v;
            $this->modifiedColumns[] = AlarmSeverityAssignmentRulePeer::MOD;
        }


        return $this;
    } // setMod()

    /**
     * Set the value of [name] column.
     *
     * @param  string $v new value
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function setName($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->name !== $v) {
            $this->name = $v;
            $this->modifiedColumns[] = AlarmSeverityAssignmentRulePeer::NAME;
        }


        return $this;
    } // setName()

    /**
     * Set the value of [precedence] column.
     *
     * @param  int $v new value
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function setPrecedence($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->precedence !== $v) {
            $this->precedence = $v;
            $this->modifiedColumns[] = AlarmSeverityAssignmentRulePeer::PRECEDENCE;
        }


        return $this;
    } // setPrecedence()

    /**
     * Set the value of [sev_serv_indep] column.
     *
     * @param  int $v new value
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function setSevServIndep($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->sev_serv_indep !== $v) {
            $this->sev_serv_indep = $v;
            $this->modifiedColumns[] = AlarmSeverityAssignmentRulePeer::SEV_SERV_INDEP;
        }


        return $this;
    } // setSevServIndep()

    /**
     * Set the value of [sev_serv_unaff] column.
     *
     * @param  int $v new value
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function setSevServUnaff($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->sev_serv_unaff !== $v) {
            $this->sev_serv_unaff = $v;
            $this->modifiedColumns[] = AlarmSeverityAssignmentRulePeer::SEV_SERV_UNAFF;
        }


        return $this;
    } // setSevServUnaff()

    /**
     * Set the value of [sev_serv_aff] column.
     *
     * @param  int $v new value
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function setSevServAff($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->sev_serv_aff !== $v) {
            $this->sev_serv_aff = $v;
            $this->modifiedColumns[] = AlarmSeverityAssignmentRulePeer::SEV_SERV_AFF;
        }


        return $this;
    } // setSevServAff()

    /**
     * Set the value of [evt_sel_mode] column.
     *
     * @param  int $v new value
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function setEvtSelMode($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->evt_sel_mode !== $v) {
            $this->evt_sel_mode = $v;
            $this->modifiedColumns[] = AlarmSeverityAssignmentRulePeer::EVT_SEL_MODE;
        }


        return $this;
    } // setEvtSelMode()

    /**
     * Set the value of [asgt_evt_sel] column.
     *
     * @param  int $v new value
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function setAsgtEvtSel($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->asgt_evt_sel !== $v) {
            $this->asgt_evt_sel = $v;
            $this->modifiedColumns[] = AlarmSeverityAssignmentRulePeer::ASGT_EVT_SEL;
        }


        return $this;
    } // setAsgtEvtSel()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
            if ($this->asgt_evt_sel !== 0) {
                return false;
            }

        // otherwise, everything was equal, so return true
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
     * @param int $startcol 0-based offset column which indicates which resultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false)
    {
        try {

            $this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
            $this->mod = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
            $this->name = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
            $this->precedence = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
            $this->sev_serv_indep = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
            $this->sev_serv_unaff = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
            $this->sev_serv_aff = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
            $this->evt_sel_mode = ($row[$startcol + 7] !== null) ? (int) $row[$startcol + 7] : null;
            $this->asgt_evt_sel = ($row[$startcol + 8] !== null) ? (int) $row[$startcol + 8] : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }
            $this->postHydrate($row, $startcol, $rehydrate);

            return $startcol + 9; // 9 = AlarmSeverityAssignmentRulePeer::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException("Error populating AlarmSeverityAssignmentRule object", $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {

    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param boolean $deep (optional) Whether to also de-associated any related objects.
     * @param PropelPDO $con (optional) The PropelPDO connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmSeverityAssignmentRulePeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $stmt = AlarmSeverityAssignmentRulePeer::doSelectStmt($this->buildPkeyCriteria(), $con);
        $row = $stmt->fetch(PDO::FETCH_NUM);
        $stmt->closeCursor();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->collAess = null;

        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param PropelPDO $con
     * @return void
     * @throws PropelException
     * @throws Exception
     * @see        BaseObject::setDeleted()
     * @see        BaseObject::isDeleted()
     */
    public function delete(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmSeverityAssignmentRulePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        try {
            $deleteQuery = AlarmSeverityAssignmentRuleQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $con->commit();
                $this->setDeleted(true);
            } else {
                $con->commit();
            }
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @throws Exception
     * @see        doSave()
     */
    public function save(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmSeverityAssignmentRulePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        $isInsert = $this->isNew();
        try {
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                AlarmSeverityAssignmentRulePeer::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see        save()
     */
    protected function doSave(PropelPDO $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                } else {
                    $this->doUpdate($con);
                }
                $affectedRows += 1;
                $this->resetModified();
            }

            if ($this->aessScheduledForDeletion !== null) {
                if (!$this->aessScheduledForDeletion->isEmpty()) {
                    AssignmentEventSelectorQuery::create()
                        ->filterByPrimaryKeys($this->aessScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->aessScheduledForDeletion = null;
                }
            }

            if ($this->collAess !== null) {
                foreach ($this->collAess as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param PropelPDO $con
     *
     * @throws PropelException
     * @see        doSave()
     */
    protected function doInsert(PropelPDO $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[] = AlarmSeverityAssignmentRulePeer::ID;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . AlarmSeverityAssignmentRulePeer::ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::MOD)) {
            $modifiedColumns[':p' . $index++]  = '`mod`';
        }
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::NAME)) {
            $modifiedColumns[':p' . $index++]  = '`name`';
        }
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::PRECEDENCE)) {
            $modifiedColumns[':p' . $index++]  = '`precedence`';
        }
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::SEV_SERV_INDEP)) {
            $modifiedColumns[':p' . $index++]  = '`sev_serv_indep`';
        }
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::SEV_SERV_UNAFF)) {
            $modifiedColumns[':p' . $index++]  = '`sev_serv_unaff`';
        }
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::SEV_SERV_AFF)) {
            $modifiedColumns[':p' . $index++]  = '`sev_serv_aff`';
        }
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::EVT_SEL_MODE)) {
            $modifiedColumns[':p' . $index++]  = '`evt_sel_mode`';
        }
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::ASGT_EVT_SEL)) {
            $modifiedColumns[':p' . $index++]  = '`asgt_evt_sel`';
        }

        $sql = sprintf(
            'INSERT INTO `asev_asgt_rule` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`mod`':
                        $stmt->bindValue($identifier, $this->mod, PDO::PARAM_INT);
                        break;
                    case '`name`':
                        $stmt->bindValue($identifier, $this->name, PDO::PARAM_STR);
                        break;
                    case '`precedence`':
                        $stmt->bindValue($identifier, $this->precedence, PDO::PARAM_INT);
                        break;
                    case '`sev_serv_indep`':
                        $stmt->bindValue($identifier, $this->sev_serv_indep, PDO::PARAM_INT);
                        break;
                    case '`sev_serv_unaff`':
                        $stmt->bindValue($identifier, $this->sev_serv_unaff, PDO::PARAM_INT);
                        break;
                    case '`sev_serv_aff`':
                        $stmt->bindValue($identifier, $this->sev_serv_aff, PDO::PARAM_INT);
                        break;
                    case '`evt_sel_mode`':
                        $stmt->bindValue($identifier, $this->evt_sel_mode, PDO::PARAM_INT);
                        break;
                    case '`asgt_evt_sel`':
                        $stmt->bindValue($identifier, $this->asgt_evt_sel, PDO::PARAM_INT);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param PropelPDO $con
     *
     * @see        doSave()
     */
    protected function doUpdate(PropelPDO $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();
        BasePeer::doUpdate($selectCriteria, $valuesCriteria, $con);
    }

    /**
     * Array of ValidationFailed objects.
     * @var        array ValidationFailed[]
     */
    protected $validationFailures = array();

    /**
     * Gets any ValidationFailed objects that resulted from last call to validate().
     *
     *
     * @return array ValidationFailed[]
     * @see        validate()
     */
    public function getValidationFailures()
    {
        return $this->validationFailures;
    }

    /**
     * Validates the objects modified field values and all objects related to this table.
     *
     * If $columns is either a column name or an array of column names
     * only those columns are validated.
     *
     * @param mixed $columns Column name or an array of column names.
     * @return boolean Whether all columns pass validation.
     * @see        doValidate()
     * @see        getValidationFailures()
     */
    public function validate($columns = null)
    {
        $res = $this->doValidate($columns);
        if ($res === true) {
            $this->validationFailures = array();

            return true;
        }

        $this->validationFailures = $res;

        return false;
    }

    /**
     * This function performs the validation work for complex object models.
     *
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggregated array of ValidationFailed objects will be returned.
     *
     * @param array $columns Array of column names to validate.
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objects otherwise.
     */
    protected function doValidate($columns = null)
    {
        if (!$this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;

            $failureMap = array();


            if (($retval = AlarmSeverityAssignmentRulePeer::doValidate($this, $columns)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }


                if ($this->collAess !== null) {
                    foreach ($this->collAess as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }


            $this->alreadyInValidation = false;
        }

        return (!empty($failureMap) ? $failureMap : true);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param string $name name
     * @param string $type The type of fieldname the $name is of:
     *               one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *               BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *               Defaults to BasePeer::TYPE_PHPNAME
     * @return mixed Value of field.
     */
    public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = AlarmSeverityAssignmentRulePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getMod();
                break;
            case 2:
                return $this->getName();
                break;
            case 3:
                return $this->getPrecedence();
                break;
            case 4:
                return $this->getSevServIndep();
                break;
            case 5:
                return $this->getSevServUnaff();
                break;
            case 6:
                return $this->getSevServAff();
                break;
            case 7:
                return $this->getEvtSelMode();
                break;
            case 8:
                return $this->getAsgtEvtSel();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     *                    BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                    Defaults to BasePeer::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to true.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {
        if (isset($alreadyDumpedObjects['AlarmSeverityAssignmentRule'][$this->getPrimaryKey()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['AlarmSeverityAssignmentRule'][$this->getPrimaryKey()] = true;
        $keys = AlarmSeverityAssignmentRulePeer::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getMod(),
            $keys[2] => $this->getName(),
            $keys[3] => $this->getPrecedence(),
            $keys[4] => $this->getSevServIndep(),
            $keys[5] => $this->getSevServUnaff(),
            $keys[6] => $this->getSevServAff(),
            $keys[7] => $this->getEvtSelMode(),
            $keys[8] => $this->getAsgtEvtSel(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->collAess) {
                $result['Aess'] = $this->collAess->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param string $name peer name
     * @param mixed $value field value
     * @param string $type The type of fieldname the $name is of:
     *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                     Defaults to BasePeer::TYPE_PHPNAME
     * @return void
     */
    public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = AlarmSeverityAssignmentRulePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);

        $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @param mixed $value field value
     * @return void
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setMod($value);
                break;
            case 2:
                $this->setName($value);
                break;
            case 3:
                $this->setPrecedence($value);
                break;
            case 4:
                $this->setSevServIndep($value);
                break;
            case 5:
                $this->setSevServUnaff($value);
                break;
            case 6:
                $this->setSevServAff($value);
                break;
            case 7:
                $this->setEvtSelMode($value);
                break;
            case 8:
                $this->setAsgtEvtSel($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     * The default key type is the column's BasePeer::TYPE_PHPNAME
     *
     * @param array  $arr     An array to populate the object from.
     * @param string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
    {
        $keys = AlarmSeverityAssignmentRulePeer::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
        if (array_key_exists($keys[1], $arr)) $this->setMod($arr[$keys[1]]);
        if (array_key_exists($keys[2], $arr)) $this->setName($arr[$keys[2]]);
        if (array_key_exists($keys[3], $arr)) $this->setPrecedence($arr[$keys[3]]);
        if (array_key_exists($keys[4], $arr)) $this->setSevServIndep($arr[$keys[4]]);
        if (array_key_exists($keys[5], $arr)) $this->setSevServUnaff($arr[$keys[5]]);
        if (array_key_exists($keys[6], $arr)) $this->setSevServAff($arr[$keys[6]]);
        if (array_key_exists($keys[7], $arr)) $this->setEvtSelMode($arr[$keys[7]]);
        if (array_key_exists($keys[8], $arr)) $this->setAsgtEvtSel($arr[$keys[8]]);
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(AlarmSeverityAssignmentRulePeer::DATABASE_NAME);

        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::ID)) $criteria->add(AlarmSeverityAssignmentRulePeer::ID, $this->id);
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::MOD)) $criteria->add(AlarmSeverityAssignmentRulePeer::MOD, $this->mod);
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::NAME)) $criteria->add(AlarmSeverityAssignmentRulePeer::NAME, $this->name);
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::PRECEDENCE)) $criteria->add(AlarmSeverityAssignmentRulePeer::PRECEDENCE, $this->precedence);
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::SEV_SERV_INDEP)) $criteria->add(AlarmSeverityAssignmentRulePeer::SEV_SERV_INDEP, $this->sev_serv_indep);
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::SEV_SERV_UNAFF)) $criteria->add(AlarmSeverityAssignmentRulePeer::SEV_SERV_UNAFF, $this->sev_serv_unaff);
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::SEV_SERV_AFF)) $criteria->add(AlarmSeverityAssignmentRulePeer::SEV_SERV_AFF, $this->sev_serv_aff);
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::EVT_SEL_MODE)) $criteria->add(AlarmSeverityAssignmentRulePeer::EVT_SEL_MODE, $this->evt_sel_mode);
        if ($this->isColumnModified(AlarmSeverityAssignmentRulePeer::ASGT_EVT_SEL)) $criteria->add(AlarmSeverityAssignmentRulePeer::ASGT_EVT_SEL, $this->asgt_evt_sel);

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(AlarmSeverityAssignmentRulePeer::DATABASE_NAME);
        $criteria->add(AlarmSeverityAssignmentRulePeer::ID, $this->id);

        return $criteria;
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param  int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {

        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param object $copyObj An object of AlarmSeverityAssignmentRule (or compatible) type.
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setMod($this->getMod());
        $copyObj->setName($this->getName());
        $copyObj->setPrecedence($this->getPrecedence());
        $copyObj->setSevServIndep($this->getSevServIndep());
        $copyObj->setSevServUnaff($this->getSevServUnaff());
        $copyObj->setSevServAff($this->getSevServAff());
        $copyObj->setEvtSelMode($this->getEvtSelMode());
        $copyObj->setAsgtEvtSel($this->getAsgtEvtSel());

        if ($deepCopy && !$this->startCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);
            // store object hash to prevent cycle
            $this->startCopy = true;

            foreach ($this->getAess() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addAes($relObj->copy($deepCopy));
                }
            }

            //unflag object copy
            $this->startCopy = false;
        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return AlarmSeverityAssignmentRule Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Returns a peer instance associated with this om.
     *
     * Since Peer classes are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     *
     * @return AlarmSeverityAssignmentRulePeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new AlarmSeverityAssignmentRulePeer();
        }

        return self::$peer;
    }


    /**
     * Initializes a collection based on the name of a relation.
     * Avoids crafting an 'init[$relationName]s' method name
     * that wouldn't work when StandardEnglishPluralizer is used.
     *
     * @param string $relationName The name of the relation to initialize
     * @return void
     */
    public function initRelation($relationName)
    {
        if ('Aes' == $relationName) {
            $this->initAess();
        }
    }

    /**
     * Clears out the collAess collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     * @see        addAess()
     */
    public function clearAess()
    {
        $this->collAess = null; // important to set this to null since that means it is uninitialized
        $this->collAessPartial = null;

        return $this;
    }

    /**
     * reset is the collAess collection loaded partially
     *
     * @return void
     */
    public function resetPartialAess($v = true)
    {
        $this->collAessPartial = $v;
    }

    /**
     * Initializes the collAess collection.
     *
     * By default this just sets the collAess collection to an empty array (like clearcollAess());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initAess($overrideExisting = true)
    {
        if (null !== $this->collAess && !$overrideExisting) {
            return;
        }
        $this->collAess = new PropelObjectCollection();
        $this->collAess->setModel('AssignmentEventSelector');
    }

    /**
     * Gets an array of AssignmentEventSelector objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this AlarmSeverityAssignmentRule is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|AssignmentEventSelector[] List of AssignmentEventSelector objects
     * @throws PropelException
     */
    public function getAess($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collAessPartial && !$this->isNew();
        if (null === $this->collAess || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collAess) {
                // return empty collection
                $this->initAess();
            } else {
                $collAess = AssignmentEventSelectorQuery::create(null, $criteria)
                    ->filterByAlarmSeverityAssignmentRule($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collAessPartial && count($collAess)) {
                      $this->initAess(false);

                      foreach ($collAess as $obj) {
                        if (false == $this->collAess->contains($obj)) {
                          $this->collAess->append($obj);
                        }
                      }

                      $this->collAessPartial = true;
                    }

                    $collAess->getInternalIterator()->rewind();

                    return $collAess;
                }

                if ($partial && $this->collAess) {
                    foreach ($this->collAess as $obj) {
                        if ($obj->isNew()) {
                            $collAess[] = $obj;
                        }
                    }
                }

                $this->collAess = $collAess;
                $this->collAessPartial = false;
            }
        }

        return $this->collAess;
    }

    /**
     * Sets a collection of Aes objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $aess A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function setAess(PropelCollection $aess, PropelPDO $con = null)
    {
        $aessToDelete = $this->getAess(new Criteria(), $con)->diff($aess);


        $this->aessScheduledForDeletion = $aessToDelete;

        foreach ($aessToDelete as $aesRemoved) {
            $aesRemoved->setAlarmSeverityAssignmentRule(null);
        }

        $this->collAess = null;
        foreach ($aess as $aes) {
            $this->addAes($aes);
        }

        $this->collAess = $aess;
        $this->collAessPartial = false;

        return $this;
    }

    /**
     * Returns the number of related AssignmentEventSelector objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related AssignmentEventSelector objects.
     * @throws PropelException
     */
    public function countAess(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collAessPartial && !$this->isNew();
        if (null === $this->collAess || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collAess) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getAess());
            }
            $query = AssignmentEventSelectorQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByAlarmSeverityAssignmentRule($this)
                ->count($con);
        }

        return count($this->collAess);
    }

    /**
     * Method called to associate a AssignmentEventSelector object to this object
     * through the AssignmentEventSelector foreign key attribute.
     *
     * @param    AssignmentEventSelector $l AssignmentEventSelector
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function addAes(AssignmentEventSelector $l)
    {
        if ($this->collAess === null) {
            $this->initAess();
            $this->collAessPartial = true;
        }

        if (!in_array($l, $this->collAess->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddAes($l);

            if ($this->aessScheduledForDeletion and $this->aessScheduledForDeletion->contains($l)) {
                $this->aessScheduledForDeletion->remove($this->aessScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	Aes $aes The aes object to add.
     */
    protected function doAddAes($aes)
    {
        $this->collAess[]= $aes;
        $aes->setAlarmSeverityAssignmentRule($this);
    }

    /**
     * @param	Aes $aes The aes object to remove.
     * @return AlarmSeverityAssignmentRule The current object (for fluent API support)
     */
    public function removeAes($aes)
    {
        if ($this->getAess()->contains($aes)) {
            $this->collAess->remove($this->collAess->search($aes));
            if (null === $this->aessScheduledForDeletion) {
                $this->aessScheduledForDeletion = clone $this->collAess;
                $this->aessScheduledForDeletion->clear();
            }
            $this->aessScheduledForDeletion[]= clone $aes;
            $aes->setAlarmSeverityAssignmentRule(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this AlarmSeverityAssignmentRule is new, it will return
     * an empty collection; or if this AlarmSeverityAssignmentRule has previously
     * been saved, it will retrieve related Aess from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in AlarmSeverityAssignmentRule.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @param string $join_behavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return PropelObjectCollection|AssignmentEventSelector[] List of AssignmentEventSelector objects
     */
    public function getAessJoinAlarmEventDescriptor($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $query = AssignmentEventSelectorQuery::create(null, $criteria);
        $query->joinWith('AlarmEventDescriptor', $join_behavior);

        return $this->getAess($query, $con);
    }

    /**
     * Clears the current object and sets all attributes to their default values
     */
    public function clear()
    {
        $this->id = null;
        $this->mod = null;
        $this->name = null;
        $this->precedence = null;
        $this->sev_serv_indep = null;
        $this->sev_serv_unaff = null;
        $this->sev_serv_aff = null;
        $this->evt_sel_mode = null;
        $this->asgt_evt_sel = null;
        $this->alreadyInSave = false;
        $this->alreadyInValidation = false;
        $this->alreadyInClearAllReferencesDeep = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references to other model objects or collections of model objects.
     *
     * This method is a user-space workaround for PHP's inability to garbage collect
     * objects with circular references (even in PHP 5.3). This is currently necessary
     * when using Propel in certain daemon or large-volume/high-memory operations.
     *
     * @param boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep && !$this->alreadyInClearAllReferencesDeep) {
            $this->alreadyInClearAllReferencesDeep = true;
            if ($this->collAess) {
                foreach ($this->collAess as $o) {
                    $o->clearAllReferences($deep);
                }
            }

            $this->alreadyInClearAllReferencesDeep = false;
        } // if ($deep)

        if ($this->collAess instanceof PropelCollection) {
            $this->collAess->clearIterator();
        }
        $this->collAess = null;
    }

    /**
     * return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(AlarmSeverityAssignmentRulePeer::DEFAULT_STRING_FORMAT);
    }

    /**
     * return true is the object is in saving state
     *
     * @return boolean
     */
    public function isAlreadyInSave()
    {
        return $this->alreadyInSave;
    }

}
