<?php


/**
 * Base class that represents a query for the 'asev_asgt_rule' table.
 *
 *
 *
 * @method AlarmSeverityAssignmentRuleQuery orderById($order = Criteria::ASC) Order by the id column
 * @method AlarmSeverityAssignmentRuleQuery orderByMod($order = Criteria::ASC) Order by the mod column
 * @method AlarmSeverityAssignmentRuleQuery orderByName($order = Criteria::ASC) Order by the name column
 * @method AlarmSeverityAssignmentRuleQuery orderByPrecedence($order = Criteria::ASC) Order by the precedence column
 * @method AlarmSeverityAssignmentRuleQuery orderBySevServIndep($order = Criteria::ASC) Order by the sev_serv_indep column
 * @method AlarmSeverityAssignmentRuleQuery orderBySevServUnaff($order = Criteria::ASC) Order by the sev_serv_unaff column
 * @method AlarmSeverityAssignmentRuleQuery orderBySevServAff($order = Criteria::ASC) Order by the sev_serv_aff column
 * @method AlarmSeverityAssignmentRuleQuery orderByEvtSelMode($order = Criteria::ASC) Order by the evt_sel_mode column
 * @method AlarmSeverityAssignmentRuleQuery orderByAsgtEvtSel($order = Criteria::ASC) Order by the asgt_evt_sel column
 *
 * @method AlarmSeverityAssignmentRuleQuery groupById() Group by the id column
 * @method AlarmSeverityAssignmentRuleQuery groupByMod() Group by the mod column
 * @method AlarmSeverityAssignmentRuleQuery groupByName() Group by the name column
 * @method AlarmSeverityAssignmentRuleQuery groupByPrecedence() Group by the precedence column
 * @method AlarmSeverityAssignmentRuleQuery groupBySevServIndep() Group by the sev_serv_indep column
 * @method AlarmSeverityAssignmentRuleQuery groupBySevServUnaff() Group by the sev_serv_unaff column
 * @method AlarmSeverityAssignmentRuleQuery groupBySevServAff() Group by the sev_serv_aff column
 * @method AlarmSeverityAssignmentRuleQuery groupByEvtSelMode() Group by the evt_sel_mode column
 * @method AlarmSeverityAssignmentRuleQuery groupByAsgtEvtSel() Group by the asgt_evt_sel column
 *
 * @method AlarmSeverityAssignmentRuleQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method AlarmSeverityAssignmentRuleQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method AlarmSeverityAssignmentRuleQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method AlarmSeverityAssignmentRuleQuery leftJoinAes($relationAlias = null) Adds a LEFT JOIN clause to the query using the Aes relation
 * @method AlarmSeverityAssignmentRuleQuery rightJoinAes($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Aes relation
 * @method AlarmSeverityAssignmentRuleQuery innerJoinAes($relationAlias = null) Adds a INNER JOIN clause to the query using the Aes relation
 *
 * @method AlarmSeverityAssignmentRule findOne(PropelPDO $con = null) Return the first AlarmSeverityAssignmentRule matching the query
 * @method AlarmSeverityAssignmentRule findOneOrCreate(PropelPDO $con = null) Return the first AlarmSeverityAssignmentRule matching the query, or a new AlarmSeverityAssignmentRule object populated from the query conditions when no match is found
 *
 * @method AlarmSeverityAssignmentRule findOneByMod(int $mod) Return the first AlarmSeverityAssignmentRule filtered by the mod column
 * @method AlarmSeverityAssignmentRule findOneByName(string $name) Return the first AlarmSeverityAssignmentRule filtered by the name column
 * @method AlarmSeverityAssignmentRule findOneByPrecedence(int $precedence) Return the first AlarmSeverityAssignmentRule filtered by the precedence column
 * @method AlarmSeverityAssignmentRule findOneBySevServIndep(int $sev_serv_indep) Return the first AlarmSeverityAssignmentRule filtered by the sev_serv_indep column
 * @method AlarmSeverityAssignmentRule findOneBySevServUnaff(int $sev_serv_unaff) Return the first AlarmSeverityAssignmentRule filtered by the sev_serv_unaff column
 * @method AlarmSeverityAssignmentRule findOneBySevServAff(int $sev_serv_aff) Return the first AlarmSeverityAssignmentRule filtered by the sev_serv_aff column
 * @method AlarmSeverityAssignmentRule findOneByEvtSelMode(int $evt_sel_mode) Return the first AlarmSeverityAssignmentRule filtered by the evt_sel_mode column
 * @method AlarmSeverityAssignmentRule findOneByAsgtEvtSel(int $asgt_evt_sel) Return the first AlarmSeverityAssignmentRule filtered by the asgt_evt_sel column
 *
 * @method array findById(int $id) Return AlarmSeverityAssignmentRule objects filtered by the id column
 * @method array findByMod(int $mod) Return AlarmSeverityAssignmentRule objects filtered by the mod column
 * @method array findByName(string $name) Return AlarmSeverityAssignmentRule objects filtered by the name column
 * @method array findByPrecedence(int $precedence) Return AlarmSeverityAssignmentRule objects filtered by the precedence column
 * @method array findBySevServIndep(int $sev_serv_indep) Return AlarmSeverityAssignmentRule objects filtered by the sev_serv_indep column
 * @method array findBySevServUnaff(int $sev_serv_unaff) Return AlarmSeverityAssignmentRule objects filtered by the sev_serv_unaff column
 * @method array findBySevServAff(int $sev_serv_aff) Return AlarmSeverityAssignmentRule objects filtered by the sev_serv_aff column
 * @method array findByEvtSelMode(int $evt_sel_mode) Return AlarmSeverityAssignmentRule objects filtered by the evt_sel_mode column
 * @method array findByAsgtEvtSel(int $asgt_evt_sel) Return AlarmSeverityAssignmentRule objects filtered by the asgt_evt_sel column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAlarmSeverityAssignmentRuleQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseAlarmSeverityAssignmentRuleQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'AlarmSeverityAssignmentRule';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new AlarmSeverityAssignmentRuleQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   AlarmSeverityAssignmentRuleQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return AlarmSeverityAssignmentRuleQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof AlarmSeverityAssignmentRuleQuery) {
            return $criteria;
        }
        $query = new AlarmSeverityAssignmentRuleQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   AlarmSeverityAssignmentRule|AlarmSeverityAssignmentRule[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = AlarmSeverityAssignmentRulePeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(AlarmSeverityAssignmentRulePeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AlarmSeverityAssignmentRule A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AlarmSeverityAssignmentRule A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `mod`, `name`, `precedence`, `sev_serv_indep`, `sev_serv_unaff`, `sev_serv_aff`, `evt_sel_mode`, `asgt_evt_sel` FROM `asev_asgt_rule` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new AlarmSeverityAssignmentRule();
            $obj->hydrate($row);
            AlarmSeverityAssignmentRulePeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return AlarmSeverityAssignmentRule|AlarmSeverityAssignmentRule[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|AlarmSeverityAssignmentRule[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the mod column
     *
     * Example usage:
     * <code>
     * $query->filterByMod(1234); // WHERE mod = 1234
     * $query->filterByMod(array(12, 34)); // WHERE mod IN (12, 34)
     * $query->filterByMod(array('min' => 12)); // WHERE mod >= 12
     * $query->filterByMod(array('max' => 12)); // WHERE mod <= 12
     * </code>
     *
     * @param     mixed $mod The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByMod($mod = null, $comparison = null)
    {
        if (is_array($mod)) {
            $useMinMax = false;
            if (isset($mod['min'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::MOD, $mod['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($mod['max'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::MOD, $mod['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::MOD, $mod, $comparison);
    }

    /**
     * Filter the query on the name column
     *
     * Example usage:
     * <code>
     * $query->filterByName('fooValue');   // WHERE name = 'fooValue'
     * $query->filterByName('%fooValue%'); // WHERE name LIKE '%fooValue%'
     * </code>
     *
     * @param     string $name The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByName($name = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($name)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $name)) {
                $name = str_replace('*', '%', $name);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::NAME, $name, $comparison);
    }

    /**
     * Filter the query on the precedence column
     *
     * Example usage:
     * <code>
     * $query->filterByPrecedence(1234); // WHERE precedence = 1234
     * $query->filterByPrecedence(array(12, 34)); // WHERE precedence IN (12, 34)
     * $query->filterByPrecedence(array('min' => 12)); // WHERE precedence >= 12
     * $query->filterByPrecedence(array('max' => 12)); // WHERE precedence <= 12
     * </code>
     *
     * @param     mixed $precedence The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByPrecedence($precedence = null, $comparison = null)
    {
        if (is_array($precedence)) {
            $useMinMax = false;
            if (isset($precedence['min'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::PRECEDENCE, $precedence['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($precedence['max'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::PRECEDENCE, $precedence['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::PRECEDENCE, $precedence, $comparison);
    }

    /**
     * Filter the query on the sev_serv_indep column
     *
     * Example usage:
     * <code>
     * $query->filterBySevServIndep(1234); // WHERE sev_serv_indep = 1234
     * $query->filterBySevServIndep(array(12, 34)); // WHERE sev_serv_indep IN (12, 34)
     * $query->filterBySevServIndep(array('min' => 12)); // WHERE sev_serv_indep >= 12
     * $query->filterBySevServIndep(array('max' => 12)); // WHERE sev_serv_indep <= 12
     * </code>
     *
     * @param     mixed $sevServIndep The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterBySevServIndep($sevServIndep = null, $comparison = null)
    {
        if (is_array($sevServIndep)) {
            $useMinMax = false;
            if (isset($sevServIndep['min'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::SEV_SERV_INDEP, $sevServIndep['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($sevServIndep['max'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::SEV_SERV_INDEP, $sevServIndep['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::SEV_SERV_INDEP, $sevServIndep, $comparison);
    }

    /**
     * Filter the query on the sev_serv_unaff column
     *
     * Example usage:
     * <code>
     * $query->filterBySevServUnaff(1234); // WHERE sev_serv_unaff = 1234
     * $query->filterBySevServUnaff(array(12, 34)); // WHERE sev_serv_unaff IN (12, 34)
     * $query->filterBySevServUnaff(array('min' => 12)); // WHERE sev_serv_unaff >= 12
     * $query->filterBySevServUnaff(array('max' => 12)); // WHERE sev_serv_unaff <= 12
     * </code>
     *
     * @param     mixed $sevServUnaff The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterBySevServUnaff($sevServUnaff = null, $comparison = null)
    {
        if (is_array($sevServUnaff)) {
            $useMinMax = false;
            if (isset($sevServUnaff['min'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::SEV_SERV_UNAFF, $sevServUnaff['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($sevServUnaff['max'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::SEV_SERV_UNAFF, $sevServUnaff['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::SEV_SERV_UNAFF, $sevServUnaff, $comparison);
    }

    /**
     * Filter the query on the sev_serv_aff column
     *
     * Example usage:
     * <code>
     * $query->filterBySevServAff(1234); // WHERE sev_serv_aff = 1234
     * $query->filterBySevServAff(array(12, 34)); // WHERE sev_serv_aff IN (12, 34)
     * $query->filterBySevServAff(array('min' => 12)); // WHERE sev_serv_aff >= 12
     * $query->filterBySevServAff(array('max' => 12)); // WHERE sev_serv_aff <= 12
     * </code>
     *
     * @param     mixed $sevServAff The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterBySevServAff($sevServAff = null, $comparison = null)
    {
        if (is_array($sevServAff)) {
            $useMinMax = false;
            if (isset($sevServAff['min'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::SEV_SERV_AFF, $sevServAff['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($sevServAff['max'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::SEV_SERV_AFF, $sevServAff['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::SEV_SERV_AFF, $sevServAff, $comparison);
    }

    /**
     * Filter the query on the evt_sel_mode column
     *
     * Example usage:
     * <code>
     * $query->filterByEvtSelMode(1234); // WHERE evt_sel_mode = 1234
     * $query->filterByEvtSelMode(array(12, 34)); // WHERE evt_sel_mode IN (12, 34)
     * $query->filterByEvtSelMode(array('min' => 12)); // WHERE evt_sel_mode >= 12
     * $query->filterByEvtSelMode(array('max' => 12)); // WHERE evt_sel_mode <= 12
     * </code>
     *
     * @param     mixed $evtSelMode The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByEvtSelMode($evtSelMode = null, $comparison = null)
    {
        if (is_array($evtSelMode)) {
            $useMinMax = false;
            if (isset($evtSelMode['min'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::EVT_SEL_MODE, $evtSelMode['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($evtSelMode['max'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::EVT_SEL_MODE, $evtSelMode['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::EVT_SEL_MODE, $evtSelMode, $comparison);
    }

    /**
     * Filter the query on the asgt_evt_sel column
     *
     * Example usage:
     * <code>
     * $query->filterByAsgtEvtSel(1234); // WHERE asgt_evt_sel = 1234
     * $query->filterByAsgtEvtSel(array(12, 34)); // WHERE asgt_evt_sel IN (12, 34)
     * $query->filterByAsgtEvtSel(array('min' => 12)); // WHERE asgt_evt_sel >= 12
     * $query->filterByAsgtEvtSel(array('max' => 12)); // WHERE asgt_evt_sel <= 12
     * </code>
     *
     * @param     mixed $asgtEvtSel The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByAsgtEvtSel($asgtEvtSel = null, $comparison = null)
    {
        if (is_array($asgtEvtSel)) {
            $useMinMax = false;
            if (isset($asgtEvtSel['min'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::ASGT_EVT_SEL, $asgtEvtSel['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($asgtEvtSel['max'])) {
                $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::ASGT_EVT_SEL, $asgtEvtSel['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::ASGT_EVT_SEL, $asgtEvtSel, $comparison);
    }

    /**
     * Filter the query by a related AssignmentEventSelector object
     *
     * @param   AssignmentEventSelector|PropelObjectCollection $assignmentEventSelector  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAes($assignmentEventSelector, $comparison = null)
    {
        if ($assignmentEventSelector instanceof AssignmentEventSelector) {
            return $this
                ->addUsingAlias(AlarmSeverityAssignmentRulePeer::ID, $assignmentEventSelector->getAsarId(), $comparison);
        } elseif ($assignmentEventSelector instanceof PropelObjectCollection) {
            return $this
                ->useAesQuery()
                ->filterByPrimaryKeys($assignmentEventSelector->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByAes() only accepts arguments of type AssignmentEventSelector or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Aes relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function joinAes($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Aes');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Aes');
        }

        return $this;
    }

    /**
     * Use the Aes relation AssignmentEventSelector object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AssignmentEventSelectorQuery A secondary query class using the current class as primary query
     */
    public function useAesQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAes($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Aes', 'AssignmentEventSelectorQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   AlarmSeverityAssignmentRule $alarmSeverityAssignmentRule Object to remove from the list of results
     *
     * @return AlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function prune($alarmSeverityAssignmentRule = null)
    {
        if ($alarmSeverityAssignmentRule) {
            $this->addUsingAlias(AlarmSeverityAssignmentRulePeer::ID, $alarmSeverityAssignmentRule->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
