<?php


/**
 * Base class that represents a row from the 'alm_man_obj' table.
 *
 *
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAlarmingManagedObject extends BaseObject implements Persistent
{
    /**
     * Peer class name
     */
    const PEER = 'AlarmingManagedObjectPeer';

    /**
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var        AlarmingManagedObjectPeer
     */
    protected static $peer;

    /**
     * The flag var to prevent infinite loop in deep copy
     * @var       boolean
     */
    protected $startCopy = false;

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the mod field.
     * @var        int
     */
    protected $mod;

    /**
     * The value for the name field.
     * @var        string
     */
    protected $name;

    /**
     * The value for the inst_addr_sel field.
     * @var        int
     */
    protected $inst_addr_sel;

    /**
     * The value for the inst_addr_val field.
     * @var        string
     */
    protected $inst_addr_val;

    /**
     * The value for the amh_id field.
     * @var        int
     */
    protected $amh_id;

    /**
     * @var        AlarmingManagementHost
     */
    protected $aAlarmingManagementHost;

    /**
     * @var        PropelObjectCollection|CurrentAlarmCondition[] Collection to store aggregation of CurrentAlarmCondition objects.
     */
    protected $collCacs;
    protected $collCacsPartial;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInSave = false;

    /**
     * Flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInValidation = false;

    /**
     * Flag to prevent endless clearAllReferences($deep=true) loop, if this object is referenced
     * @var        boolean
     */
    protected $alreadyInClearAllReferencesDeep = false;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $cacsScheduledForDeletion = null;

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {

        return $this->id;
    }

    /**
     * Get the [mod] column value.
     *
     * @return int
     */
    public function getMod()
    {

        return $this->mod;
    }

    /**
     * Get the [name] column value.
     *
     * @return string
     */
    public function getName()
    {

        return $this->name;
    }

    /**
     * Get the [inst_addr_sel] column value.
     *
     * @return int
     */
    public function getInstAddrSel()
    {

        return $this->inst_addr_sel;
    }

    /**
     * Get the [inst_addr_val] column value.
     *
     * @return string
     */
    public function getInstAddrVal()
    {

        return $this->inst_addr_val;
    }

    /**
     * Get the [amh_id] column value.
     *
     * @return int
     */
    public function getAmhId()
    {

        return $this->amh_id;
    }

    /**
     * Set the value of [id] column.
     *
     * @param  int $v new value
     * @return AlarmingManagedObject The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[] = AlarmingManagedObjectPeer::ID;
        }


        return $this;
    } // setId()

    /**
     * Set the value of [mod] column.
     *
     * @param  int $v new value
     * @return AlarmingManagedObject The current object (for fluent API support)
     */
    public function setMod($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->mod !== $v) {
            $this->mod = $v;
            $this->modifiedColumns[] = AlarmingManagedObjectPeer::MOD;
        }


        return $this;
    } // setMod()

    /**
     * Set the value of [name] column.
     *
     * @param  string $v new value
     * @return AlarmingManagedObject The current object (for fluent API support)
     */
    public function setName($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->name !== $v) {
            $this->name = $v;
            $this->modifiedColumns[] = AlarmingManagedObjectPeer::NAME;
        }


        return $this;
    } // setName()

    /**
     * Set the value of [inst_addr_sel] column.
     *
     * @param  int $v new value
     * @return AlarmingManagedObject The current object (for fluent API support)
     */
    public function setInstAddrSel($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->inst_addr_sel !== $v) {
            $this->inst_addr_sel = $v;
            $this->modifiedColumns[] = AlarmingManagedObjectPeer::INST_ADDR_SEL;
        }


        return $this;
    } // setInstAddrSel()

    /**
     * Set the value of [inst_addr_val] column.
     *
     * @param  string $v new value
     * @return AlarmingManagedObject The current object (for fluent API support)
     */
    public function setInstAddrVal($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->inst_addr_val !== $v) {
            $this->inst_addr_val = $v;
            $this->modifiedColumns[] = AlarmingManagedObjectPeer::INST_ADDR_VAL;
        }


        return $this;
    } // setInstAddrVal()

    /**
     * Set the value of [amh_id] column.
     *
     * @param  int $v new value
     * @return AlarmingManagedObject The current object (for fluent API support)
     */
    public function setAmhId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->amh_id !== $v) {
            $this->amh_id = $v;
            $this->modifiedColumns[] = AlarmingManagedObjectPeer::AMH_ID;
        }

        if ($this->aAlarmingManagementHost !== null && $this->aAlarmingManagementHost->getId() !== $v) {
            $this->aAlarmingManagementHost = null;
        }


        return $this;
    } // setAmhId()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
        // otherwise, everything was equal, so return true
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
     * @param int $startcol 0-based offset column which indicates which resultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false)
    {
        try {

            $this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
            $this->mod = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
            $this->name = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
            $this->inst_addr_sel = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
            $this->inst_addr_val = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
            $this->amh_id = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }
            $this->postHydrate($row, $startcol, $rehydrate);

            return $startcol + 6; // 6 = AlarmingManagedObjectPeer::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException("Error populating AlarmingManagedObject object", $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {

        if ($this->aAlarmingManagementHost !== null && $this->amh_id !== $this->aAlarmingManagementHost->getId()) {
            $this->aAlarmingManagementHost = null;
        }
    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param boolean $deep (optional) Whether to also de-associated any related objects.
     * @param PropelPDO $con (optional) The PropelPDO connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmingManagedObjectPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $stmt = AlarmingManagedObjectPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
        $row = $stmt->fetch(PDO::FETCH_NUM);
        $stmt->closeCursor();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->aAlarmingManagementHost = null;
            $this->collCacs = null;

        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param PropelPDO $con
     * @return void
     * @throws PropelException
     * @throws Exception
     * @see        BaseObject::setDeleted()
     * @see        BaseObject::isDeleted()
     */
    public function delete(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmingManagedObjectPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        try {
            $deleteQuery = AlarmingManagedObjectQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $con->commit();
                $this->setDeleted(true);
            } else {
                $con->commit();
            }
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @throws Exception
     * @see        doSave()
     */
    public function save(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmingManagedObjectPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        $isInsert = $this->isNew();
        try {
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                AlarmingManagedObjectPeer::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see        save()
     */
    protected function doSave(PropelPDO $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aAlarmingManagementHost !== null) {
                if ($this->aAlarmingManagementHost->isModified() || $this->aAlarmingManagementHost->isNew()) {
                    $affectedRows += $this->aAlarmingManagementHost->save($con);
                }
                $this->setAlarmingManagementHost($this->aAlarmingManagementHost);
            }

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                } else {
                    $this->doUpdate($con);
                }
                $affectedRows += 1;
                $this->resetModified();
            }

            if ($this->cacsScheduledForDeletion !== null) {
                if (!$this->cacsScheduledForDeletion->isEmpty()) {
                    CurrentAlarmConditionQuery::create()
                        ->filterByPrimaryKeys($this->cacsScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->cacsScheduledForDeletion = null;
                }
            }

            if ($this->collCacs !== null) {
                foreach ($this->collCacs as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param PropelPDO $con
     *
     * @throws PropelException
     * @see        doSave()
     */
    protected function doInsert(PropelPDO $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[] = AlarmingManagedObjectPeer::ID;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . AlarmingManagedObjectPeer::ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(AlarmingManagedObjectPeer::ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(AlarmingManagedObjectPeer::MOD)) {
            $modifiedColumns[':p' . $index++]  = '`mod`';
        }
        if ($this->isColumnModified(AlarmingManagedObjectPeer::NAME)) {
            $modifiedColumns[':p' . $index++]  = '`name`';
        }
        if ($this->isColumnModified(AlarmingManagedObjectPeer::INST_ADDR_SEL)) {
            $modifiedColumns[':p' . $index++]  = '`inst_addr_sel`';
        }
        if ($this->isColumnModified(AlarmingManagedObjectPeer::INST_ADDR_VAL)) {
            $modifiedColumns[':p' . $index++]  = '`inst_addr_val`';
        }
        if ($this->isColumnModified(AlarmingManagedObjectPeer::AMH_ID)) {
            $modifiedColumns[':p' . $index++]  = '`amh_id`';
        }

        $sql = sprintf(
            'INSERT INTO `alm_man_obj` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`mod`':
                        $stmt->bindValue($identifier, $this->mod, PDO::PARAM_INT);
                        break;
                    case '`name`':
                        $stmt->bindValue($identifier, $this->name, PDO::PARAM_STR);
                        break;
                    case '`inst_addr_sel`':
                        $stmt->bindValue($identifier, $this->inst_addr_sel, PDO::PARAM_INT);
                        break;
                    case '`inst_addr_val`':
                        $stmt->bindValue($identifier, $this->inst_addr_val, PDO::PARAM_STR);
                        break;
                    case '`amh_id`':
                        $stmt->bindValue($identifier, $this->amh_id, PDO::PARAM_INT);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param PropelPDO $con
     *
     * @see        doSave()
     */
    protected function doUpdate(PropelPDO $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();
        BasePeer::doUpdate($selectCriteria, $valuesCriteria, $con);
    }

    /**
     * Array of ValidationFailed objects.
     * @var        array ValidationFailed[]
     */
    protected $validationFailures = array();

    /**
     * Gets any ValidationFailed objects that resulted from last call to validate().
     *
     *
     * @return array ValidationFailed[]
     * @see        validate()
     */
    public function getValidationFailures()
    {
        return $this->validationFailures;
    }

    /**
     * Validates the objects modified field values and all objects related to this table.
     *
     * If $columns is either a column name or an array of column names
     * only those columns are validated.
     *
     * @param mixed $columns Column name or an array of column names.
     * @return boolean Whether all columns pass validation.
     * @see        doValidate()
     * @see        getValidationFailures()
     */
    public function validate($columns = null)
    {
        $res = $this->doValidate($columns);
        if ($res === true) {
            $this->validationFailures = array();

            return true;
        }

        $this->validationFailures = $res;

        return false;
    }

    /**
     * This function performs the validation work for complex object models.
     *
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggregated array of ValidationFailed objects will be returned.
     *
     * @param array $columns Array of column names to validate.
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objects otherwise.
     */
    protected function doValidate($columns = null)
    {
        if (!$this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;

            $failureMap = array();


            // We call the validate method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aAlarmingManagementHost !== null) {
                if (!$this->aAlarmingManagementHost->validate($columns)) {
                    $failureMap = array_merge($failureMap, $this->aAlarmingManagementHost->getValidationFailures());
                }
            }


            if (($retval = AlarmingManagedObjectPeer::doValidate($this, $columns)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }


                if ($this->collCacs !== null) {
                    foreach ($this->collCacs as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }


            $this->alreadyInValidation = false;
        }

        return (!empty($failureMap) ? $failureMap : true);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param string $name name
     * @param string $type The type of fieldname the $name is of:
     *               one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *               BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *               Defaults to BasePeer::TYPE_PHPNAME
     * @return mixed Value of field.
     */
    public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = AlarmingManagedObjectPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getMod();
                break;
            case 2:
                return $this->getName();
                break;
            case 3:
                return $this->getInstAddrSel();
                break;
            case 4:
                return $this->getInstAddrVal();
                break;
            case 5:
                return $this->getAmhId();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     *                    BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                    Defaults to BasePeer::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to true.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {
        if (isset($alreadyDumpedObjects['AlarmingManagedObject'][$this->getPrimaryKey()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['AlarmingManagedObject'][$this->getPrimaryKey()] = true;
        $keys = AlarmingManagedObjectPeer::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getMod(),
            $keys[2] => $this->getName(),
            $keys[3] => $this->getInstAddrSel(),
            $keys[4] => $this->getInstAddrVal(),
            $keys[5] => $this->getAmhId(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->aAlarmingManagementHost) {
                $result['AlarmingManagementHost'] = $this->aAlarmingManagementHost->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
            if (null !== $this->collCacs) {
                $result['Cacs'] = $this->collCacs->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param string $name peer name
     * @param mixed $value field value
     * @param string $type The type of fieldname the $name is of:
     *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                     Defaults to BasePeer::TYPE_PHPNAME
     * @return void
     */
    public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = AlarmingManagedObjectPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);

        $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @param mixed $value field value
     * @return void
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setMod($value);
                break;
            case 2:
                $this->setName($value);
                break;
            case 3:
                $this->setInstAddrSel($value);
                break;
            case 4:
                $this->setInstAddrVal($value);
                break;
            case 5:
                $this->setAmhId($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     * The default key type is the column's BasePeer::TYPE_PHPNAME
     *
     * @param array  $arr     An array to populate the object from.
     * @param string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
    {
        $keys = AlarmingManagedObjectPeer::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
        if (array_key_exists($keys[1], $arr)) $this->setMod($arr[$keys[1]]);
        if (array_key_exists($keys[2], $arr)) $this->setName($arr[$keys[2]]);
        if (array_key_exists($keys[3], $arr)) $this->setInstAddrSel($arr[$keys[3]]);
        if (array_key_exists($keys[4], $arr)) $this->setInstAddrVal($arr[$keys[4]]);
        if (array_key_exists($keys[5], $arr)) $this->setAmhId($arr[$keys[5]]);
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(AlarmingManagedObjectPeer::DATABASE_NAME);

        if ($this->isColumnModified(AlarmingManagedObjectPeer::ID)) $criteria->add(AlarmingManagedObjectPeer::ID, $this->id);
        if ($this->isColumnModified(AlarmingManagedObjectPeer::MOD)) $criteria->add(AlarmingManagedObjectPeer::MOD, $this->mod);
        if ($this->isColumnModified(AlarmingManagedObjectPeer::NAME)) $criteria->add(AlarmingManagedObjectPeer::NAME, $this->name);
        if ($this->isColumnModified(AlarmingManagedObjectPeer::INST_ADDR_SEL)) $criteria->add(AlarmingManagedObjectPeer::INST_ADDR_SEL, $this->inst_addr_sel);
        if ($this->isColumnModified(AlarmingManagedObjectPeer::INST_ADDR_VAL)) $criteria->add(AlarmingManagedObjectPeer::INST_ADDR_VAL, $this->inst_addr_val);
        if ($this->isColumnModified(AlarmingManagedObjectPeer::AMH_ID)) $criteria->add(AlarmingManagedObjectPeer::AMH_ID, $this->amh_id);

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(AlarmingManagedObjectPeer::DATABASE_NAME);
        $criteria->add(AlarmingManagedObjectPeer::ID, $this->id);

        return $criteria;
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param  int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {

        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param object $copyObj An object of AlarmingManagedObject (or compatible) type.
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setMod($this->getMod());
        $copyObj->setName($this->getName());
        $copyObj->setInstAddrSel($this->getInstAddrSel());
        $copyObj->setInstAddrVal($this->getInstAddrVal());
        $copyObj->setAmhId($this->getAmhId());

        if ($deepCopy && !$this->startCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);
            // store object hash to prevent cycle
            $this->startCopy = true;

            foreach ($this->getCacs() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addCac($relObj->copy($deepCopy));
                }
            }

            //unflag object copy
            $this->startCopy = false;
        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return AlarmingManagedObject Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Returns a peer instance associated with this om.
     *
     * Since Peer classes are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     *
     * @return AlarmingManagedObjectPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new AlarmingManagedObjectPeer();
        }

        return self::$peer;
    }

    /**
     * Declares an association between this object and a AlarmingManagementHost object.
     *
     * @param                  AlarmingManagementHost $v
     * @return AlarmingManagedObject The current object (for fluent API support)
     * @throws PropelException
     */
    public function setAlarmingManagementHost(AlarmingManagementHost $v = null)
    {
        if ($v === null) {
            $this->setAmhId(NULL);
        } else {
            $this->setAmhId($v->getId());
        }

        $this->aAlarmingManagementHost = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the AlarmingManagementHost object, it will not be re-added.
        if ($v !== null) {
            $v->addAmo($this);
        }


        return $this;
    }


    /**
     * Get the associated AlarmingManagementHost object
     *
     * @param PropelPDO $con Optional Connection object.
     * @param $doQuery Executes a query to get the object if required
     * @return AlarmingManagementHost The associated AlarmingManagementHost object.
     * @throws PropelException
     */
    public function getAlarmingManagementHost(PropelPDO $con = null, $doQuery = true)
    {
        if ($this->aAlarmingManagementHost === null && ($this->amh_id !== null) && $doQuery) {
            $this->aAlarmingManagementHost = AlarmingManagementHostQuery::create()->findPk($this->amh_id, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aAlarmingManagementHost->addAmos($this);
             */
        }

        return $this->aAlarmingManagementHost;
    }


    /**
     * Initializes a collection based on the name of a relation.
     * Avoids crafting an 'init[$relationName]s' method name
     * that wouldn't work when StandardEnglishPluralizer is used.
     *
     * @param string $relationName The name of the relation to initialize
     * @return void
     */
    public function initRelation($relationName)
    {
        if ('Cac' == $relationName) {
            $this->initCacs();
        }
    }

    /**
     * Clears out the collCacs collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return AlarmingManagedObject The current object (for fluent API support)
     * @see        addCacs()
     */
    public function clearCacs()
    {
        $this->collCacs = null; // important to set this to null since that means it is uninitialized
        $this->collCacsPartial = null;

        return $this;
    }

    /**
     * reset is the collCacs collection loaded partially
     *
     * @return void
     */
    public function resetPartialCacs($v = true)
    {
        $this->collCacsPartial = $v;
    }

    /**
     * Initializes the collCacs collection.
     *
     * By default this just sets the collCacs collection to an empty array (like clearcollCacs());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initCacs($overrideExisting = true)
    {
        if (null !== $this->collCacs && !$overrideExisting) {
            return;
        }
        $this->collCacs = new PropelObjectCollection();
        $this->collCacs->setModel('CurrentAlarmCondition');
    }

    /**
     * Gets an array of CurrentAlarmCondition objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this AlarmingManagedObject is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|CurrentAlarmCondition[] List of CurrentAlarmCondition objects
     * @throws PropelException
     */
    public function getCacs($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collCacsPartial && !$this->isNew();
        if (null === $this->collCacs || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collCacs) {
                // return empty collection
                $this->initCacs();
            } else {
                $collCacs = CurrentAlarmConditionQuery::create(null, $criteria)
                    ->filterByAlarmingManagedObject($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collCacsPartial && count($collCacs)) {
                      $this->initCacs(false);

                      foreach ($collCacs as $obj) {
                        if (false == $this->collCacs->contains($obj)) {
                          $this->collCacs->append($obj);
                        }
                      }

                      $this->collCacsPartial = true;
                    }

                    $collCacs->getInternalIterator()->rewind();

                    return $collCacs;
                }

                if ($partial && $this->collCacs) {
                    foreach ($this->collCacs as $obj) {
                        if ($obj->isNew()) {
                            $collCacs[] = $obj;
                        }
                    }
                }

                $this->collCacs = $collCacs;
                $this->collCacsPartial = false;
            }
        }

        return $this->collCacs;
    }

    /**
     * Sets a collection of Cac objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $cacs A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return AlarmingManagedObject The current object (for fluent API support)
     */
    public function setCacs(PropelCollection $cacs, PropelPDO $con = null)
    {
        $cacsToDelete = $this->getCacs(new Criteria(), $con)->diff($cacs);


        $this->cacsScheduledForDeletion = $cacsToDelete;

        foreach ($cacsToDelete as $cacRemoved) {
            $cacRemoved->setAlarmingManagedObject(null);
        }

        $this->collCacs = null;
        foreach ($cacs as $cac) {
            $this->addCac($cac);
        }

        $this->collCacs = $cacs;
        $this->collCacsPartial = false;

        return $this;
    }

    /**
     * Returns the number of related CurrentAlarmCondition objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related CurrentAlarmCondition objects.
     * @throws PropelException
     */
    public function countCacs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collCacsPartial && !$this->isNew();
        if (null === $this->collCacs || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collCacs) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getCacs());
            }
            $query = CurrentAlarmConditionQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByAlarmingManagedObject($this)
                ->count($con);
        }

        return count($this->collCacs);
    }

    /**
     * Method called to associate a CurrentAlarmCondition object to this object
     * through the CurrentAlarmCondition foreign key attribute.
     *
     * @param    CurrentAlarmCondition $l CurrentAlarmCondition
     * @return AlarmingManagedObject The current object (for fluent API support)
     */
    public function addCac(CurrentAlarmCondition $l)
    {
        if ($this->collCacs === null) {
            $this->initCacs();
            $this->collCacsPartial = true;
        }

        if (!in_array($l, $this->collCacs->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddCac($l);

            if ($this->cacsScheduledForDeletion and $this->cacsScheduledForDeletion->contains($l)) {
                $this->cacsScheduledForDeletion->remove($this->cacsScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	Cac $cac The cac object to add.
     */
    protected function doAddCac($cac)
    {
        $this->collCacs[]= $cac;
        $cac->setAlarmingManagedObject($this);
    }

    /**
     * @param	Cac $cac The cac object to remove.
     * @return AlarmingManagedObject The current object (for fluent API support)
     */
    public function removeCac($cac)
    {
        if ($this->getCacs()->contains($cac)) {
            $this->collCacs->remove($this->collCacs->search($cac));
            if (null === $this->cacsScheduledForDeletion) {
                $this->cacsScheduledForDeletion = clone $this->collCacs;
                $this->cacsScheduledForDeletion->clear();
            }
            $this->cacsScheduledForDeletion[]= clone $cac;
            $cac->setAlarmingManagedObject(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this AlarmingManagedObject is new, it will return
     * an empty collection; or if this AlarmingManagedObject has previously
     * been saved, it will retrieve related Cacs from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in AlarmingManagedObject.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @param string $join_behavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return PropelObjectCollection|CurrentAlarmCondition[] List of CurrentAlarmCondition objects
     */
    public function getCacsJoinAlarmEventDescriptor($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $query = CurrentAlarmConditionQuery::create(null, $criteria);
        $query->joinWith('AlarmEventDescriptor', $join_behavior);

        return $this->getCacs($query, $con);
    }

    /**
     * Clears the current object and sets all attributes to their default values
     */
    public function clear()
    {
        $this->id = null;
        $this->mod = null;
        $this->name = null;
        $this->inst_addr_sel = null;
        $this->inst_addr_val = null;
        $this->amh_id = null;
        $this->alreadyInSave = false;
        $this->alreadyInValidation = false;
        $this->alreadyInClearAllReferencesDeep = false;
        $this->clearAllReferences();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references to other model objects or collections of model objects.
     *
     * This method is a user-space workaround for PHP's inability to garbage collect
     * objects with circular references (even in PHP 5.3). This is currently necessary
     * when using Propel in certain daemon or large-volume/high-memory operations.
     *
     * @param boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep && !$this->alreadyInClearAllReferencesDeep) {
            $this->alreadyInClearAllReferencesDeep = true;
            if ($this->collCacs) {
                foreach ($this->collCacs as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->aAlarmingManagementHost instanceof Persistent) {
              $this->aAlarmingManagementHost->clearAllReferences($deep);
            }

            $this->alreadyInClearAllReferencesDeep = false;
        } // if ($deep)

        if ($this->collCacs instanceof PropelCollection) {
            $this->collCacs->clearIterator();
        }
        $this->collCacs = null;
        $this->aAlarmingManagementHost = null;
    }

    /**
     * return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(AlarmingManagedObjectPeer::DEFAULT_STRING_FORMAT);
    }

    /**
     * return true is the object is in saving state
     *
     * @return boolean
     */
    public function isAlreadyInSave()
    {
        return $this->alreadyInSave;
    }

}
