<?php


/**
 * Base class that represents a query for the 'alm_man_obj' table.
 *
 *
 *
 * @method AlarmingManagedObjectQuery orderById($order = Criteria::ASC) Order by the id column
 * @method AlarmingManagedObjectQuery orderByMod($order = Criteria::ASC) Order by the mod column
 * @method AlarmingManagedObjectQuery orderByName($order = Criteria::ASC) Order by the name column
 * @method AlarmingManagedObjectQuery orderByInstAddrSel($order = Criteria::ASC) Order by the inst_addr_sel column
 * @method AlarmingManagedObjectQuery orderByInstAddrVal($order = Criteria::ASC) Order by the inst_addr_val column
 * @method AlarmingManagedObjectQuery orderByAmhId($order = Criteria::ASC) Order by the amh_id column
 *
 * @method AlarmingManagedObjectQuery groupById() Group by the id column
 * @method AlarmingManagedObjectQuery groupByMod() Group by the mod column
 * @method AlarmingManagedObjectQuery groupByName() Group by the name column
 * @method AlarmingManagedObjectQuery groupByInstAddrSel() Group by the inst_addr_sel column
 * @method AlarmingManagedObjectQuery groupByInstAddrVal() Group by the inst_addr_val column
 * @method AlarmingManagedObjectQuery groupByAmhId() Group by the amh_id column
 *
 * @method AlarmingManagedObjectQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method AlarmingManagedObjectQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method AlarmingManagedObjectQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method AlarmingManagedObjectQuery leftJoinAlarmingManagementHost($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmingManagementHost relation
 * @method AlarmingManagedObjectQuery rightJoinAlarmingManagementHost($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmingManagementHost relation
 * @method AlarmingManagedObjectQuery innerJoinAlarmingManagementHost($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmingManagementHost relation
 *
 * @method AlarmingManagedObjectQuery leftJoinCac($relationAlias = null) Adds a LEFT JOIN clause to the query using the Cac relation
 * @method AlarmingManagedObjectQuery rightJoinCac($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Cac relation
 * @method AlarmingManagedObjectQuery innerJoinCac($relationAlias = null) Adds a INNER JOIN clause to the query using the Cac relation
 *
 * @method AlarmingManagedObject findOne(PropelPDO $con = null) Return the first AlarmingManagedObject matching the query
 * @method AlarmingManagedObject findOneOrCreate(PropelPDO $con = null) Return the first AlarmingManagedObject matching the query, or a new AlarmingManagedObject object populated from the query conditions when no match is found
 *
 * @method AlarmingManagedObject findOneByMod(int $mod) Return the first AlarmingManagedObject filtered by the mod column
 * @method AlarmingManagedObject findOneByName(string $name) Return the first AlarmingManagedObject filtered by the name column
 * @method AlarmingManagedObject findOneByInstAddrSel(int $inst_addr_sel) Return the first AlarmingManagedObject filtered by the inst_addr_sel column
 * @method AlarmingManagedObject findOneByInstAddrVal(string $inst_addr_val) Return the first AlarmingManagedObject filtered by the inst_addr_val column
 * @method AlarmingManagedObject findOneByAmhId(int $amh_id) Return the first AlarmingManagedObject filtered by the amh_id column
 *
 * @method array findById(int $id) Return AlarmingManagedObject objects filtered by the id column
 * @method array findByMod(int $mod) Return AlarmingManagedObject objects filtered by the mod column
 * @method array findByName(string $name) Return AlarmingManagedObject objects filtered by the name column
 * @method array findByInstAddrSel(int $inst_addr_sel) Return AlarmingManagedObject objects filtered by the inst_addr_sel column
 * @method array findByInstAddrVal(string $inst_addr_val) Return AlarmingManagedObject objects filtered by the inst_addr_val column
 * @method array findByAmhId(int $amh_id) Return AlarmingManagedObject objects filtered by the amh_id column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAlarmingManagedObjectQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseAlarmingManagedObjectQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'AlarmingManagedObject';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new AlarmingManagedObjectQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   AlarmingManagedObjectQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return AlarmingManagedObjectQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof AlarmingManagedObjectQuery) {
            return $criteria;
        }
        $query = new AlarmingManagedObjectQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   AlarmingManagedObject|AlarmingManagedObject[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = AlarmingManagedObjectPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(AlarmingManagedObjectPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AlarmingManagedObject A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AlarmingManagedObject A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `mod`, `name`, `inst_addr_sel`, `inst_addr_val`, `amh_id` FROM `alm_man_obj` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new AlarmingManagedObject();
            $obj->hydrate($row);
            AlarmingManagedObjectPeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return AlarmingManagedObject|AlarmingManagedObject[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|AlarmingManagedObject[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return AlarmingManagedObjectQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(AlarmingManagedObjectPeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return AlarmingManagedObjectQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(AlarmingManagedObjectPeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagedObjectQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(AlarmingManagedObjectPeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(AlarmingManagedObjectPeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmingManagedObjectPeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the mod column
     *
     * Example usage:
     * <code>
     * $query->filterByMod(1234); // WHERE mod = 1234
     * $query->filterByMod(array(12, 34)); // WHERE mod IN (12, 34)
     * $query->filterByMod(array('min' => 12)); // WHERE mod >= 12
     * $query->filterByMod(array('max' => 12)); // WHERE mod <= 12
     * </code>
     *
     * @param     mixed $mod The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagedObjectQuery The current query, for fluid interface
     */
    public function filterByMod($mod = null, $comparison = null)
    {
        if (is_array($mod)) {
            $useMinMax = false;
            if (isset($mod['min'])) {
                $this->addUsingAlias(AlarmingManagedObjectPeer::MOD, $mod['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($mod['max'])) {
                $this->addUsingAlias(AlarmingManagedObjectPeer::MOD, $mod['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmingManagedObjectPeer::MOD, $mod, $comparison);
    }

    /**
     * Filter the query on the name column
     *
     * Example usage:
     * <code>
     * $query->filterByName('fooValue');   // WHERE name = 'fooValue'
     * $query->filterByName('%fooValue%'); // WHERE name LIKE '%fooValue%'
     * </code>
     *
     * @param     string $name The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagedObjectQuery The current query, for fluid interface
     */
    public function filterByName($name = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($name)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $name)) {
                $name = str_replace('*', '%', $name);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AlarmingManagedObjectPeer::NAME, $name, $comparison);
    }

    /**
     * Filter the query on the inst_addr_sel column
     *
     * Example usage:
     * <code>
     * $query->filterByInstAddrSel(1234); // WHERE inst_addr_sel = 1234
     * $query->filterByInstAddrSel(array(12, 34)); // WHERE inst_addr_sel IN (12, 34)
     * $query->filterByInstAddrSel(array('min' => 12)); // WHERE inst_addr_sel >= 12
     * $query->filterByInstAddrSel(array('max' => 12)); // WHERE inst_addr_sel <= 12
     * </code>
     *
     * @param     mixed $instAddrSel The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagedObjectQuery The current query, for fluid interface
     */
    public function filterByInstAddrSel($instAddrSel = null, $comparison = null)
    {
        if (is_array($instAddrSel)) {
            $useMinMax = false;
            if (isset($instAddrSel['min'])) {
                $this->addUsingAlias(AlarmingManagedObjectPeer::INST_ADDR_SEL, $instAddrSel['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($instAddrSel['max'])) {
                $this->addUsingAlias(AlarmingManagedObjectPeer::INST_ADDR_SEL, $instAddrSel['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmingManagedObjectPeer::INST_ADDR_SEL, $instAddrSel, $comparison);
    }

    /**
     * Filter the query on the inst_addr_val column
     *
     * Example usage:
     * <code>
     * $query->filterByInstAddrVal('fooValue');   // WHERE inst_addr_val = 'fooValue'
     * $query->filterByInstAddrVal('%fooValue%'); // WHERE inst_addr_val LIKE '%fooValue%'
     * </code>
     *
     * @param     string $instAddrVal The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagedObjectQuery The current query, for fluid interface
     */
    public function filterByInstAddrVal($instAddrVal = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($instAddrVal)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $instAddrVal)) {
                $instAddrVal = str_replace('*', '%', $instAddrVal);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AlarmingManagedObjectPeer::INST_ADDR_VAL, $instAddrVal, $comparison);
    }

    /**
     * Filter the query on the amh_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAmhId(1234); // WHERE amh_id = 1234
     * $query->filterByAmhId(array(12, 34)); // WHERE amh_id IN (12, 34)
     * $query->filterByAmhId(array('min' => 12)); // WHERE amh_id >= 12
     * $query->filterByAmhId(array('max' => 12)); // WHERE amh_id <= 12
     * </code>
     *
     * @see       filterByAlarmingManagementHost()
     *
     * @param     mixed $amhId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagedObjectQuery The current query, for fluid interface
     */
    public function filterByAmhId($amhId = null, $comparison = null)
    {
        if (is_array($amhId)) {
            $useMinMax = false;
            if (isset($amhId['min'])) {
                $this->addUsingAlias(AlarmingManagedObjectPeer::AMH_ID, $amhId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($amhId['max'])) {
                $this->addUsingAlias(AlarmingManagedObjectPeer::AMH_ID, $amhId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmingManagedObjectPeer::AMH_ID, $amhId, $comparison);
    }

    /**
     * Filter the query by a related AlarmingManagementHost object
     *
     * @param   AlarmingManagementHost|PropelObjectCollection $alarmingManagementHost The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmingManagedObjectQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmingManagementHost($alarmingManagementHost, $comparison = null)
    {
        if ($alarmingManagementHost instanceof AlarmingManagementHost) {
            return $this
                ->addUsingAlias(AlarmingManagedObjectPeer::AMH_ID, $alarmingManagementHost->getId(), $comparison);
        } elseif ($alarmingManagementHost instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(AlarmingManagedObjectPeer::AMH_ID, $alarmingManagementHost->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmingManagementHost() only accepts arguments of type AlarmingManagementHost or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmingManagementHost relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmingManagedObjectQuery The current query, for fluid interface
     */
    public function joinAlarmingManagementHost($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmingManagementHost');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmingManagementHost');
        }

        return $this;
    }

    /**
     * Use the AlarmingManagementHost relation AlarmingManagementHost object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmingManagementHostQuery A secondary query class using the current class as primary query
     */
    public function useAlarmingManagementHostQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmingManagementHost($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmingManagementHost', 'AlarmingManagementHostQuery');
    }

    /**
     * Filter the query by a related CurrentAlarmCondition object
     *
     * @param   CurrentAlarmCondition|PropelObjectCollection $currentAlarmCondition  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmingManagedObjectQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByCac($currentAlarmCondition, $comparison = null)
    {
        if ($currentAlarmCondition instanceof CurrentAlarmCondition) {
            return $this
                ->addUsingAlias(AlarmingManagedObjectPeer::ID, $currentAlarmCondition->getAmoId(), $comparison);
        } elseif ($currentAlarmCondition instanceof PropelObjectCollection) {
            return $this
                ->useCacQuery()
                ->filterByPrimaryKeys($currentAlarmCondition->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByCac() only accepts arguments of type CurrentAlarmCondition or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Cac relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmingManagedObjectQuery The current query, for fluid interface
     */
    public function joinCac($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Cac');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Cac');
        }

        return $this;
    }

    /**
     * Use the Cac relation CurrentAlarmCondition object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   CurrentAlarmConditionQuery A secondary query class using the current class as primary query
     */
    public function useCacQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinCac($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Cac', 'CurrentAlarmConditionQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   AlarmingManagedObject $alarmingManagedObject Object to remove from the list of results
     *
     * @return AlarmingManagedObjectQuery The current query, for fluid interface
     */
    public function prune($alarmingManagedObject = null)
    {
        if ($alarmingManagedObject) {
            $this->addUsingAlias(AlarmingManagedObjectPeer::ID, $alarmingManagedObject->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
