<?php


/**
 * Base class that represents a row from the 'alm_mgmt_host' table.
 *
 *
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAlarmingManagementHost extends BaseObject implements Persistent
{
    /**
     * Peer class name
     */
    const PEER = 'AlarmingManagementHostPeer';

    /**
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var        AlarmingManagementHostPeer
     */
    protected static $peer;

    /**
     * The flag var to prevent infinite loop in deep copy
     * @var       boolean
     */
    protected $startCopy = false;

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the mod field.
     * @var        int
     */
    protected $mod;

    /**
     * The value for the name field.
     * @var        string
     */
    protected $name;

    /**
     * The value for the host_addr_sel field.
     * @var        int
     */
    protected $host_addr_sel;

    /**
     * The value for the host_addr_val field.
     * @var        string
     */
    protected $host_addr_val;

    /**
     * The value for the local field.
     * @var        boolean
     */
    protected $local;

    /**
     * The value for the interface_class field.
     * Note: this column has a database default value of: ''
     * @var        string
     */
    protected $interface_class;

    /**
     * @var        PropelObjectCollection|AlarmingManagedObject[] Collection to store aggregation of AlarmingManagedObject objects.
     */
    protected $collAmos;
    protected $collAmosPartial;

    /**
     * @var        PropelObjectCollection|EscalationHostSelector[] Collection to store aggregation of EscalationHostSelector objects.
     */
    protected $collEhss;
    protected $collEhssPartial;

    /**
     * @var        PropelObjectCollection|DestinationHostSelector[] Collection to store aggregation of DestinationHostSelector objects.
     */
    protected $collDhss;
    protected $collDhssPartial;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInSave = false;

    /**
     * Flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInValidation = false;

    /**
     * Flag to prevent endless clearAllReferences($deep=true) loop, if this object is referenced
     * @var        boolean
     */
    protected $alreadyInClearAllReferencesDeep = false;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $amosScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $ehssScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $dhssScheduledForDeletion = null;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see        __construct()
     */
    public function applyDefaultValues()
    {
        $this->interface_class = '';
    }

    /**
     * Initializes internal state of BaseAlarmingManagementHost object.
     * @see        applyDefaults()
     */
    public function __construct()
    {
        parent::__construct();
        $this->applyDefaultValues();
    }

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {

        return $this->id;
    }

    /**
     * Get the [mod] column value.
     *
     * @return int
     */
    public function getMod()
    {

        return $this->mod;
    }

    /**
     * Get the [name] column value.
     *
     * @return string
     */
    public function getName()
    {

        return $this->name;
    }

    /**
     * Get the [host_addr_sel] column value.
     *
     * @return int
     */
    public function getHostAddrSel()
    {

        return $this->host_addr_sel;
    }

    /**
     * Get the [host_addr_val] column value.
     *
     * @return string
     */
    public function getHostAddrVal()
    {

        return $this->host_addr_val;
    }

    /**
     * Get the [local] column value.
     *
     * @return boolean
     */
    public function getLocal()
    {

        return $this->local;
    }

    /**
     * Get the [interface_class] column value.
     *
     * @return string
     */
    public function getInterfaceClass()
    {

        return $this->interface_class;
    }

    /**
     * Set the value of [id] column.
     *
     * @param  int $v new value
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[] = AlarmingManagementHostPeer::ID;
        }


        return $this;
    } // setId()

    /**
     * Set the value of [mod] column.
     *
     * @param  int $v new value
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function setMod($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->mod !== $v) {
            $this->mod = $v;
            $this->modifiedColumns[] = AlarmingManagementHostPeer::MOD;
        }


        return $this;
    } // setMod()

    /**
     * Set the value of [name] column.
     *
     * @param  string $v new value
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function setName($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->name !== $v) {
            $this->name = $v;
            $this->modifiedColumns[] = AlarmingManagementHostPeer::NAME;
        }


        return $this;
    } // setName()

    /**
     * Set the value of [host_addr_sel] column.
     *
     * @param  int $v new value
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function setHostAddrSel($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->host_addr_sel !== $v) {
            $this->host_addr_sel = $v;
            $this->modifiedColumns[] = AlarmingManagementHostPeer::HOST_ADDR_SEL;
        }


        return $this;
    } // setHostAddrSel()

    /**
     * Set the value of [host_addr_val] column.
     *
     * @param  string $v new value
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function setHostAddrVal($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->host_addr_val !== $v) {
            $this->host_addr_val = $v;
            $this->modifiedColumns[] = AlarmingManagementHostPeer::HOST_ADDR_VAL;
        }


        return $this;
    } // setHostAddrVal()

    /**
     * Sets the value of the [local] column.
     * Non-boolean arguments are converted using the following rules:
     *   * 1, '1', 'true',  'on',  and 'yes' are converted to boolean true
     *   * 0, '0', 'false', 'off', and 'no'  are converted to boolean false
     * Check on string values is case insensitive (so 'FaLsE' is seen as 'false').
     *
     * @param boolean|integer|string $v The new value
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function setLocal($v)
    {
        if ($v !== null) {
            if (is_string($v)) {
                $v = in_array(strtolower($v), array('false', 'off', '-', 'no', 'n', '0', '')) ? false : true;
            } else {
                $v = (boolean) $v;
            }
        }

        if ($this->local !== $v) {
            $this->local = $v;
            $this->modifiedColumns[] = AlarmingManagementHostPeer::LOCAL;
        }


        return $this;
    } // setLocal()

    /**
     * Set the value of [interface_class] column.
     *
     * @param  string $v new value
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function setInterfaceClass($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->interface_class !== $v) {
            $this->interface_class = $v;
            $this->modifiedColumns[] = AlarmingManagementHostPeer::INTERFACE_CLASS;
        }


        return $this;
    } // setInterfaceClass()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
            if ($this->interface_class !== '') {
                return false;
            }

        // otherwise, everything was equal, so return true
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
     * @param int $startcol 0-based offset column which indicates which resultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false)
    {
        try {

            $this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
            $this->mod = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
            $this->name = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
            $this->host_addr_sel = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
            $this->host_addr_val = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
            $this->local = ($row[$startcol + 5] !== null) ? (boolean) $row[$startcol + 5] : null;
            $this->interface_class = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }
            $this->postHydrate($row, $startcol, $rehydrate);

            return $startcol + 7; // 7 = AlarmingManagementHostPeer::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException("Error populating AlarmingManagementHost object", $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {

    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param boolean $deep (optional) Whether to also de-associated any related objects.
     * @param PropelPDO $con (optional) The PropelPDO connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmingManagementHostPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $stmt = AlarmingManagementHostPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
        $row = $stmt->fetch(PDO::FETCH_NUM);
        $stmt->closeCursor();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->collAmos = null;

            $this->collEhss = null;

            $this->collDhss = null;

        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param PropelPDO $con
     * @return void
     * @throws PropelException
     * @throws Exception
     * @see        BaseObject::setDeleted()
     * @see        BaseObject::isDeleted()
     */
    public function delete(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmingManagementHostPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        try {
            $deleteQuery = AlarmingManagementHostQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $con->commit();
                $this->setDeleted(true);
            } else {
                $con->commit();
            }
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @throws Exception
     * @see        doSave()
     */
    public function save(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(AlarmingManagementHostPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        $isInsert = $this->isNew();
        try {
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                AlarmingManagementHostPeer::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see        save()
     */
    protected function doSave(PropelPDO $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                } else {
                    $this->doUpdate($con);
                }
                $affectedRows += 1;
                $this->resetModified();
            }

            if ($this->amosScheduledForDeletion !== null) {
                if (!$this->amosScheduledForDeletion->isEmpty()) {
                    AlarmingManagedObjectQuery::create()
                        ->filterByPrimaryKeys($this->amosScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->amosScheduledForDeletion = null;
                }
            }

            if ($this->collAmos !== null) {
                foreach ($this->collAmos as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->ehssScheduledForDeletion !== null) {
                if (!$this->ehssScheduledForDeletion->isEmpty()) {
                    EscalationHostSelectorQuery::create()
                        ->filterByPrimaryKeys($this->ehssScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->ehssScheduledForDeletion = null;
                }
            }

            if ($this->collEhss !== null) {
                foreach ($this->collEhss as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->dhssScheduledForDeletion !== null) {
                if (!$this->dhssScheduledForDeletion->isEmpty()) {
                    DestinationHostSelectorQuery::create()
                        ->filterByPrimaryKeys($this->dhssScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->dhssScheduledForDeletion = null;
                }
            }

            if ($this->collDhss !== null) {
                foreach ($this->collDhss as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param PropelPDO $con
     *
     * @throws PropelException
     * @see        doSave()
     */
    protected function doInsert(PropelPDO $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[] = AlarmingManagementHostPeer::ID;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . AlarmingManagementHostPeer::ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(AlarmingManagementHostPeer::ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(AlarmingManagementHostPeer::MOD)) {
            $modifiedColumns[':p' . $index++]  = '`mod`';
        }
        if ($this->isColumnModified(AlarmingManagementHostPeer::NAME)) {
            $modifiedColumns[':p' . $index++]  = '`name`';
        }
        if ($this->isColumnModified(AlarmingManagementHostPeer::HOST_ADDR_SEL)) {
            $modifiedColumns[':p' . $index++]  = '`host_addr_sel`';
        }
        if ($this->isColumnModified(AlarmingManagementHostPeer::HOST_ADDR_VAL)) {
            $modifiedColumns[':p' . $index++]  = '`host_addr_val`';
        }
        if ($this->isColumnModified(AlarmingManagementHostPeer::LOCAL)) {
            $modifiedColumns[':p' . $index++]  = '`local`';
        }
        if ($this->isColumnModified(AlarmingManagementHostPeer::INTERFACE_CLASS)) {
            $modifiedColumns[':p' . $index++]  = '`interface_class`';
        }

        $sql = sprintf(
            'INSERT INTO `alm_mgmt_host` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`mod`':
                        $stmt->bindValue($identifier, $this->mod, PDO::PARAM_INT);
                        break;
                    case '`name`':
                        $stmt->bindValue($identifier, $this->name, PDO::PARAM_STR);
                        break;
                    case '`host_addr_sel`':
                        $stmt->bindValue($identifier, $this->host_addr_sel, PDO::PARAM_INT);
                        break;
                    case '`host_addr_val`':
                        $stmt->bindValue($identifier, $this->host_addr_val, PDO::PARAM_STR);
                        break;
                    case '`local`':
                        $stmt->bindValue($identifier, (int) $this->local, PDO::PARAM_INT);
                        break;
                    case '`interface_class`':
                        $stmt->bindValue($identifier, $this->interface_class, PDO::PARAM_STR);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param PropelPDO $con
     *
     * @see        doSave()
     */
    protected function doUpdate(PropelPDO $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();
        BasePeer::doUpdate($selectCriteria, $valuesCriteria, $con);
    }

    /**
     * Array of ValidationFailed objects.
     * @var        array ValidationFailed[]
     */
    protected $validationFailures = array();

    /**
     * Gets any ValidationFailed objects that resulted from last call to validate().
     *
     *
     * @return array ValidationFailed[]
     * @see        validate()
     */
    public function getValidationFailures()
    {
        return $this->validationFailures;
    }

    /**
     * Validates the objects modified field values and all objects related to this table.
     *
     * If $columns is either a column name or an array of column names
     * only those columns are validated.
     *
     * @param mixed $columns Column name or an array of column names.
     * @return boolean Whether all columns pass validation.
     * @see        doValidate()
     * @see        getValidationFailures()
     */
    public function validate($columns = null)
    {
        $res = $this->doValidate($columns);
        if ($res === true) {
            $this->validationFailures = array();

            return true;
        }

        $this->validationFailures = $res;

        return false;
    }

    /**
     * This function performs the validation work for complex object models.
     *
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggregated array of ValidationFailed objects will be returned.
     *
     * @param array $columns Array of column names to validate.
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objects otherwise.
     */
    protected function doValidate($columns = null)
    {
        if (!$this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;

            $failureMap = array();


            if (($retval = AlarmingManagementHostPeer::doValidate($this, $columns)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }


                if ($this->collAmos !== null) {
                    foreach ($this->collAmos as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }

                if ($this->collEhss !== null) {
                    foreach ($this->collEhss as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }

                if ($this->collDhss !== null) {
                    foreach ($this->collDhss as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }


            $this->alreadyInValidation = false;
        }

        return (!empty($failureMap) ? $failureMap : true);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param string $name name
     * @param string $type The type of fieldname the $name is of:
     *               one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *               BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *               Defaults to BasePeer::TYPE_PHPNAME
     * @return mixed Value of field.
     */
    public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = AlarmingManagementHostPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getMod();
                break;
            case 2:
                return $this->getName();
                break;
            case 3:
                return $this->getHostAddrSel();
                break;
            case 4:
                return $this->getHostAddrVal();
                break;
            case 5:
                return $this->getLocal();
                break;
            case 6:
                return $this->getInterfaceClass();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     *                    BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                    Defaults to BasePeer::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to true.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {
        if (isset($alreadyDumpedObjects['AlarmingManagementHost'][$this->getPrimaryKey()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['AlarmingManagementHost'][$this->getPrimaryKey()] = true;
        $keys = AlarmingManagementHostPeer::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getMod(),
            $keys[2] => $this->getName(),
            $keys[3] => $this->getHostAddrSel(),
            $keys[4] => $this->getHostAddrVal(),
            $keys[5] => $this->getLocal(),
            $keys[6] => $this->getInterfaceClass(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->collAmos) {
                $result['Amos'] = $this->collAmos->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collEhss) {
                $result['Ehss'] = $this->collEhss->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collDhss) {
                $result['Dhss'] = $this->collDhss->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param string $name peer name
     * @param mixed $value field value
     * @param string $type The type of fieldname the $name is of:
     *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                     Defaults to BasePeer::TYPE_PHPNAME
     * @return void
     */
    public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = AlarmingManagementHostPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);

        $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @param mixed $value field value
     * @return void
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setMod($value);
                break;
            case 2:
                $this->setName($value);
                break;
            case 3:
                $this->setHostAddrSel($value);
                break;
            case 4:
                $this->setHostAddrVal($value);
                break;
            case 5:
                $this->setLocal($value);
                break;
            case 6:
                $this->setInterfaceClass($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     * The default key type is the column's BasePeer::TYPE_PHPNAME
     *
     * @param array  $arr     An array to populate the object from.
     * @param string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
    {
        $keys = AlarmingManagementHostPeer::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
        if (array_key_exists($keys[1], $arr)) $this->setMod($arr[$keys[1]]);
        if (array_key_exists($keys[2], $arr)) $this->setName($arr[$keys[2]]);
        if (array_key_exists($keys[3], $arr)) $this->setHostAddrSel($arr[$keys[3]]);
        if (array_key_exists($keys[4], $arr)) $this->setHostAddrVal($arr[$keys[4]]);
        if (array_key_exists($keys[5], $arr)) $this->setLocal($arr[$keys[5]]);
        if (array_key_exists($keys[6], $arr)) $this->setInterfaceClass($arr[$keys[6]]);
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(AlarmingManagementHostPeer::DATABASE_NAME);

        if ($this->isColumnModified(AlarmingManagementHostPeer::ID)) $criteria->add(AlarmingManagementHostPeer::ID, $this->id);
        if ($this->isColumnModified(AlarmingManagementHostPeer::MOD)) $criteria->add(AlarmingManagementHostPeer::MOD, $this->mod);
        if ($this->isColumnModified(AlarmingManagementHostPeer::NAME)) $criteria->add(AlarmingManagementHostPeer::NAME, $this->name);
        if ($this->isColumnModified(AlarmingManagementHostPeer::HOST_ADDR_SEL)) $criteria->add(AlarmingManagementHostPeer::HOST_ADDR_SEL, $this->host_addr_sel);
        if ($this->isColumnModified(AlarmingManagementHostPeer::HOST_ADDR_VAL)) $criteria->add(AlarmingManagementHostPeer::HOST_ADDR_VAL, $this->host_addr_val);
        if ($this->isColumnModified(AlarmingManagementHostPeer::LOCAL)) $criteria->add(AlarmingManagementHostPeer::LOCAL, $this->local);
        if ($this->isColumnModified(AlarmingManagementHostPeer::INTERFACE_CLASS)) $criteria->add(AlarmingManagementHostPeer::INTERFACE_CLASS, $this->interface_class);

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(AlarmingManagementHostPeer::DATABASE_NAME);
        $criteria->add(AlarmingManagementHostPeer::ID, $this->id);

        return $criteria;
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param  int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {

        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param object $copyObj An object of AlarmingManagementHost (or compatible) type.
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setMod($this->getMod());
        $copyObj->setName($this->getName());
        $copyObj->setHostAddrSel($this->getHostAddrSel());
        $copyObj->setHostAddrVal($this->getHostAddrVal());
        $copyObj->setLocal($this->getLocal());
        $copyObj->setInterfaceClass($this->getInterfaceClass());

        if ($deepCopy && !$this->startCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);
            // store object hash to prevent cycle
            $this->startCopy = true;

            foreach ($this->getAmos() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addAmo($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getEhss() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addEhs($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getDhss() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addDhs($relObj->copy($deepCopy));
                }
            }

            //unflag object copy
            $this->startCopy = false;
        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return AlarmingManagementHost Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Returns a peer instance associated with this om.
     *
     * Since Peer classes are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     *
     * @return AlarmingManagementHostPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new AlarmingManagementHostPeer();
        }

        return self::$peer;
    }


    /**
     * Initializes a collection based on the name of a relation.
     * Avoids crafting an 'init[$relationName]s' method name
     * that wouldn't work when StandardEnglishPluralizer is used.
     *
     * @param string $relationName The name of the relation to initialize
     * @return void
     */
    public function initRelation($relationName)
    {
        if ('Amo' == $relationName) {
            $this->initAmos();
        }
        if ('Ehs' == $relationName) {
            $this->initEhss();
        }
        if ('Dhs' == $relationName) {
            $this->initDhss();
        }
    }

    /**
     * Clears out the collAmos collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return AlarmingManagementHost The current object (for fluent API support)
     * @see        addAmos()
     */
    public function clearAmos()
    {
        $this->collAmos = null; // important to set this to null since that means it is uninitialized
        $this->collAmosPartial = null;

        return $this;
    }

    /**
     * reset is the collAmos collection loaded partially
     *
     * @return void
     */
    public function resetPartialAmos($v = true)
    {
        $this->collAmosPartial = $v;
    }

    /**
     * Initializes the collAmos collection.
     *
     * By default this just sets the collAmos collection to an empty array (like clearcollAmos());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initAmos($overrideExisting = true)
    {
        if (null !== $this->collAmos && !$overrideExisting) {
            return;
        }
        $this->collAmos = new PropelObjectCollection();
        $this->collAmos->setModel('AlarmingManagedObject');
    }

    /**
     * Gets an array of AlarmingManagedObject objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this AlarmingManagementHost is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|AlarmingManagedObject[] List of AlarmingManagedObject objects
     * @throws PropelException
     */
    public function getAmos($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collAmosPartial && !$this->isNew();
        if (null === $this->collAmos || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collAmos) {
                // return empty collection
                $this->initAmos();
            } else {
                $collAmos = AlarmingManagedObjectQuery::create(null, $criteria)
                    ->filterByAlarmingManagementHost($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collAmosPartial && count($collAmos)) {
                      $this->initAmos(false);

                      foreach ($collAmos as $obj) {
                        if (false == $this->collAmos->contains($obj)) {
                          $this->collAmos->append($obj);
                        }
                      }

                      $this->collAmosPartial = true;
                    }

                    $collAmos->getInternalIterator()->rewind();

                    return $collAmos;
                }

                if ($partial && $this->collAmos) {
                    foreach ($this->collAmos as $obj) {
                        if ($obj->isNew()) {
                            $collAmos[] = $obj;
                        }
                    }
                }

                $this->collAmos = $collAmos;
                $this->collAmosPartial = false;
            }
        }

        return $this->collAmos;
    }

    /**
     * Sets a collection of Amo objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $amos A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function setAmos(PropelCollection $amos, PropelPDO $con = null)
    {
        $amosToDelete = $this->getAmos(new Criteria(), $con)->diff($amos);


        $this->amosScheduledForDeletion = $amosToDelete;

        foreach ($amosToDelete as $amoRemoved) {
            $amoRemoved->setAlarmingManagementHost(null);
        }

        $this->collAmos = null;
        foreach ($amos as $amo) {
            $this->addAmo($amo);
        }

        $this->collAmos = $amos;
        $this->collAmosPartial = false;

        return $this;
    }

    /**
     * Returns the number of related AlarmingManagedObject objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related AlarmingManagedObject objects.
     * @throws PropelException
     */
    public function countAmos(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collAmosPartial && !$this->isNew();
        if (null === $this->collAmos || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collAmos) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getAmos());
            }
            $query = AlarmingManagedObjectQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByAlarmingManagementHost($this)
                ->count($con);
        }

        return count($this->collAmos);
    }

    /**
     * Method called to associate a AlarmingManagedObject object to this object
     * through the AlarmingManagedObject foreign key attribute.
     *
     * @param    AlarmingManagedObject $l AlarmingManagedObject
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function addAmo(AlarmingManagedObject $l)
    {
        if ($this->collAmos === null) {
            $this->initAmos();
            $this->collAmosPartial = true;
        }

        if (!in_array($l, $this->collAmos->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddAmo($l);

            if ($this->amosScheduledForDeletion and $this->amosScheduledForDeletion->contains($l)) {
                $this->amosScheduledForDeletion->remove($this->amosScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	Amo $amo The amo object to add.
     */
    protected function doAddAmo($amo)
    {
        $this->collAmos[]= $amo;
        $amo->setAlarmingManagementHost($this);
    }

    /**
     * @param	Amo $amo The amo object to remove.
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function removeAmo($amo)
    {
        if ($this->getAmos()->contains($amo)) {
            $this->collAmos->remove($this->collAmos->search($amo));
            if (null === $this->amosScheduledForDeletion) {
                $this->amosScheduledForDeletion = clone $this->collAmos;
                $this->amosScheduledForDeletion->clear();
            }
            $this->amosScheduledForDeletion[]= clone $amo;
            $amo->setAlarmingManagementHost(null);
        }

        return $this;
    }

    /**
     * Clears out the collEhss collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return AlarmingManagementHost The current object (for fluent API support)
     * @see        addEhss()
     */
    public function clearEhss()
    {
        $this->collEhss = null; // important to set this to null since that means it is uninitialized
        $this->collEhssPartial = null;

        return $this;
    }

    /**
     * reset is the collEhss collection loaded partially
     *
     * @return void
     */
    public function resetPartialEhss($v = true)
    {
        $this->collEhssPartial = $v;
    }

    /**
     * Initializes the collEhss collection.
     *
     * By default this just sets the collEhss collection to an empty array (like clearcollEhss());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initEhss($overrideExisting = true)
    {
        if (null !== $this->collEhss && !$overrideExisting) {
            return;
        }
        $this->collEhss = new PropelObjectCollection();
        $this->collEhss->setModel('EscalationHostSelector');
    }

    /**
     * Gets an array of EscalationHostSelector objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this AlarmingManagementHost is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|EscalationHostSelector[] List of EscalationHostSelector objects
     * @throws PropelException
     */
    public function getEhss($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collEhssPartial && !$this->isNew();
        if (null === $this->collEhss || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collEhss) {
                // return empty collection
                $this->initEhss();
            } else {
                $collEhss = EscalationHostSelectorQuery::create(null, $criteria)
                    ->filterByAlarmingManagementHost($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collEhssPartial && count($collEhss)) {
                      $this->initEhss(false);

                      foreach ($collEhss as $obj) {
                        if (false == $this->collEhss->contains($obj)) {
                          $this->collEhss->append($obj);
                        }
                      }

                      $this->collEhssPartial = true;
                    }

                    $collEhss->getInternalIterator()->rewind();

                    return $collEhss;
                }

                if ($partial && $this->collEhss) {
                    foreach ($this->collEhss as $obj) {
                        if ($obj->isNew()) {
                            $collEhss[] = $obj;
                        }
                    }
                }

                $this->collEhss = $collEhss;
                $this->collEhssPartial = false;
            }
        }

        return $this->collEhss;
    }

    /**
     * Sets a collection of Ehs objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $ehss A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function setEhss(PropelCollection $ehss, PropelPDO $con = null)
    {
        $ehssToDelete = $this->getEhss(new Criteria(), $con)->diff($ehss);


        $this->ehssScheduledForDeletion = $ehssToDelete;

        foreach ($ehssToDelete as $ehsRemoved) {
            $ehsRemoved->setAlarmingManagementHost(null);
        }

        $this->collEhss = null;
        foreach ($ehss as $ehs) {
            $this->addEhs($ehs);
        }

        $this->collEhss = $ehss;
        $this->collEhssPartial = false;

        return $this;
    }

    /**
     * Returns the number of related EscalationHostSelector objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related EscalationHostSelector objects.
     * @throws PropelException
     */
    public function countEhss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collEhssPartial && !$this->isNew();
        if (null === $this->collEhss || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collEhss) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getEhss());
            }
            $query = EscalationHostSelectorQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByAlarmingManagementHost($this)
                ->count($con);
        }

        return count($this->collEhss);
    }

    /**
     * Method called to associate a EscalationHostSelector object to this object
     * through the EscalationHostSelector foreign key attribute.
     *
     * @param    EscalationHostSelector $l EscalationHostSelector
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function addEhs(EscalationHostSelector $l)
    {
        if ($this->collEhss === null) {
            $this->initEhss();
            $this->collEhssPartial = true;
        }

        if (!in_array($l, $this->collEhss->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddEhs($l);

            if ($this->ehssScheduledForDeletion and $this->ehssScheduledForDeletion->contains($l)) {
                $this->ehssScheduledForDeletion->remove($this->ehssScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	Ehs $ehs The ehs object to add.
     */
    protected function doAddEhs($ehs)
    {
        $this->collEhss[]= $ehs;
        $ehs->setAlarmingManagementHost($this);
    }

    /**
     * @param	Ehs $ehs The ehs object to remove.
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function removeEhs($ehs)
    {
        if ($this->getEhss()->contains($ehs)) {
            $this->collEhss->remove($this->collEhss->search($ehs));
            if (null === $this->ehssScheduledForDeletion) {
                $this->ehssScheduledForDeletion = clone $this->collEhss;
                $this->ehssScheduledForDeletion->clear();
            }
            $this->ehssScheduledForDeletion[]= clone $ehs;
            $ehs->setAlarmingManagementHost(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this AlarmingManagementHost is new, it will return
     * an empty collection; or if this AlarmingManagementHost has previously
     * been saved, it will retrieve related Ehss from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in AlarmingManagementHost.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @param string $join_behavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return PropelObjectCollection|EscalationHostSelector[] List of EscalationHostSelector objects
     */
    public function getEhssJoinAlarmBalanceMonitor($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $query = EscalationHostSelectorQuery::create(null, $criteria);
        $query->joinWith('AlarmBalanceMonitor', $join_behavior);

        return $this->getEhss($query, $con);
    }

    /**
     * Clears out the collDhss collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return AlarmingManagementHost The current object (for fluent API support)
     * @see        addDhss()
     */
    public function clearDhss()
    {
        $this->collDhss = null; // important to set this to null since that means it is uninitialized
        $this->collDhssPartial = null;

        return $this;
    }

    /**
     * reset is the collDhss collection loaded partially
     *
     * @return void
     */
    public function resetPartialDhss($v = true)
    {
        $this->collDhssPartial = $v;
    }

    /**
     * Initializes the collDhss collection.
     *
     * By default this just sets the collDhss collection to an empty array (like clearcollDhss());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initDhss($overrideExisting = true)
    {
        if (null !== $this->collDhss && !$overrideExisting) {
            return;
        }
        $this->collDhss = new PropelObjectCollection();
        $this->collDhss->setModel('DestinationHostSelector');
    }

    /**
     * Gets an array of DestinationHostSelector objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this AlarmingManagementHost is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|DestinationHostSelector[] List of DestinationHostSelector objects
     * @throws PropelException
     */
    public function getDhss($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collDhssPartial && !$this->isNew();
        if (null === $this->collDhss || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collDhss) {
                // return empty collection
                $this->initDhss();
            } else {
                $collDhss = DestinationHostSelectorQuery::create(null, $criteria)
                    ->filterByAlarmingManagementHost($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collDhssPartial && count($collDhss)) {
                      $this->initDhss(false);

                      foreach ($collDhss as $obj) {
                        if (false == $this->collDhss->contains($obj)) {
                          $this->collDhss->append($obj);
                        }
                      }

                      $this->collDhssPartial = true;
                    }

                    $collDhss->getInternalIterator()->rewind();

                    return $collDhss;
                }

                if ($partial && $this->collDhss) {
                    foreach ($this->collDhss as $obj) {
                        if ($obj->isNew()) {
                            $collDhss[] = $obj;
                        }
                    }
                }

                $this->collDhss = $collDhss;
                $this->collDhssPartial = false;
            }
        }

        return $this->collDhss;
    }

    /**
     * Sets a collection of Dhs objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $dhss A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function setDhss(PropelCollection $dhss, PropelPDO $con = null)
    {
        $dhssToDelete = $this->getDhss(new Criteria(), $con)->diff($dhss);


        $this->dhssScheduledForDeletion = $dhssToDelete;

        foreach ($dhssToDelete as $dhsRemoved) {
            $dhsRemoved->setAlarmingManagementHost(null);
        }

        $this->collDhss = null;
        foreach ($dhss as $dhs) {
            $this->addDhs($dhs);
        }

        $this->collDhss = $dhss;
        $this->collDhssPartial = false;

        return $this;
    }

    /**
     * Returns the number of related DestinationHostSelector objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related DestinationHostSelector objects.
     * @throws PropelException
     */
    public function countDhss(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collDhssPartial && !$this->isNew();
        if (null === $this->collDhss || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collDhss) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getDhss());
            }
            $query = DestinationHostSelectorQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByAlarmingManagementHost($this)
                ->count($con);
        }

        return count($this->collDhss);
    }

    /**
     * Method called to associate a DestinationHostSelector object to this object
     * through the DestinationHostSelector foreign key attribute.
     *
     * @param    DestinationHostSelector $l DestinationHostSelector
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function addDhs(DestinationHostSelector $l)
    {
        if ($this->collDhss === null) {
            $this->initDhss();
            $this->collDhssPartial = true;
        }

        if (!in_array($l, $this->collDhss->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddDhs($l);

            if ($this->dhssScheduledForDeletion and $this->dhssScheduledForDeletion->contains($l)) {
                $this->dhssScheduledForDeletion->remove($this->dhssScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	Dhs $dhs The dhs object to add.
     */
    protected function doAddDhs($dhs)
    {
        $this->collDhss[]= $dhs;
        $dhs->setAlarmingManagementHost($this);
    }

    /**
     * @param	Dhs $dhs The dhs object to remove.
     * @return AlarmingManagementHost The current object (for fluent API support)
     */
    public function removeDhs($dhs)
    {
        if ($this->getDhss()->contains($dhs)) {
            $this->collDhss->remove($this->collDhss->search($dhs));
            if (null === $this->dhssScheduledForDeletion) {
                $this->dhssScheduledForDeletion = clone $this->collDhss;
                $this->dhssScheduledForDeletion->clear();
            }
            $this->dhssScheduledForDeletion[]= clone $dhs;
            $dhs->setAlarmingManagementHost(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this AlarmingManagementHost is new, it will return
     * an empty collection; or if this AlarmingManagementHost has previously
     * been saved, it will retrieve related Dhss from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in AlarmingManagementHost.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @param string $join_behavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return PropelObjectCollection|DestinationHostSelector[] List of DestinationHostSelector objects
     */
    public function getDhssJoinAlarmForwardingInstruction($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $query = DestinationHostSelectorQuery::create(null, $criteria);
        $query->joinWith('AlarmForwardingInstruction', $join_behavior);

        return $this->getDhss($query, $con);
    }

    /**
     * Clears the current object and sets all attributes to their default values
     */
    public function clear()
    {
        $this->id = null;
        $this->mod = null;
        $this->name = null;
        $this->host_addr_sel = null;
        $this->host_addr_val = null;
        $this->local = null;
        $this->interface_class = null;
        $this->alreadyInSave = false;
        $this->alreadyInValidation = false;
        $this->alreadyInClearAllReferencesDeep = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references to other model objects or collections of model objects.
     *
     * This method is a user-space workaround for PHP's inability to garbage collect
     * objects with circular references (even in PHP 5.3). This is currently necessary
     * when using Propel in certain daemon or large-volume/high-memory operations.
     *
     * @param boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep && !$this->alreadyInClearAllReferencesDeep) {
            $this->alreadyInClearAllReferencesDeep = true;
            if ($this->collAmos) {
                foreach ($this->collAmos as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collEhss) {
                foreach ($this->collEhss as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collDhss) {
                foreach ($this->collDhss as $o) {
                    $o->clearAllReferences($deep);
                }
            }

            $this->alreadyInClearAllReferencesDeep = false;
        } // if ($deep)

        if ($this->collAmos instanceof PropelCollection) {
            $this->collAmos->clearIterator();
        }
        $this->collAmos = null;
        if ($this->collEhss instanceof PropelCollection) {
            $this->collEhss->clearIterator();
        }
        $this->collEhss = null;
        if ($this->collDhss instanceof PropelCollection) {
            $this->collDhss->clearIterator();
        }
        $this->collDhss = null;
    }

    /**
     * return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(AlarmingManagementHostPeer::DEFAULT_STRING_FORMAT);
    }

    /**
     * return true is the object is in saving state
     *
     * @return boolean
     */
    public function isAlreadyInSave()
    {
        return $this->alreadyInSave;
    }

}
