<?php


/**
 * Base class that represents a query for the 'alm_mgmt_host' table.
 *
 *
 *
 * @method AlarmingManagementHostQuery orderById($order = Criteria::ASC) Order by the id column
 * @method AlarmingManagementHostQuery orderByMod($order = Criteria::ASC) Order by the mod column
 * @method AlarmingManagementHostQuery orderByName($order = Criteria::ASC) Order by the name column
 * @method AlarmingManagementHostQuery orderByHostAddrSel($order = Criteria::ASC) Order by the host_addr_sel column
 * @method AlarmingManagementHostQuery orderByHostAddrVal($order = Criteria::ASC) Order by the host_addr_val column
 * @method AlarmingManagementHostQuery orderByLocal($order = Criteria::ASC) Order by the local column
 * @method AlarmingManagementHostQuery orderByInterfaceClass($order = Criteria::ASC) Order by the interface_class column
 *
 * @method AlarmingManagementHostQuery groupById() Group by the id column
 * @method AlarmingManagementHostQuery groupByMod() Group by the mod column
 * @method AlarmingManagementHostQuery groupByName() Group by the name column
 * @method AlarmingManagementHostQuery groupByHostAddrSel() Group by the host_addr_sel column
 * @method AlarmingManagementHostQuery groupByHostAddrVal() Group by the host_addr_val column
 * @method AlarmingManagementHostQuery groupByLocal() Group by the local column
 * @method AlarmingManagementHostQuery groupByInterfaceClass() Group by the interface_class column
 *
 * @method AlarmingManagementHostQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method AlarmingManagementHostQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method AlarmingManagementHostQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method AlarmingManagementHostQuery leftJoinAmo($relationAlias = null) Adds a LEFT JOIN clause to the query using the Amo relation
 * @method AlarmingManagementHostQuery rightJoinAmo($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Amo relation
 * @method AlarmingManagementHostQuery innerJoinAmo($relationAlias = null) Adds a INNER JOIN clause to the query using the Amo relation
 *
 * @method AlarmingManagementHostQuery leftJoinEhs($relationAlias = null) Adds a LEFT JOIN clause to the query using the Ehs relation
 * @method AlarmingManagementHostQuery rightJoinEhs($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Ehs relation
 * @method AlarmingManagementHostQuery innerJoinEhs($relationAlias = null) Adds a INNER JOIN clause to the query using the Ehs relation
 *
 * @method AlarmingManagementHostQuery leftJoinDhs($relationAlias = null) Adds a LEFT JOIN clause to the query using the Dhs relation
 * @method AlarmingManagementHostQuery rightJoinDhs($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Dhs relation
 * @method AlarmingManagementHostQuery innerJoinDhs($relationAlias = null) Adds a INNER JOIN clause to the query using the Dhs relation
 *
 * @method AlarmingManagementHost findOne(PropelPDO $con = null) Return the first AlarmingManagementHost matching the query
 * @method AlarmingManagementHost findOneOrCreate(PropelPDO $con = null) Return the first AlarmingManagementHost matching the query, or a new AlarmingManagementHost object populated from the query conditions when no match is found
 *
 * @method AlarmingManagementHost findOneByMod(int $mod) Return the first AlarmingManagementHost filtered by the mod column
 * @method AlarmingManagementHost findOneByName(string $name) Return the first AlarmingManagementHost filtered by the name column
 * @method AlarmingManagementHost findOneByHostAddrSel(int $host_addr_sel) Return the first AlarmingManagementHost filtered by the host_addr_sel column
 * @method AlarmingManagementHost findOneByHostAddrVal(string $host_addr_val) Return the first AlarmingManagementHost filtered by the host_addr_val column
 * @method AlarmingManagementHost findOneByLocal(boolean $local) Return the first AlarmingManagementHost filtered by the local column
 * @method AlarmingManagementHost findOneByInterfaceClass(string $interface_class) Return the first AlarmingManagementHost filtered by the interface_class column
 *
 * @method array findById(int $id) Return AlarmingManagementHost objects filtered by the id column
 * @method array findByMod(int $mod) Return AlarmingManagementHost objects filtered by the mod column
 * @method array findByName(string $name) Return AlarmingManagementHost objects filtered by the name column
 * @method array findByHostAddrSel(int $host_addr_sel) Return AlarmingManagementHost objects filtered by the host_addr_sel column
 * @method array findByHostAddrVal(string $host_addr_val) Return AlarmingManagementHost objects filtered by the host_addr_val column
 * @method array findByLocal(boolean $local) Return AlarmingManagementHost objects filtered by the local column
 * @method array findByInterfaceClass(string $interface_class) Return AlarmingManagementHost objects filtered by the interface_class column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAlarmingManagementHostQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseAlarmingManagementHostQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'AlarmingManagementHost';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new AlarmingManagementHostQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   AlarmingManagementHostQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return AlarmingManagementHostQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof AlarmingManagementHostQuery) {
            return $criteria;
        }
        $query = new AlarmingManagementHostQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   AlarmingManagementHost|AlarmingManagementHost[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = AlarmingManagementHostPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(AlarmingManagementHostPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AlarmingManagementHost A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AlarmingManagementHost A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `mod`, `name`, `host_addr_sel`, `host_addr_val`, `local`, `interface_class` FROM `alm_mgmt_host` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new AlarmingManagementHost();
            $obj->hydrate($row);
            AlarmingManagementHostPeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return AlarmingManagementHost|AlarmingManagementHost[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|AlarmingManagementHost[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(AlarmingManagementHostPeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(AlarmingManagementHostPeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(AlarmingManagementHostPeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(AlarmingManagementHostPeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmingManagementHostPeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the mod column
     *
     * Example usage:
     * <code>
     * $query->filterByMod(1234); // WHERE mod = 1234
     * $query->filterByMod(array(12, 34)); // WHERE mod IN (12, 34)
     * $query->filterByMod(array('min' => 12)); // WHERE mod >= 12
     * $query->filterByMod(array('max' => 12)); // WHERE mod <= 12
     * </code>
     *
     * @param     mixed $mod The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function filterByMod($mod = null, $comparison = null)
    {
        if (is_array($mod)) {
            $useMinMax = false;
            if (isset($mod['min'])) {
                $this->addUsingAlias(AlarmingManagementHostPeer::MOD, $mod['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($mod['max'])) {
                $this->addUsingAlias(AlarmingManagementHostPeer::MOD, $mod['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmingManagementHostPeer::MOD, $mod, $comparison);
    }

    /**
     * Filter the query on the name column
     *
     * Example usage:
     * <code>
     * $query->filterByName('fooValue');   // WHERE name = 'fooValue'
     * $query->filterByName('%fooValue%'); // WHERE name LIKE '%fooValue%'
     * </code>
     *
     * @param     string $name The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function filterByName($name = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($name)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $name)) {
                $name = str_replace('*', '%', $name);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AlarmingManagementHostPeer::NAME, $name, $comparison);
    }

    /**
     * Filter the query on the host_addr_sel column
     *
     * Example usage:
     * <code>
     * $query->filterByHostAddrSel(1234); // WHERE host_addr_sel = 1234
     * $query->filterByHostAddrSel(array(12, 34)); // WHERE host_addr_sel IN (12, 34)
     * $query->filterByHostAddrSel(array('min' => 12)); // WHERE host_addr_sel >= 12
     * $query->filterByHostAddrSel(array('max' => 12)); // WHERE host_addr_sel <= 12
     * </code>
     *
     * @param     mixed $hostAddrSel The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function filterByHostAddrSel($hostAddrSel = null, $comparison = null)
    {
        if (is_array($hostAddrSel)) {
            $useMinMax = false;
            if (isset($hostAddrSel['min'])) {
                $this->addUsingAlias(AlarmingManagementHostPeer::HOST_ADDR_SEL, $hostAddrSel['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($hostAddrSel['max'])) {
                $this->addUsingAlias(AlarmingManagementHostPeer::HOST_ADDR_SEL, $hostAddrSel['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AlarmingManagementHostPeer::HOST_ADDR_SEL, $hostAddrSel, $comparison);
    }

    /**
     * Filter the query on the host_addr_val column
     *
     * Example usage:
     * <code>
     * $query->filterByHostAddrVal('fooValue');   // WHERE host_addr_val = 'fooValue'
     * $query->filterByHostAddrVal('%fooValue%'); // WHERE host_addr_val LIKE '%fooValue%'
     * </code>
     *
     * @param     string $hostAddrVal The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function filterByHostAddrVal($hostAddrVal = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($hostAddrVal)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $hostAddrVal)) {
                $hostAddrVal = str_replace('*', '%', $hostAddrVal);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AlarmingManagementHostPeer::HOST_ADDR_VAL, $hostAddrVal, $comparison);
    }

    /**
     * Filter the query on the local column
     *
     * Example usage:
     * <code>
     * $query->filterByLocal(true); // WHERE local = true
     * $query->filterByLocal('yes'); // WHERE local = true
     * </code>
     *
     * @param     boolean|string $local The value to use as filter.
     *              Non-boolean arguments are converted using the following rules:
     *                * 1, '1', 'true',  'on',  and 'yes' are converted to boolean true
     *                * 0, '0', 'false', 'off', and 'no'  are converted to boolean false
     *              Check on string values is case insensitive (so 'FaLsE' is seen as 'false').
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function filterByLocal($local = null, $comparison = null)
    {
        if (is_string($local)) {
            $local = in_array(strtolower($local), array('false', 'off', '-', 'no', 'n', '0', '')) ? false : true;
        }

        return $this->addUsingAlias(AlarmingManagementHostPeer::LOCAL, $local, $comparison);
    }

    /**
     * Filter the query on the interface_class column
     *
     * Example usage:
     * <code>
     * $query->filterByInterfaceClass('fooValue');   // WHERE interface_class = 'fooValue'
     * $query->filterByInterfaceClass('%fooValue%'); // WHERE interface_class LIKE '%fooValue%'
     * </code>
     *
     * @param     string $interfaceClass The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function filterByInterfaceClass($interfaceClass = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($interfaceClass)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $interfaceClass)) {
                $interfaceClass = str_replace('*', '%', $interfaceClass);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AlarmingManagementHostPeer::INTERFACE_CLASS, $interfaceClass, $comparison);
    }

    /**
     * Filter the query by a related AlarmingManagedObject object
     *
     * @param   AlarmingManagedObject|PropelObjectCollection $alarmingManagedObject  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmingManagementHostQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAmo($alarmingManagedObject, $comparison = null)
    {
        if ($alarmingManagedObject instanceof AlarmingManagedObject) {
            return $this
                ->addUsingAlias(AlarmingManagementHostPeer::ID, $alarmingManagedObject->getAmhId(), $comparison);
        } elseif ($alarmingManagedObject instanceof PropelObjectCollection) {
            return $this
                ->useAmoQuery()
                ->filterByPrimaryKeys($alarmingManagedObject->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByAmo() only accepts arguments of type AlarmingManagedObject or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Amo relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function joinAmo($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Amo');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Amo');
        }

        return $this;
    }

    /**
     * Use the Amo relation AlarmingManagedObject object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmingManagedObjectQuery A secondary query class using the current class as primary query
     */
    public function useAmoQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAmo($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Amo', 'AlarmingManagedObjectQuery');
    }

    /**
     * Filter the query by a related EscalationHostSelector object
     *
     * @param   EscalationHostSelector|PropelObjectCollection $escalationHostSelector  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmingManagementHostQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByEhs($escalationHostSelector, $comparison = null)
    {
        if ($escalationHostSelector instanceof EscalationHostSelector) {
            return $this
                ->addUsingAlias(AlarmingManagementHostPeer::ID, $escalationHostSelector->getAmhId(), $comparison);
        } elseif ($escalationHostSelector instanceof PropelObjectCollection) {
            return $this
                ->useEhsQuery()
                ->filterByPrimaryKeys($escalationHostSelector->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByEhs() only accepts arguments of type EscalationHostSelector or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Ehs relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function joinEhs($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Ehs');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Ehs');
        }

        return $this;
    }

    /**
     * Use the Ehs relation EscalationHostSelector object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   EscalationHostSelectorQuery A secondary query class using the current class as primary query
     */
    public function useEhsQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinEhs($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Ehs', 'EscalationHostSelectorQuery');
    }

    /**
     * Filter the query by a related DestinationHostSelector object
     *
     * @param   DestinationHostSelector|PropelObjectCollection $destinationHostSelector  the related object to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AlarmingManagementHostQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByDhs($destinationHostSelector, $comparison = null)
    {
        if ($destinationHostSelector instanceof DestinationHostSelector) {
            return $this
                ->addUsingAlias(AlarmingManagementHostPeer::ID, $destinationHostSelector->getAmhId(), $comparison);
        } elseif ($destinationHostSelector instanceof PropelObjectCollection) {
            return $this
                ->useDhsQuery()
                ->filterByPrimaryKeys($destinationHostSelector->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByDhs() only accepts arguments of type DestinationHostSelector or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Dhs relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function joinDhs($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Dhs');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Dhs');
        }

        return $this;
    }

    /**
     * Use the Dhs relation DestinationHostSelector object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   DestinationHostSelectorQuery A secondary query class using the current class as primary query
     */
    public function useDhsQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinDhs($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Dhs', 'DestinationHostSelectorQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   AlarmingManagementHost $alarmingManagementHost Object to remove from the list of results
     *
     * @return AlarmingManagementHostQuery The current query, for fluid interface
     */
    public function prune($alarmingManagementHost = null)
    {
        if ($alarmingManagementHost) {
            $this->addUsingAlias(AlarmingManagementHostPeer::ID, $alarmingManagementHost->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
