<?php


/**
 * Base class that represents a query for the 'asgt_evt_sel' table.
 *
 *
 *
 * @method AssignmentEventSelectorQuery orderById($order = Criteria::ASC) Order by the id column
 * @method AssignmentEventSelectorQuery orderByAsarId($order = Criteria::ASC) Order by the asar_id column
 * @method AssignmentEventSelectorQuery orderByAedId($order = Criteria::ASC) Order by the aed_id column
 *
 * @method AssignmentEventSelectorQuery groupById() Group by the id column
 * @method AssignmentEventSelectorQuery groupByAsarId() Group by the asar_id column
 * @method AssignmentEventSelectorQuery groupByAedId() Group by the aed_id column
 *
 * @method AssignmentEventSelectorQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method AssignmentEventSelectorQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method AssignmentEventSelectorQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method AssignmentEventSelectorQuery leftJoinAlarmSeverityAssignmentRule($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmSeverityAssignmentRule relation
 * @method AssignmentEventSelectorQuery rightJoinAlarmSeverityAssignmentRule($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmSeverityAssignmentRule relation
 * @method AssignmentEventSelectorQuery innerJoinAlarmSeverityAssignmentRule($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmSeverityAssignmentRule relation
 *
 * @method AssignmentEventSelectorQuery leftJoinAlarmEventDescriptor($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmEventDescriptor relation
 * @method AssignmentEventSelectorQuery rightJoinAlarmEventDescriptor($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmEventDescriptor relation
 * @method AssignmentEventSelectorQuery innerJoinAlarmEventDescriptor($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmEventDescriptor relation
 *
 * @method AssignmentEventSelector findOne(PropelPDO $con = null) Return the first AssignmentEventSelector matching the query
 * @method AssignmentEventSelector findOneOrCreate(PropelPDO $con = null) Return the first AssignmentEventSelector matching the query, or a new AssignmentEventSelector object populated from the query conditions when no match is found
 *
 * @method AssignmentEventSelector findOneByAsarId(int $asar_id) Return the first AssignmentEventSelector filtered by the asar_id column
 * @method AssignmentEventSelector findOneByAedId(int $aed_id) Return the first AssignmentEventSelector filtered by the aed_id column
 *
 * @method array findById(int $id) Return AssignmentEventSelector objects filtered by the id column
 * @method array findByAsarId(int $asar_id) Return AssignmentEventSelector objects filtered by the asar_id column
 * @method array findByAedId(int $aed_id) Return AssignmentEventSelector objects filtered by the aed_id column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAssignmentEventSelectorQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseAssignmentEventSelectorQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'AssignmentEventSelector';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new AssignmentEventSelectorQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   AssignmentEventSelectorQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return AssignmentEventSelectorQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof AssignmentEventSelectorQuery) {
            return $criteria;
        }
        $query = new AssignmentEventSelectorQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   AssignmentEventSelector|AssignmentEventSelector[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = AssignmentEventSelectorPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(AssignmentEventSelectorPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AssignmentEventSelector A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 AssignmentEventSelector A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `asar_id`, `aed_id` FROM `asgt_evt_sel` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new AssignmentEventSelector();
            $obj->hydrate($row);
            AssignmentEventSelectorPeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return AssignmentEventSelector|AssignmentEventSelector[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|AssignmentEventSelector[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return AssignmentEventSelectorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(AssignmentEventSelectorPeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return AssignmentEventSelectorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(AssignmentEventSelectorPeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AssignmentEventSelectorQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(AssignmentEventSelectorPeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(AssignmentEventSelectorPeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AssignmentEventSelectorPeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the asar_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAsarId(1234); // WHERE asar_id = 1234
     * $query->filterByAsarId(array(12, 34)); // WHERE asar_id IN (12, 34)
     * $query->filterByAsarId(array('min' => 12)); // WHERE asar_id >= 12
     * $query->filterByAsarId(array('max' => 12)); // WHERE asar_id <= 12
     * </code>
     *
     * @see       filterByAlarmSeverityAssignmentRule()
     *
     * @param     mixed $asarId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AssignmentEventSelectorQuery The current query, for fluid interface
     */
    public function filterByAsarId($asarId = null, $comparison = null)
    {
        if (is_array($asarId)) {
            $useMinMax = false;
            if (isset($asarId['min'])) {
                $this->addUsingAlias(AssignmentEventSelectorPeer::ASAR_ID, $asarId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($asarId['max'])) {
                $this->addUsingAlias(AssignmentEventSelectorPeer::ASAR_ID, $asarId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AssignmentEventSelectorPeer::ASAR_ID, $asarId, $comparison);
    }

    /**
     * Filter the query on the aed_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAedId(1234); // WHERE aed_id = 1234
     * $query->filterByAedId(array(12, 34)); // WHERE aed_id IN (12, 34)
     * $query->filterByAedId(array('min' => 12)); // WHERE aed_id >= 12
     * $query->filterByAedId(array('max' => 12)); // WHERE aed_id <= 12
     * </code>
     *
     * @see       filterByAlarmEventDescriptor()
     *
     * @param     mixed $aedId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return AssignmentEventSelectorQuery The current query, for fluid interface
     */
    public function filterByAedId($aedId = null, $comparison = null)
    {
        if (is_array($aedId)) {
            $useMinMax = false;
            if (isset($aedId['min'])) {
                $this->addUsingAlias(AssignmentEventSelectorPeer::AED_ID, $aedId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($aedId['max'])) {
                $this->addUsingAlias(AssignmentEventSelectorPeer::AED_ID, $aedId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AssignmentEventSelectorPeer::AED_ID, $aedId, $comparison);
    }

    /**
     * Filter the query by a related AlarmSeverityAssignmentRule object
     *
     * @param   AlarmSeverityAssignmentRule|PropelObjectCollection $alarmSeverityAssignmentRule The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AssignmentEventSelectorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmSeverityAssignmentRule($alarmSeverityAssignmentRule, $comparison = null)
    {
        if ($alarmSeverityAssignmentRule instanceof AlarmSeverityAssignmentRule) {
            return $this
                ->addUsingAlias(AssignmentEventSelectorPeer::ASAR_ID, $alarmSeverityAssignmentRule->getId(), $comparison);
        } elseif ($alarmSeverityAssignmentRule instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(AssignmentEventSelectorPeer::ASAR_ID, $alarmSeverityAssignmentRule->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmSeverityAssignmentRule() only accepts arguments of type AlarmSeverityAssignmentRule or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmSeverityAssignmentRule relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AssignmentEventSelectorQuery The current query, for fluid interface
     */
    public function joinAlarmSeverityAssignmentRule($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmSeverityAssignmentRule');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmSeverityAssignmentRule');
        }

        return $this;
    }

    /**
     * Use the AlarmSeverityAssignmentRule relation AlarmSeverityAssignmentRule object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmSeverityAssignmentRuleQuery A secondary query class using the current class as primary query
     */
    public function useAlarmSeverityAssignmentRuleQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmSeverityAssignmentRule($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmSeverityAssignmentRule', 'AlarmSeverityAssignmentRuleQuery');
    }

    /**
     * Filter the query by a related AlarmEventDescriptor object
     *
     * @param   AlarmEventDescriptor|PropelObjectCollection $alarmEventDescriptor The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 AssignmentEventSelectorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmEventDescriptor($alarmEventDescriptor, $comparison = null)
    {
        if ($alarmEventDescriptor instanceof AlarmEventDescriptor) {
            return $this
                ->addUsingAlias(AssignmentEventSelectorPeer::AED_ID, $alarmEventDescriptor->getId(), $comparison);
        } elseif ($alarmEventDescriptor instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(AssignmentEventSelectorPeer::AED_ID, $alarmEventDescriptor->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmEventDescriptor() only accepts arguments of type AlarmEventDescriptor or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmEventDescriptor relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return AssignmentEventSelectorQuery The current query, for fluid interface
     */
    public function joinAlarmEventDescriptor($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmEventDescriptor');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmEventDescriptor');
        }

        return $this;
    }

    /**
     * Use the AlarmEventDescriptor relation AlarmEventDescriptor object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmEventDescriptorQuery A secondary query class using the current class as primary query
     */
    public function useAlarmEventDescriptorQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmEventDescriptor($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmEventDescriptor', 'AlarmEventDescriptorQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   AssignmentEventSelector $assignmentEventSelector Object to remove from the list of results
     *
     * @return AssignmentEventSelectorQuery The current query, for fluid interface
     */
    public function prune($assignmentEventSelector = null)
    {
        if ($assignmentEventSelector) {
            $this->addUsingAlias(AssignmentEventSelectorPeer::ID, $assignmentEventSelector->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
