<?php


/**
 * Base class that represents a query for the 'attr_dscr' table.
 *
 * 
 *
 * @method     AttributeDescriptorQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     AttributeDescriptorQuery orderByMod($order = Criteria::ASC) Order by the mod column
 * @method     AttributeDescriptorQuery orderByIntern($order = Criteria::ASC) Order by the intern column
 * @method     AttributeDescriptorQuery orderByExtern($order = Criteria::ASC) Order by the extern column
 * @method     AttributeDescriptorQuery orderByMocdId($order = Criteria::ASC) Order by the mocd_id column
 * @method     AttributeDescriptorQuery orderByProps($order = Criteria::ASC) Order by the props column
 * @method     AttributeDescriptorQuery orderByRelMoc($order = Criteria::ASC) Order by the rel_moc column
 *
 * @method     AttributeDescriptorQuery groupById() Group by the id column
 * @method     AttributeDescriptorQuery groupByMod() Group by the mod column
 * @method     AttributeDescriptorQuery groupByIntern() Group by the intern column
 * @method     AttributeDescriptorQuery groupByExtern() Group by the extern column
 * @method     AttributeDescriptorQuery groupByMocdId() Group by the mocd_id column
 * @method     AttributeDescriptorQuery groupByProps() Group by the props column
 * @method     AttributeDescriptorQuery groupByRelMoc() Group by the rel_moc column
 *
 * @method     AttributeDescriptorQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     AttributeDescriptorQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     AttributeDescriptorQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     AttributeDescriptorQuery leftJoinManagedObjectClassDescriptor($relationAlias = null) Adds a LEFT JOIN clause to the query using the ManagedObjectClassDescriptor relation
 * @method     AttributeDescriptorQuery rightJoinManagedObjectClassDescriptor($relationAlias = null) Adds a RIGHT JOIN clause to the query using the ManagedObjectClassDescriptor relation
 * @method     AttributeDescriptorQuery innerJoinManagedObjectClassDescriptor($relationAlias = null) Adds a INNER JOIN clause to the query using the ManagedObjectClassDescriptor relation
 *
 * @method     AttributeDescriptor findOne(PropelPDO $con = null) Return the first AttributeDescriptor matching the query
 * @method     AttributeDescriptor findOneOrCreate(PropelPDO $con = null) Return the first AttributeDescriptor matching the query, or a new AttributeDescriptor object populated from the query conditions when no match is found
 *
 * @method     AttributeDescriptor findOneById(int $id) Return the first AttributeDescriptor filtered by the id column
 * @method     AttributeDescriptor findOneByMod(int $mod) Return the first AttributeDescriptor filtered by the mod column
 * @method     AttributeDescriptor findOneByIntern(string $intern) Return the first AttributeDescriptor filtered by the intern column
 * @method     AttributeDescriptor findOneByExtern(string $extern) Return the first AttributeDescriptor filtered by the extern column
 * @method     AttributeDescriptor findOneByMocdId(int $mocd_id) Return the first AttributeDescriptor filtered by the mocd_id column
 * @method     AttributeDescriptor findOneByProps(int $props) Return the first AttributeDescriptor filtered by the props column
 * @method     AttributeDescriptor findOneByRelMoc(string $rel_moc) Return the first AttributeDescriptor filtered by the rel_moc column
 *
 * @method     array findById(int $id) Return AttributeDescriptor objects filtered by the id column
 * @method     array findByMod(int $mod) Return AttributeDescriptor objects filtered by the mod column
 * @method     array findByIntern(string $intern) Return AttributeDescriptor objects filtered by the intern column
 * @method     array findByExtern(string $extern) Return AttributeDescriptor objects filtered by the extern column
 * @method     array findByMocdId(int $mocd_id) Return AttributeDescriptor objects filtered by the mocd_id column
 * @method     array findByProps(int $props) Return AttributeDescriptor objects filtered by the props column
 * @method     array findByRelMoc(string $rel_moc) Return AttributeDescriptor objects filtered by the rel_moc column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseAttributeDescriptorQuery extends ModelCriteria
{

	/**
	 * Initializes internal state of BaseAttributeDescriptorQuery object.
	 *
	 * @param     string $dbName The dabase name
	 * @param     string $modelName The phpName of a model, e.g. 'Book'
	 * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
	 */
	public function __construct($dbName = 'sysal', $modelName = 'AttributeDescriptor', $modelAlias = null)
	{
		parent::__construct($dbName, $modelName, $modelAlias);
	}

	/**
	 * Returns a new AttributeDescriptorQuery object.
	 *
	 * @param     string $modelAlias The alias of a model in the query
	 * @param     Criteria $criteria Optional Criteria to build the query from
	 *
	 * @return    AttributeDescriptorQuery
	 */
	public static function create($modelAlias = null, $criteria = null)
	{
		if ($criteria instanceof AttributeDescriptorQuery) {
			return $criteria;
		}
		$query = new AttributeDescriptorQuery();
		if (null !== $modelAlias) {
			$query->setModelAlias($modelAlias);
		}
		if ($criteria instanceof Criteria) {
			$query->mergeWith($criteria);
		}
		return $query;
	}

	/**
	 * Find object by primary key
	 * Use instance pooling to avoid a database query if the object exists
	 * <code>
	 * $obj  = $c->findPk(12, $con);
	 * </code>
	 * @param     mixed $key Primary key to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    AttributeDescriptor|array|mixed the result, formatted by the current formatter
	 */
	public function findPk($key, $con = null)
	{
		if ((null !== ($obj = AttributeDescriptorPeer::getInstanceFromPool((string) $key))) && $this->getFormatter()->isObjectFormatter()) {
			// the object is alredy in the instance pool
			return $obj;
		} else {
			// the object has not been requested yet, or the formatter is not an object formatter
			$criteria = $this->isKeepQuery() ? clone $this : $this;
			$stmt = $criteria
				->filterByPrimaryKey($key)
				->getSelectStatement($con);
			return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
		}
	}

	/**
	 * Find objects by primary key
	 * <code>
	 * $objs = $c->findPks(array(12, 56, 832), $con);
	 * </code>
	 * @param     array $keys Primary keys to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    PropelObjectCollection|array|mixed the list of results, formatted by the current formatter
	 */
	public function findPks($keys, $con = null)
	{	
		$criteria = $this->isKeepQuery() ? clone $this : $this;
		return $this
			->filterByPrimaryKeys($keys)
			->find($con);
	}

	/**
	 * Filter the query by primary key
	 *
	 * @param     mixed $key Primary key to use for the query
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKey($key)
	{
		return $this->addUsingAlias(AttributeDescriptorPeer::ID, $key, Criteria::EQUAL);
	}

	/**
	 * Filter the query by a list of primary keys
	 *
	 * @param     array $keys The list of primary key to use for the query
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKeys($keys)
	{
		return $this->addUsingAlias(AttributeDescriptorPeer::ID, $keys, Criteria::IN);
	}

	/**
	 * Filter the query on the id column
	 * 
	 * @param     int|array $id The value to use as filter.
	 *            Accepts an associative array('min' => $minValue, 'max' => $maxValue)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function filterById($id = null, $comparison = null)
	{
		if (is_array($id) && null === $comparison) {
			$comparison = Criteria::IN;
		}
		return $this->addUsingAlias(AttributeDescriptorPeer::ID, $id, $comparison);
	}

	/**
	 * Filter the query on the mod column
	 * 
	 * @param     int|array $mod The value to use as filter.
	 *            Accepts an associative array('min' => $minValue, 'max' => $maxValue)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function filterByMod($mod = null, $comparison = null)
	{
		if (is_array($mod)) {
			$useMinMax = false;
			if (isset($mod['min'])) {
				$this->addUsingAlias(AttributeDescriptorPeer::MOD, $mod['min'], Criteria::GREATER_EQUAL);
				$useMinMax = true;
			}
			if (isset($mod['max'])) {
				$this->addUsingAlias(AttributeDescriptorPeer::MOD, $mod['max'], Criteria::LESS_EQUAL);
				$useMinMax = true;
			}
			if ($useMinMax) {
				return $this;
			}
			if (null === $comparison) {
				$comparison = Criteria::IN;
			}
		}
		return $this->addUsingAlias(AttributeDescriptorPeer::MOD, $mod, $comparison);
	}

	/**
	 * Filter the query on the intern column
	 * 
	 * @param     string $intern The value to use as filter.
	 *            Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function filterByIntern($intern = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($intern)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $intern)) {
				$intern = str_replace('*', '%', $intern);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(AttributeDescriptorPeer::INTERN, $intern, $comparison);
	}

	/**
	 * Filter the query on the extern column
	 * 
	 * @param     string $extern The value to use as filter.
	 *            Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function filterByExtern($extern = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($extern)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $extern)) {
				$extern = str_replace('*', '%', $extern);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(AttributeDescriptorPeer::EXTERN, $extern, $comparison);
	}

	/**
	 * Filter the query on the mocd_id column
	 * 
	 * @param     int|array $mocdId The value to use as filter.
	 *            Accepts an associative array('min' => $minValue, 'max' => $maxValue)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function filterByMocdId($mocdId = null, $comparison = null)
	{
		if (is_array($mocdId)) {
			$useMinMax = false;
			if (isset($mocdId['min'])) {
				$this->addUsingAlias(AttributeDescriptorPeer::MOCD_ID, $mocdId['min'], Criteria::GREATER_EQUAL);
				$useMinMax = true;
			}
			if (isset($mocdId['max'])) {
				$this->addUsingAlias(AttributeDescriptorPeer::MOCD_ID, $mocdId['max'], Criteria::LESS_EQUAL);
				$useMinMax = true;
			}
			if ($useMinMax) {
				return $this;
			}
			if (null === $comparison) {
				$comparison = Criteria::IN;
			}
		}
		return $this->addUsingAlias(AttributeDescriptorPeer::MOCD_ID, $mocdId, $comparison);
	}

	/**
	 * Filter the query on the props column
	 * 
	 * @param     int|array $props The value to use as filter.
	 *            Accepts an associative array('min' => $minValue, 'max' => $maxValue)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function filterByProps($props = null, $comparison = null)
	{
		if (is_array($props)) {
			$useMinMax = false;
			if (isset($props['min'])) {
				$this->addUsingAlias(AttributeDescriptorPeer::PROPS, $props['min'], Criteria::GREATER_EQUAL);
				$useMinMax = true;
			}
			if (isset($props['max'])) {
				$this->addUsingAlias(AttributeDescriptorPeer::PROPS, $props['max'], Criteria::LESS_EQUAL);
				$useMinMax = true;
			}
			if ($useMinMax) {
				return $this;
			}
			if (null === $comparison) {
				$comparison = Criteria::IN;
			}
		}
		return $this->addUsingAlias(AttributeDescriptorPeer::PROPS, $props, $comparison);
	}

	/**
	 * Filter the query on the rel_moc column
	 * 
	 * @param     string $relMoc The value to use as filter.
	 *            Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function filterByRelMoc($relMoc = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($relMoc)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $relMoc)) {
				$relMoc = str_replace('*', '%', $relMoc);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(AttributeDescriptorPeer::REL_MOC, $relMoc, $comparison);
	}

	/**
	 * Filter the query by a related ManagedObjectClassDescriptor object
	 *
	 * @param     ManagedObjectClassDescriptor $managedObjectClassDescriptor  the related object to use as filter
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function filterByManagedObjectClassDescriptor($managedObjectClassDescriptor, $comparison = null)
	{
		return $this
			->addUsingAlias(AttributeDescriptorPeer::MOCD_ID, $managedObjectClassDescriptor->getId(), $comparison);
	}

	/**
	 * Adds a JOIN clause to the query using the ManagedObjectClassDescriptor relation
	 * 
	 * @param     string $relationAlias optional alias for the relation
	 * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function joinManagedObjectClassDescriptor($relationAlias = null, $joinType = Criteria::INNER_JOIN)
	{
		$tableMap = $this->getTableMap();
		$relationMap = $tableMap->getRelation('ManagedObjectClassDescriptor');
		
		// create a ModelJoin object for this join
		$join = new ModelJoin();
		$join->setJoinType($joinType);
		$join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
		if ($previousJoin = $this->getPreviousJoin()) {
			$join->setPreviousJoin($previousJoin);
		}
		
		// add the ModelJoin to the current object
		if($relationAlias) {
			$this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
			$this->addJoinObject($join, $relationAlias);
		} else {
			$this->addJoinObject($join, 'ManagedObjectClassDescriptor');
		}
		
		return $this;
	}

	/**
	 * Use the ManagedObjectClassDescriptor relation ManagedObjectClassDescriptor object
	 *
	 * @see       useQuery()
	 * 
	 * @param     string $relationAlias optional alias for the relation,
	 *                                   to be used as main alias in the secondary query
	 * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
	 *
	 * @return    ManagedObjectClassDescriptorQuery A secondary query class using the current class as primary query
	 */
	public function useManagedObjectClassDescriptorQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
	{
		return $this
			->joinManagedObjectClassDescriptor($relationAlias, $joinType)
			->useQuery($relationAlias ? $relationAlias : 'ManagedObjectClassDescriptor', 'ManagedObjectClassDescriptorQuery');
	}

	/**
	 * Exclude object from result
	 *
	 * @param     AttributeDescriptor $attributeDescriptor Object to remove from the list of results
	 *
	 * @return    AttributeDescriptorQuery The current query, for fluid interface
	 */
	public function prune($attributeDescriptor = null)
	{
		if ($attributeDescriptor) {
			$this->addUsingAlias(AttributeDescriptorPeer::ID, $attributeDescriptor->getId(), Criteria::NOT_EQUAL);
	  }
	  
		return $this;
	}

} // BaseAttributeDescriptorQuery
