<?php


/**
 * Base class that represents a query for the 'bal_evt_sel' table.
 *
 *
 *
 * @method BalancingEventSelectorQuery orderById($order = Criteria::ASC) Order by the id column
 * @method BalancingEventSelectorQuery orderByAbmId($order = Criteria::ASC) Order by the abm_id column
 * @method BalancingEventSelectorQuery orderByAedId($order = Criteria::ASC) Order by the aed_id column
 *
 * @method BalancingEventSelectorQuery groupById() Group by the id column
 * @method BalancingEventSelectorQuery groupByAbmId() Group by the abm_id column
 * @method BalancingEventSelectorQuery groupByAedId() Group by the aed_id column
 *
 * @method BalancingEventSelectorQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method BalancingEventSelectorQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method BalancingEventSelectorQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method BalancingEventSelectorQuery leftJoinAlarmBalanceMonitor($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmBalanceMonitor relation
 * @method BalancingEventSelectorQuery rightJoinAlarmBalanceMonitor($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmBalanceMonitor relation
 * @method BalancingEventSelectorQuery innerJoinAlarmBalanceMonitor($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmBalanceMonitor relation
 *
 * @method BalancingEventSelectorQuery leftJoinAlarmEventDescriptor($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmEventDescriptor relation
 * @method BalancingEventSelectorQuery rightJoinAlarmEventDescriptor($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmEventDescriptor relation
 * @method BalancingEventSelectorQuery innerJoinAlarmEventDescriptor($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmEventDescriptor relation
 *
 * @method BalancingEventSelector findOne(PropelPDO $con = null) Return the first BalancingEventSelector matching the query
 * @method BalancingEventSelector findOneOrCreate(PropelPDO $con = null) Return the first BalancingEventSelector matching the query, or a new BalancingEventSelector object populated from the query conditions when no match is found
 *
 * @method BalancingEventSelector findOneByAbmId(int $abm_id) Return the first BalancingEventSelector filtered by the abm_id column
 * @method BalancingEventSelector findOneByAedId(int $aed_id) Return the first BalancingEventSelector filtered by the aed_id column
 *
 * @method array findById(int $id) Return BalancingEventSelector objects filtered by the id column
 * @method array findByAbmId(int $abm_id) Return BalancingEventSelector objects filtered by the abm_id column
 * @method array findByAedId(int $aed_id) Return BalancingEventSelector objects filtered by the aed_id column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseBalancingEventSelectorQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseBalancingEventSelectorQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'BalancingEventSelector';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new BalancingEventSelectorQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   BalancingEventSelectorQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return BalancingEventSelectorQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof BalancingEventSelectorQuery) {
            return $criteria;
        }
        $query = new BalancingEventSelectorQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   BalancingEventSelector|BalancingEventSelector[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = BalancingEventSelectorPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(BalancingEventSelectorPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 BalancingEventSelector A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 BalancingEventSelector A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `abm_id`, `aed_id` FROM `bal_evt_sel` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new BalancingEventSelector();
            $obj->hydrate($row);
            BalancingEventSelectorPeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return BalancingEventSelector|BalancingEventSelector[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|BalancingEventSelector[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return BalancingEventSelectorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(BalancingEventSelectorPeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return BalancingEventSelectorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(BalancingEventSelectorPeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return BalancingEventSelectorQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(BalancingEventSelectorPeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(BalancingEventSelectorPeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(BalancingEventSelectorPeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the abm_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAbmId(1234); // WHERE abm_id = 1234
     * $query->filterByAbmId(array(12, 34)); // WHERE abm_id IN (12, 34)
     * $query->filterByAbmId(array('min' => 12)); // WHERE abm_id >= 12
     * $query->filterByAbmId(array('max' => 12)); // WHERE abm_id <= 12
     * </code>
     *
     * @see       filterByAlarmBalanceMonitor()
     *
     * @param     mixed $abmId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return BalancingEventSelectorQuery The current query, for fluid interface
     */
    public function filterByAbmId($abmId = null, $comparison = null)
    {
        if (is_array($abmId)) {
            $useMinMax = false;
            if (isset($abmId['min'])) {
                $this->addUsingAlias(BalancingEventSelectorPeer::ABM_ID, $abmId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($abmId['max'])) {
                $this->addUsingAlias(BalancingEventSelectorPeer::ABM_ID, $abmId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(BalancingEventSelectorPeer::ABM_ID, $abmId, $comparison);
    }

    /**
     * Filter the query on the aed_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAedId(1234); // WHERE aed_id = 1234
     * $query->filterByAedId(array(12, 34)); // WHERE aed_id IN (12, 34)
     * $query->filterByAedId(array('min' => 12)); // WHERE aed_id >= 12
     * $query->filterByAedId(array('max' => 12)); // WHERE aed_id <= 12
     * </code>
     *
     * @see       filterByAlarmEventDescriptor()
     *
     * @param     mixed $aedId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return BalancingEventSelectorQuery The current query, for fluid interface
     */
    public function filterByAedId($aedId = null, $comparison = null)
    {
        if (is_array($aedId)) {
            $useMinMax = false;
            if (isset($aedId['min'])) {
                $this->addUsingAlias(BalancingEventSelectorPeer::AED_ID, $aedId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($aedId['max'])) {
                $this->addUsingAlias(BalancingEventSelectorPeer::AED_ID, $aedId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(BalancingEventSelectorPeer::AED_ID, $aedId, $comparison);
    }

    /**
     * Filter the query by a related AlarmBalanceMonitor object
     *
     * @param   AlarmBalanceMonitor|PropelObjectCollection $alarmBalanceMonitor The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 BalancingEventSelectorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmBalanceMonitor($alarmBalanceMonitor, $comparison = null)
    {
        if ($alarmBalanceMonitor instanceof AlarmBalanceMonitor) {
            return $this
                ->addUsingAlias(BalancingEventSelectorPeer::ABM_ID, $alarmBalanceMonitor->getId(), $comparison);
        } elseif ($alarmBalanceMonitor instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(BalancingEventSelectorPeer::ABM_ID, $alarmBalanceMonitor->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmBalanceMonitor() only accepts arguments of type AlarmBalanceMonitor or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmBalanceMonitor relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return BalancingEventSelectorQuery The current query, for fluid interface
     */
    public function joinAlarmBalanceMonitor($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmBalanceMonitor');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmBalanceMonitor');
        }

        return $this;
    }

    /**
     * Use the AlarmBalanceMonitor relation AlarmBalanceMonitor object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmBalanceMonitorQuery A secondary query class using the current class as primary query
     */
    public function useAlarmBalanceMonitorQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmBalanceMonitor($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmBalanceMonitor', 'AlarmBalanceMonitorQuery');
    }

    /**
     * Filter the query by a related AlarmEventDescriptor object
     *
     * @param   AlarmEventDescriptor|PropelObjectCollection $alarmEventDescriptor The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 BalancingEventSelectorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmEventDescriptor($alarmEventDescriptor, $comparison = null)
    {
        if ($alarmEventDescriptor instanceof AlarmEventDescriptor) {
            return $this
                ->addUsingAlias(BalancingEventSelectorPeer::AED_ID, $alarmEventDescriptor->getId(), $comparison);
        } elseif ($alarmEventDescriptor instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(BalancingEventSelectorPeer::AED_ID, $alarmEventDescriptor->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmEventDescriptor() only accepts arguments of type AlarmEventDescriptor or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmEventDescriptor relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return BalancingEventSelectorQuery The current query, for fluid interface
     */
    public function joinAlarmEventDescriptor($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmEventDescriptor');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmEventDescriptor');
        }

        return $this;
    }

    /**
     * Use the AlarmEventDescriptor relation AlarmEventDescriptor object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmEventDescriptorQuery A secondary query class using the current class as primary query
     */
    public function useAlarmEventDescriptorQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmEventDescriptor($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmEventDescriptor', 'AlarmEventDescriptorQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   BalancingEventSelector $balancingEventSelector Object to remove from the list of results
     *
     * @return BalancingEventSelectorQuery The current query, for fluid interface
     */
    public function prune($balancingEventSelector = null)
    {
        if ($balancingEventSelector) {
            $this->addUsingAlias(BalancingEventSelectorPeer::ID, $balancingEventSelector->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
