<?php


/**
 * Base class that represents a row from the 'cur_alm_cond' table.
 *
 *
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseCurrentAlarmCondition extends BaseObject implements Persistent
{
    /**
     * Peer class name
     */
    const PEER = 'CurrentAlarmConditionPeer';

    /**
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var        CurrentAlarmConditionPeer
     */
    protected static $peer;

    /**
     * The flag var to prevent infinite loop in deep copy
     * @var       boolean
     */
    protected $startCopy = false;

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the amo_id field.
     * @var        int
     */
    protected $amo_id;

    /**
     * The value for the aed_id field.
     * @var        int
     */
    protected $aed_id;

    /**
     * The value for the evt_time field.
     * @var        string
     */
    protected $evt_time;

    /**
     * The value for the rec_date field.
     * @var        string
     */
    protected $rec_date;

    /**
     * The value for the alm_stat field.
     * @var        int
     */
    protected $alm_stat;

    /**
     * The value for the serv_infl field.
     * @var        int
     */
    protected $serv_infl;

    /**
     * The value for the obs_val field.
     * @var        int
     */
    protected $obs_val;

    /**
     * @var        AlarmingManagedObject
     */
    protected $aAlarmingManagedObject;

    /**
     * @var        AlarmEventDescriptor
     */
    protected $aAlarmEventDescriptor;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInSave = false;

    /**
     * Flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInValidation = false;

    /**
     * Flag to prevent endless clearAllReferences($deep=true) loop, if this object is referenced
     * @var        boolean
     */
    protected $alreadyInClearAllReferencesDeep = false;

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {

        return $this->id;
    }

    /**
     * Get the [amo_id] column value.
     *
     * @return int
     */
    public function getAmoId()
    {

        return $this->amo_id;
    }

    /**
     * Get the [aed_id] column value.
     *
     * @return int
     */
    public function getAedId()
    {

        return $this->aed_id;
    }

    /**
     * Get the [evt_time] column value.
     *
     * @return string
     */
    public function getEvtTime()
    {

        return $this->evt_time;
    }

    /**
     * Get the [rec_date] column value.
     *
     * @return string
     */
    public function getRecDate()
    {

        return $this->rec_date;
    }

    /**
     * Get the [alm_stat] column value.
     *
     * @return int
     */
    public function getAlmStat()
    {

        return $this->alm_stat;
    }

    /**
     * Get the [serv_infl] column value.
     *
     * @return int
     */
    public function getServInfl()
    {

        return $this->serv_infl;
    }

    /**
     * Get the [obs_val] column value.
     *
     * @return int
     */
    public function getObsVal()
    {

        return $this->obs_val;
    }

    /**
     * Set the value of [id] column.
     *
     * @param  int $v new value
     * @return CurrentAlarmCondition The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[] = CurrentAlarmConditionPeer::ID;
        }


        return $this;
    } // setId()

    /**
     * Set the value of [amo_id] column.
     *
     * @param  int $v new value
     * @return CurrentAlarmCondition The current object (for fluent API support)
     */
    public function setAmoId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->amo_id !== $v) {
            $this->amo_id = $v;
            $this->modifiedColumns[] = CurrentAlarmConditionPeer::AMO_ID;
        }

        if ($this->aAlarmingManagedObject !== null && $this->aAlarmingManagedObject->getId() !== $v) {
            $this->aAlarmingManagedObject = null;
        }


        return $this;
    } // setAmoId()

    /**
     * Set the value of [aed_id] column.
     *
     * @param  int $v new value
     * @return CurrentAlarmCondition The current object (for fluent API support)
     */
    public function setAedId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->aed_id !== $v) {
            $this->aed_id = $v;
            $this->modifiedColumns[] = CurrentAlarmConditionPeer::AED_ID;
        }

        if ($this->aAlarmEventDescriptor !== null && $this->aAlarmEventDescriptor->getId() !== $v) {
            $this->aAlarmEventDescriptor = null;
        }


        return $this;
    } // setAedId()

    /**
     * Set the value of [evt_time] column.
     *
     * @param  string $v new value
     * @return CurrentAlarmCondition The current object (for fluent API support)
     */
    public function setEvtTime($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->evt_time !== $v) {
            $this->evt_time = $v;
            $this->modifiedColumns[] = CurrentAlarmConditionPeer::EVT_TIME;
        }


        return $this;
    } // setEvtTime()

    /**
     * Set the value of [rec_date] column.
     *
     * @param  string $v new value
     * @return CurrentAlarmCondition The current object (for fluent API support)
     */
    public function setRecDate($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->rec_date !== $v) {
            $this->rec_date = $v;
            $this->modifiedColumns[] = CurrentAlarmConditionPeer::REC_DATE;
        }


        return $this;
    } // setRecDate()

    /**
     * Set the value of [alm_stat] column.
     *
     * @param  int $v new value
     * @return CurrentAlarmCondition The current object (for fluent API support)
     */
    public function setAlmStat($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->alm_stat !== $v) {
            $this->alm_stat = $v;
            $this->modifiedColumns[] = CurrentAlarmConditionPeer::ALM_STAT;
        }


        return $this;
    } // setAlmStat()

    /**
     * Set the value of [serv_infl] column.
     *
     * @param  int $v new value
     * @return CurrentAlarmCondition The current object (for fluent API support)
     */
    public function setServInfl($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->serv_infl !== $v) {
            $this->serv_infl = $v;
            $this->modifiedColumns[] = CurrentAlarmConditionPeer::SERV_INFL;
        }


        return $this;
    } // setServInfl()

    /**
     * Set the value of [obs_val] column.
     *
     * @param  int $v new value
     * @return CurrentAlarmCondition The current object (for fluent API support)
     */
    public function setObsVal($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->obs_val !== $v) {
            $this->obs_val = $v;
            $this->modifiedColumns[] = CurrentAlarmConditionPeer::OBS_VAL;
        }


        return $this;
    } // setObsVal()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
        // otherwise, everything was equal, so return true
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
     * @param int $startcol 0-based offset column which indicates which resultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false)
    {
        try {

            $this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
            $this->amo_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
            $this->aed_id = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
            $this->evt_time = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
            $this->rec_date = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
            $this->alm_stat = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
            $this->serv_infl = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
            $this->obs_val = ($row[$startcol + 7] !== null) ? (int) $row[$startcol + 7] : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }
            $this->postHydrate($row, $startcol, $rehydrate);

            return $startcol + 8; // 8 = CurrentAlarmConditionPeer::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException("Error populating CurrentAlarmCondition object", $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {

        if ($this->aAlarmingManagedObject !== null && $this->amo_id !== $this->aAlarmingManagedObject->getId()) {
            $this->aAlarmingManagedObject = null;
        }
        if ($this->aAlarmEventDescriptor !== null && $this->aed_id !== $this->aAlarmEventDescriptor->getId()) {
            $this->aAlarmEventDescriptor = null;
        }
    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param boolean $deep (optional) Whether to also de-associated any related objects.
     * @param PropelPDO $con (optional) The PropelPDO connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getConnection(CurrentAlarmConditionPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $stmt = CurrentAlarmConditionPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
        $row = $stmt->fetch(PDO::FETCH_NUM);
        $stmt->closeCursor();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->aAlarmingManagedObject = null;
            $this->aAlarmEventDescriptor = null;
        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param PropelPDO $con
     * @return void
     * @throws PropelException
     * @throws Exception
     * @see        BaseObject::setDeleted()
     * @see        BaseObject::isDeleted()
     */
    public function delete(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(CurrentAlarmConditionPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        try {
            $deleteQuery = CurrentAlarmConditionQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $con->commit();
                $this->setDeleted(true);
            } else {
                $con->commit();
            }
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @throws Exception
     * @see        doSave()
     */
    public function save(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(CurrentAlarmConditionPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        $isInsert = $this->isNew();
        try {
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                CurrentAlarmConditionPeer::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see        save()
     */
    protected function doSave(PropelPDO $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aAlarmingManagedObject !== null) {
                if ($this->aAlarmingManagedObject->isModified() || $this->aAlarmingManagedObject->isNew()) {
                    $affectedRows += $this->aAlarmingManagedObject->save($con);
                }
                $this->setAlarmingManagedObject($this->aAlarmingManagedObject);
            }

            if ($this->aAlarmEventDescriptor !== null) {
                if ($this->aAlarmEventDescriptor->isModified() || $this->aAlarmEventDescriptor->isNew()) {
                    $affectedRows += $this->aAlarmEventDescriptor->save($con);
                }
                $this->setAlarmEventDescriptor($this->aAlarmEventDescriptor);
            }

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                } else {
                    $this->doUpdate($con);
                }
                $affectedRows += 1;
                $this->resetModified();
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param PropelPDO $con
     *
     * @throws PropelException
     * @see        doSave()
     */
    protected function doInsert(PropelPDO $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[] = CurrentAlarmConditionPeer::ID;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . CurrentAlarmConditionPeer::ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(CurrentAlarmConditionPeer::ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(CurrentAlarmConditionPeer::AMO_ID)) {
            $modifiedColumns[':p' . $index++]  = '`amo_id`';
        }
        if ($this->isColumnModified(CurrentAlarmConditionPeer::AED_ID)) {
            $modifiedColumns[':p' . $index++]  = '`aed_id`';
        }
        if ($this->isColumnModified(CurrentAlarmConditionPeer::EVT_TIME)) {
            $modifiedColumns[':p' . $index++]  = '`evt_time`';
        }
        if ($this->isColumnModified(CurrentAlarmConditionPeer::REC_DATE)) {
            $modifiedColumns[':p' . $index++]  = '`rec_date`';
        }
        if ($this->isColumnModified(CurrentAlarmConditionPeer::ALM_STAT)) {
            $modifiedColumns[':p' . $index++]  = '`alm_stat`';
        }
        if ($this->isColumnModified(CurrentAlarmConditionPeer::SERV_INFL)) {
            $modifiedColumns[':p' . $index++]  = '`serv_infl`';
        }
        if ($this->isColumnModified(CurrentAlarmConditionPeer::OBS_VAL)) {
            $modifiedColumns[':p' . $index++]  = '`obs_val`';
        }

        $sql = sprintf(
            'INSERT INTO `cur_alm_cond` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`amo_id`':
                        $stmt->bindValue($identifier, $this->amo_id, PDO::PARAM_INT);
                        break;
                    case '`aed_id`':
                        $stmt->bindValue($identifier, $this->aed_id, PDO::PARAM_INT);
                        break;
                    case '`evt_time`':
                        $stmt->bindValue($identifier, $this->evt_time, PDO::PARAM_STR);
                        break;
                    case '`rec_date`':
                        $stmt->bindValue($identifier, $this->rec_date, PDO::PARAM_STR);
                        break;
                    case '`alm_stat`':
                        $stmt->bindValue($identifier, $this->alm_stat, PDO::PARAM_INT);
                        break;
                    case '`serv_infl`':
                        $stmt->bindValue($identifier, $this->serv_infl, PDO::PARAM_INT);
                        break;
                    case '`obs_val`':
                        $stmt->bindValue($identifier, $this->obs_val, PDO::PARAM_INT);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param PropelPDO $con
     *
     * @see        doSave()
     */
    protected function doUpdate(PropelPDO $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();
        BasePeer::doUpdate($selectCriteria, $valuesCriteria, $con);
    }

    /**
     * Array of ValidationFailed objects.
     * @var        array ValidationFailed[]
     */
    protected $validationFailures = array();

    /**
     * Gets any ValidationFailed objects that resulted from last call to validate().
     *
     *
     * @return array ValidationFailed[]
     * @see        validate()
     */
    public function getValidationFailures()
    {
        return $this->validationFailures;
    }

    /**
     * Validates the objects modified field values and all objects related to this table.
     *
     * If $columns is either a column name or an array of column names
     * only those columns are validated.
     *
     * @param mixed $columns Column name or an array of column names.
     * @return boolean Whether all columns pass validation.
     * @see        doValidate()
     * @see        getValidationFailures()
     */
    public function validate($columns = null)
    {
        $res = $this->doValidate($columns);
        if ($res === true) {
            $this->validationFailures = array();

            return true;
        }

        $this->validationFailures = $res;

        return false;
    }

    /**
     * This function performs the validation work for complex object models.
     *
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggregated array of ValidationFailed objects will be returned.
     *
     * @param array $columns Array of column names to validate.
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objects otherwise.
     */
    protected function doValidate($columns = null)
    {
        if (!$this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;

            $failureMap = array();


            // We call the validate method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aAlarmingManagedObject !== null) {
                if (!$this->aAlarmingManagedObject->validate($columns)) {
                    $failureMap = array_merge($failureMap, $this->aAlarmingManagedObject->getValidationFailures());
                }
            }

            if ($this->aAlarmEventDescriptor !== null) {
                if (!$this->aAlarmEventDescriptor->validate($columns)) {
                    $failureMap = array_merge($failureMap, $this->aAlarmEventDescriptor->getValidationFailures());
                }
            }


            if (($retval = CurrentAlarmConditionPeer::doValidate($this, $columns)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }



            $this->alreadyInValidation = false;
        }

        return (!empty($failureMap) ? $failureMap : true);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param string $name name
     * @param string $type The type of fieldname the $name is of:
     *               one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *               BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *               Defaults to BasePeer::TYPE_PHPNAME
     * @return mixed Value of field.
     */
    public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = CurrentAlarmConditionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getAmoId();
                break;
            case 2:
                return $this->getAedId();
                break;
            case 3:
                return $this->getEvtTime();
                break;
            case 4:
                return $this->getRecDate();
                break;
            case 5:
                return $this->getAlmStat();
                break;
            case 6:
                return $this->getServInfl();
                break;
            case 7:
                return $this->getObsVal();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     *                    BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                    Defaults to BasePeer::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to true.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {
        if (isset($alreadyDumpedObjects['CurrentAlarmCondition'][$this->getPrimaryKey()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['CurrentAlarmCondition'][$this->getPrimaryKey()] = true;
        $keys = CurrentAlarmConditionPeer::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getAmoId(),
            $keys[2] => $this->getAedId(),
            $keys[3] => $this->getEvtTime(),
            $keys[4] => $this->getRecDate(),
            $keys[5] => $this->getAlmStat(),
            $keys[6] => $this->getServInfl(),
            $keys[7] => $this->getObsVal(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->aAlarmingManagedObject) {
                $result['AlarmingManagedObject'] = $this->aAlarmingManagedObject->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
            if (null !== $this->aAlarmEventDescriptor) {
                $result['AlarmEventDescriptor'] = $this->aAlarmEventDescriptor->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param string $name peer name
     * @param mixed $value field value
     * @param string $type The type of fieldname the $name is of:
     *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                     Defaults to BasePeer::TYPE_PHPNAME
     * @return void
     */
    public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = CurrentAlarmConditionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);

        $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @param mixed $value field value
     * @return void
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setAmoId($value);
                break;
            case 2:
                $this->setAedId($value);
                break;
            case 3:
                $this->setEvtTime($value);
                break;
            case 4:
                $this->setRecDate($value);
                break;
            case 5:
                $this->setAlmStat($value);
                break;
            case 6:
                $this->setServInfl($value);
                break;
            case 7:
                $this->setObsVal($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     * The default key type is the column's BasePeer::TYPE_PHPNAME
     *
     * @param array  $arr     An array to populate the object from.
     * @param string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
    {
        $keys = CurrentAlarmConditionPeer::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
        if (array_key_exists($keys[1], $arr)) $this->setAmoId($arr[$keys[1]]);
        if (array_key_exists($keys[2], $arr)) $this->setAedId($arr[$keys[2]]);
        if (array_key_exists($keys[3], $arr)) $this->setEvtTime($arr[$keys[3]]);
        if (array_key_exists($keys[4], $arr)) $this->setRecDate($arr[$keys[4]]);
        if (array_key_exists($keys[5], $arr)) $this->setAlmStat($arr[$keys[5]]);
        if (array_key_exists($keys[6], $arr)) $this->setServInfl($arr[$keys[6]]);
        if (array_key_exists($keys[7], $arr)) $this->setObsVal($arr[$keys[7]]);
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(CurrentAlarmConditionPeer::DATABASE_NAME);

        if ($this->isColumnModified(CurrentAlarmConditionPeer::ID)) $criteria->add(CurrentAlarmConditionPeer::ID, $this->id);
        if ($this->isColumnModified(CurrentAlarmConditionPeer::AMO_ID)) $criteria->add(CurrentAlarmConditionPeer::AMO_ID, $this->amo_id);
        if ($this->isColumnModified(CurrentAlarmConditionPeer::AED_ID)) $criteria->add(CurrentAlarmConditionPeer::AED_ID, $this->aed_id);
        if ($this->isColumnModified(CurrentAlarmConditionPeer::EVT_TIME)) $criteria->add(CurrentAlarmConditionPeer::EVT_TIME, $this->evt_time);
        if ($this->isColumnModified(CurrentAlarmConditionPeer::REC_DATE)) $criteria->add(CurrentAlarmConditionPeer::REC_DATE, $this->rec_date);
        if ($this->isColumnModified(CurrentAlarmConditionPeer::ALM_STAT)) $criteria->add(CurrentAlarmConditionPeer::ALM_STAT, $this->alm_stat);
        if ($this->isColumnModified(CurrentAlarmConditionPeer::SERV_INFL)) $criteria->add(CurrentAlarmConditionPeer::SERV_INFL, $this->serv_infl);
        if ($this->isColumnModified(CurrentAlarmConditionPeer::OBS_VAL)) $criteria->add(CurrentAlarmConditionPeer::OBS_VAL, $this->obs_val);

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(CurrentAlarmConditionPeer::DATABASE_NAME);
        $criteria->add(CurrentAlarmConditionPeer::ID, $this->id);

        return $criteria;
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param  int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {

        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param object $copyObj An object of CurrentAlarmCondition (or compatible) type.
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setAmoId($this->getAmoId());
        $copyObj->setAedId($this->getAedId());
        $copyObj->setEvtTime($this->getEvtTime());
        $copyObj->setRecDate($this->getRecDate());
        $copyObj->setAlmStat($this->getAlmStat());
        $copyObj->setServInfl($this->getServInfl());
        $copyObj->setObsVal($this->getObsVal());

        if ($deepCopy && !$this->startCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);
            // store object hash to prevent cycle
            $this->startCopy = true;

            //unflag object copy
            $this->startCopy = false;
        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return CurrentAlarmCondition Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Returns a peer instance associated with this om.
     *
     * Since Peer classes are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     *
     * @return CurrentAlarmConditionPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new CurrentAlarmConditionPeer();
        }

        return self::$peer;
    }

    /**
     * Declares an association between this object and a AlarmingManagedObject object.
     *
     * @param                  AlarmingManagedObject $v
     * @return CurrentAlarmCondition The current object (for fluent API support)
     * @throws PropelException
     */
    public function setAlarmingManagedObject(AlarmingManagedObject $v = null)
    {
        if ($v === null) {
            $this->setAmoId(NULL);
        } else {
            $this->setAmoId($v->getId());
        }

        $this->aAlarmingManagedObject = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the AlarmingManagedObject object, it will not be re-added.
        if ($v !== null) {
            $v->addCac($this);
        }


        return $this;
    }


    /**
     * Get the associated AlarmingManagedObject object
     *
     * @param PropelPDO $con Optional Connection object.
     * @param $doQuery Executes a query to get the object if required
     * @return AlarmingManagedObject The associated AlarmingManagedObject object.
     * @throws PropelException
     */
    public function getAlarmingManagedObject(PropelPDO $con = null, $doQuery = true)
    {
        if ($this->aAlarmingManagedObject === null && ($this->amo_id !== null) && $doQuery) {
            $this->aAlarmingManagedObject = AlarmingManagedObjectQuery::create()->findPk($this->amo_id, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aAlarmingManagedObject->addCacs($this);
             */
        }

        return $this->aAlarmingManagedObject;
    }

    /**
     * Declares an association between this object and a AlarmEventDescriptor object.
     *
     * @param                  AlarmEventDescriptor $v
     * @return CurrentAlarmCondition The current object (for fluent API support)
     * @throws PropelException
     */
    public function setAlarmEventDescriptor(AlarmEventDescriptor $v = null)
    {
        if ($v === null) {
            $this->setAedId(NULL);
        } else {
            $this->setAedId($v->getId());
        }

        $this->aAlarmEventDescriptor = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the AlarmEventDescriptor object, it will not be re-added.
        if ($v !== null) {
            $v->addCac($this);
        }


        return $this;
    }


    /**
     * Get the associated AlarmEventDescriptor object
     *
     * @param PropelPDO $con Optional Connection object.
     * @param $doQuery Executes a query to get the object if required
     * @return AlarmEventDescriptor The associated AlarmEventDescriptor object.
     * @throws PropelException
     */
    public function getAlarmEventDescriptor(PropelPDO $con = null, $doQuery = true)
    {
        if ($this->aAlarmEventDescriptor === null && ($this->aed_id !== null) && $doQuery) {
            $this->aAlarmEventDescriptor = AlarmEventDescriptorQuery::create()->findPk($this->aed_id, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aAlarmEventDescriptor->addCacs($this);
             */
        }

        return $this->aAlarmEventDescriptor;
    }

    /**
     * Clears the current object and sets all attributes to their default values
     */
    public function clear()
    {
        $this->id = null;
        $this->amo_id = null;
        $this->aed_id = null;
        $this->evt_time = null;
        $this->rec_date = null;
        $this->alm_stat = null;
        $this->serv_infl = null;
        $this->obs_val = null;
        $this->alreadyInSave = false;
        $this->alreadyInValidation = false;
        $this->alreadyInClearAllReferencesDeep = false;
        $this->clearAllReferences();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references to other model objects or collections of model objects.
     *
     * This method is a user-space workaround for PHP's inability to garbage collect
     * objects with circular references (even in PHP 5.3). This is currently necessary
     * when using Propel in certain daemon or large-volume/high-memory operations.
     *
     * @param boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep && !$this->alreadyInClearAllReferencesDeep) {
            $this->alreadyInClearAllReferencesDeep = true;
            if ($this->aAlarmingManagedObject instanceof Persistent) {
              $this->aAlarmingManagedObject->clearAllReferences($deep);
            }
            if ($this->aAlarmEventDescriptor instanceof Persistent) {
              $this->aAlarmEventDescriptor->clearAllReferences($deep);
            }

            $this->alreadyInClearAllReferencesDeep = false;
        } // if ($deep)

        $this->aAlarmingManagedObject = null;
        $this->aAlarmEventDescriptor = null;
    }

    /**
     * return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(CurrentAlarmConditionPeer::DEFAULT_STRING_FORMAT);
    }

    /**
     * return true is the object is in saving state
     *
     * @return boolean
     */
    public function isAlreadyInSave()
    {
        return $this->alreadyInSave;
    }

}
