<?php


/**
 * Base class that represents a query for the 'cur_alm_cond' table.
 *
 *
 *
 * @method CurrentAlarmConditionQuery orderById($order = Criteria::ASC) Order by the id column
 * @method CurrentAlarmConditionQuery orderByAmoId($order = Criteria::ASC) Order by the amo_id column
 * @method CurrentAlarmConditionQuery orderByAedId($order = Criteria::ASC) Order by the aed_id column
 * @method CurrentAlarmConditionQuery orderByEvtTime($order = Criteria::ASC) Order by the evt_time column
 * @method CurrentAlarmConditionQuery orderByRecDate($order = Criteria::ASC) Order by the rec_date column
 * @method CurrentAlarmConditionQuery orderByAlmStat($order = Criteria::ASC) Order by the alm_stat column
 * @method CurrentAlarmConditionQuery orderByServInfl($order = Criteria::ASC) Order by the serv_infl column
 * @method CurrentAlarmConditionQuery orderByObsVal($order = Criteria::ASC) Order by the obs_val column
 *
 * @method CurrentAlarmConditionQuery groupById() Group by the id column
 * @method CurrentAlarmConditionQuery groupByAmoId() Group by the amo_id column
 * @method CurrentAlarmConditionQuery groupByAedId() Group by the aed_id column
 * @method CurrentAlarmConditionQuery groupByEvtTime() Group by the evt_time column
 * @method CurrentAlarmConditionQuery groupByRecDate() Group by the rec_date column
 * @method CurrentAlarmConditionQuery groupByAlmStat() Group by the alm_stat column
 * @method CurrentAlarmConditionQuery groupByServInfl() Group by the serv_infl column
 * @method CurrentAlarmConditionQuery groupByObsVal() Group by the obs_val column
 *
 * @method CurrentAlarmConditionQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method CurrentAlarmConditionQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method CurrentAlarmConditionQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method CurrentAlarmConditionQuery leftJoinAlarmingManagedObject($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmingManagedObject relation
 * @method CurrentAlarmConditionQuery rightJoinAlarmingManagedObject($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmingManagedObject relation
 * @method CurrentAlarmConditionQuery innerJoinAlarmingManagedObject($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmingManagedObject relation
 *
 * @method CurrentAlarmConditionQuery leftJoinAlarmEventDescriptor($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmEventDescriptor relation
 * @method CurrentAlarmConditionQuery rightJoinAlarmEventDescriptor($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmEventDescriptor relation
 * @method CurrentAlarmConditionQuery innerJoinAlarmEventDescriptor($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmEventDescriptor relation
 *
 * @method CurrentAlarmCondition findOne(PropelPDO $con = null) Return the first CurrentAlarmCondition matching the query
 * @method CurrentAlarmCondition findOneOrCreate(PropelPDO $con = null) Return the first CurrentAlarmCondition matching the query, or a new CurrentAlarmCondition object populated from the query conditions when no match is found
 *
 * @method CurrentAlarmCondition findOneByAmoId(int $amo_id) Return the first CurrentAlarmCondition filtered by the amo_id column
 * @method CurrentAlarmCondition findOneByAedId(int $aed_id) Return the first CurrentAlarmCondition filtered by the aed_id column
 * @method CurrentAlarmCondition findOneByEvtTime(string $evt_time) Return the first CurrentAlarmCondition filtered by the evt_time column
 * @method CurrentAlarmCondition findOneByRecDate(string $rec_date) Return the first CurrentAlarmCondition filtered by the rec_date column
 * @method CurrentAlarmCondition findOneByAlmStat(int $alm_stat) Return the first CurrentAlarmCondition filtered by the alm_stat column
 * @method CurrentAlarmCondition findOneByServInfl(int $serv_infl) Return the first CurrentAlarmCondition filtered by the serv_infl column
 * @method CurrentAlarmCondition findOneByObsVal(int $obs_val) Return the first CurrentAlarmCondition filtered by the obs_val column
 *
 * @method array findById(int $id) Return CurrentAlarmCondition objects filtered by the id column
 * @method array findByAmoId(int $amo_id) Return CurrentAlarmCondition objects filtered by the amo_id column
 * @method array findByAedId(int $aed_id) Return CurrentAlarmCondition objects filtered by the aed_id column
 * @method array findByEvtTime(string $evt_time) Return CurrentAlarmCondition objects filtered by the evt_time column
 * @method array findByRecDate(string $rec_date) Return CurrentAlarmCondition objects filtered by the rec_date column
 * @method array findByAlmStat(int $alm_stat) Return CurrentAlarmCondition objects filtered by the alm_stat column
 * @method array findByServInfl(int $serv_infl) Return CurrentAlarmCondition objects filtered by the serv_infl column
 * @method array findByObsVal(int $obs_val) Return CurrentAlarmCondition objects filtered by the obs_val column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseCurrentAlarmConditionQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseCurrentAlarmConditionQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'CurrentAlarmCondition';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new CurrentAlarmConditionQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   CurrentAlarmConditionQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return CurrentAlarmConditionQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof CurrentAlarmConditionQuery) {
            return $criteria;
        }
        $query = new CurrentAlarmConditionQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   CurrentAlarmCondition|CurrentAlarmCondition[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = CurrentAlarmConditionPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(CurrentAlarmConditionPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 CurrentAlarmCondition A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 CurrentAlarmCondition A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `amo_id`, `aed_id`, `evt_time`, `rec_date`, `alm_stat`, `serv_infl`, `obs_val` FROM `cur_alm_cond` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new CurrentAlarmCondition();
            $obj->hydrate($row);
            CurrentAlarmConditionPeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return CurrentAlarmCondition|CurrentAlarmCondition[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|CurrentAlarmCondition[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(CurrentAlarmConditionPeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(CurrentAlarmConditionPeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(CurrentAlarmConditionPeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the amo_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAmoId(1234); // WHERE amo_id = 1234
     * $query->filterByAmoId(array(12, 34)); // WHERE amo_id IN (12, 34)
     * $query->filterByAmoId(array('min' => 12)); // WHERE amo_id >= 12
     * $query->filterByAmoId(array('max' => 12)); // WHERE amo_id <= 12
     * </code>
     *
     * @see       filterByAlarmingManagedObject()
     *
     * @param     mixed $amoId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function filterByAmoId($amoId = null, $comparison = null)
    {
        if (is_array($amoId)) {
            $useMinMax = false;
            if (isset($amoId['min'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::AMO_ID, $amoId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($amoId['max'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::AMO_ID, $amoId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(CurrentAlarmConditionPeer::AMO_ID, $amoId, $comparison);
    }

    /**
     * Filter the query on the aed_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAedId(1234); // WHERE aed_id = 1234
     * $query->filterByAedId(array(12, 34)); // WHERE aed_id IN (12, 34)
     * $query->filterByAedId(array('min' => 12)); // WHERE aed_id >= 12
     * $query->filterByAedId(array('max' => 12)); // WHERE aed_id <= 12
     * </code>
     *
     * @see       filterByAlarmEventDescriptor()
     *
     * @param     mixed $aedId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function filterByAedId($aedId = null, $comparison = null)
    {
        if (is_array($aedId)) {
            $useMinMax = false;
            if (isset($aedId['min'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::AED_ID, $aedId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($aedId['max'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::AED_ID, $aedId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(CurrentAlarmConditionPeer::AED_ID, $aedId, $comparison);
    }

    /**
     * Filter the query on the evt_time column
     *
     * Example usage:
     * <code>
     * $query->filterByEvtTime('fooValue');   // WHERE evt_time = 'fooValue'
     * $query->filterByEvtTime('%fooValue%'); // WHERE evt_time LIKE '%fooValue%'
     * </code>
     *
     * @param     string $evtTime The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function filterByEvtTime($evtTime = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($evtTime)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $evtTime)) {
                $evtTime = str_replace('*', '%', $evtTime);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(CurrentAlarmConditionPeer::EVT_TIME, $evtTime, $comparison);
    }

    /**
     * Filter the query on the rec_date column
     *
     * Example usage:
     * <code>
     * $query->filterByRecDate('fooValue');   // WHERE rec_date = 'fooValue'
     * $query->filterByRecDate('%fooValue%'); // WHERE rec_date LIKE '%fooValue%'
     * </code>
     *
     * @param     string $recDate The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function filterByRecDate($recDate = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($recDate)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $recDate)) {
                $recDate = str_replace('*', '%', $recDate);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(CurrentAlarmConditionPeer::REC_DATE, $recDate, $comparison);
    }

    /**
     * Filter the query on the alm_stat column
     *
     * Example usage:
     * <code>
     * $query->filterByAlmStat(1234); // WHERE alm_stat = 1234
     * $query->filterByAlmStat(array(12, 34)); // WHERE alm_stat IN (12, 34)
     * $query->filterByAlmStat(array('min' => 12)); // WHERE alm_stat >= 12
     * $query->filterByAlmStat(array('max' => 12)); // WHERE alm_stat <= 12
     * </code>
     *
     * @param     mixed $almStat The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function filterByAlmStat($almStat = null, $comparison = null)
    {
        if (is_array($almStat)) {
            $useMinMax = false;
            if (isset($almStat['min'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::ALM_STAT, $almStat['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($almStat['max'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::ALM_STAT, $almStat['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(CurrentAlarmConditionPeer::ALM_STAT, $almStat, $comparison);
    }

    /**
     * Filter the query on the serv_infl column
     *
     * Example usage:
     * <code>
     * $query->filterByServInfl(1234); // WHERE serv_infl = 1234
     * $query->filterByServInfl(array(12, 34)); // WHERE serv_infl IN (12, 34)
     * $query->filterByServInfl(array('min' => 12)); // WHERE serv_infl >= 12
     * $query->filterByServInfl(array('max' => 12)); // WHERE serv_infl <= 12
     * </code>
     *
     * @param     mixed $servInfl The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function filterByServInfl($servInfl = null, $comparison = null)
    {
        if (is_array($servInfl)) {
            $useMinMax = false;
            if (isset($servInfl['min'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::SERV_INFL, $servInfl['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($servInfl['max'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::SERV_INFL, $servInfl['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(CurrentAlarmConditionPeer::SERV_INFL, $servInfl, $comparison);
    }

    /**
     * Filter the query on the obs_val column
     *
     * Example usage:
     * <code>
     * $query->filterByObsVal(1234); // WHERE obs_val = 1234
     * $query->filterByObsVal(array(12, 34)); // WHERE obs_val IN (12, 34)
     * $query->filterByObsVal(array('min' => 12)); // WHERE obs_val >= 12
     * $query->filterByObsVal(array('max' => 12)); // WHERE obs_val <= 12
     * </code>
     *
     * @param     mixed $obsVal The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function filterByObsVal($obsVal = null, $comparison = null)
    {
        if (is_array($obsVal)) {
            $useMinMax = false;
            if (isset($obsVal['min'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::OBS_VAL, $obsVal['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($obsVal['max'])) {
                $this->addUsingAlias(CurrentAlarmConditionPeer::OBS_VAL, $obsVal['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(CurrentAlarmConditionPeer::OBS_VAL, $obsVal, $comparison);
    }

    /**
     * Filter the query by a related AlarmingManagedObject object
     *
     * @param   AlarmingManagedObject|PropelObjectCollection $alarmingManagedObject The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 CurrentAlarmConditionQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmingManagedObject($alarmingManagedObject, $comparison = null)
    {
        if ($alarmingManagedObject instanceof AlarmingManagedObject) {
            return $this
                ->addUsingAlias(CurrentAlarmConditionPeer::AMO_ID, $alarmingManagedObject->getId(), $comparison);
        } elseif ($alarmingManagedObject instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(CurrentAlarmConditionPeer::AMO_ID, $alarmingManagedObject->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmingManagedObject() only accepts arguments of type AlarmingManagedObject or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmingManagedObject relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function joinAlarmingManagedObject($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmingManagedObject');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmingManagedObject');
        }

        return $this;
    }

    /**
     * Use the AlarmingManagedObject relation AlarmingManagedObject object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmingManagedObjectQuery A secondary query class using the current class as primary query
     */
    public function useAlarmingManagedObjectQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmingManagedObject($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmingManagedObject', 'AlarmingManagedObjectQuery');
    }

    /**
     * Filter the query by a related AlarmEventDescriptor object
     *
     * @param   AlarmEventDescriptor|PropelObjectCollection $alarmEventDescriptor The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 CurrentAlarmConditionQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmEventDescriptor($alarmEventDescriptor, $comparison = null)
    {
        if ($alarmEventDescriptor instanceof AlarmEventDescriptor) {
            return $this
                ->addUsingAlias(CurrentAlarmConditionPeer::AED_ID, $alarmEventDescriptor->getId(), $comparison);
        } elseif ($alarmEventDescriptor instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(CurrentAlarmConditionPeer::AED_ID, $alarmEventDescriptor->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmEventDescriptor() only accepts arguments of type AlarmEventDescriptor or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmEventDescriptor relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function joinAlarmEventDescriptor($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmEventDescriptor');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmEventDescriptor');
        }

        return $this;
    }

    /**
     * Use the AlarmEventDescriptor relation AlarmEventDescriptor object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmEventDescriptorQuery A secondary query class using the current class as primary query
     */
    public function useAlarmEventDescriptorQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmEventDescriptor($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmEventDescriptor', 'AlarmEventDescriptorQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   CurrentAlarmCondition $currentAlarmCondition Object to remove from the list of results
     *
     * @return CurrentAlarmConditionQuery The current query, for fluid interface
     */
    public function prune($currentAlarmCondition = null)
    {
        if ($currentAlarmCondition) {
            $this->addUsingAlias(CurrentAlarmConditionPeer::ID, $currentAlarmCondition->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
