<?php


/**
 * Base class that represents a query for the 'dest_host_sel' table.
 *
 *
 *
 * @method DestinationHostSelectorQuery orderById($order = Criteria::ASC) Order by the id column
 * @method DestinationHostSelectorQuery orderByAfiId($order = Criteria::ASC) Order by the afi_id column
 * @method DestinationHostSelectorQuery orderByAmhId($order = Criteria::ASC) Order by the amh_id column
 *
 * @method DestinationHostSelectorQuery groupById() Group by the id column
 * @method DestinationHostSelectorQuery groupByAfiId() Group by the afi_id column
 * @method DestinationHostSelectorQuery groupByAmhId() Group by the amh_id column
 *
 * @method DestinationHostSelectorQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method DestinationHostSelectorQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method DestinationHostSelectorQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method DestinationHostSelectorQuery leftJoinAlarmForwardingInstruction($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmForwardingInstruction relation
 * @method DestinationHostSelectorQuery rightJoinAlarmForwardingInstruction($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmForwardingInstruction relation
 * @method DestinationHostSelectorQuery innerJoinAlarmForwardingInstruction($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmForwardingInstruction relation
 *
 * @method DestinationHostSelectorQuery leftJoinAlarmingManagementHost($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmingManagementHost relation
 * @method DestinationHostSelectorQuery rightJoinAlarmingManagementHost($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmingManagementHost relation
 * @method DestinationHostSelectorQuery innerJoinAlarmingManagementHost($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmingManagementHost relation
 *
 * @method DestinationHostSelector findOne(PropelPDO $con = null) Return the first DestinationHostSelector matching the query
 * @method DestinationHostSelector findOneOrCreate(PropelPDO $con = null) Return the first DestinationHostSelector matching the query, or a new DestinationHostSelector object populated from the query conditions when no match is found
 *
 * @method DestinationHostSelector findOneByAfiId(int $afi_id) Return the first DestinationHostSelector filtered by the afi_id column
 * @method DestinationHostSelector findOneByAmhId(int $amh_id) Return the first DestinationHostSelector filtered by the amh_id column
 *
 * @method array findById(int $id) Return DestinationHostSelector objects filtered by the id column
 * @method array findByAfiId(int $afi_id) Return DestinationHostSelector objects filtered by the afi_id column
 * @method array findByAmhId(int $amh_id) Return DestinationHostSelector objects filtered by the amh_id column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseDestinationHostSelectorQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseDestinationHostSelectorQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'DestinationHostSelector';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new DestinationHostSelectorQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   DestinationHostSelectorQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return DestinationHostSelectorQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof DestinationHostSelectorQuery) {
            return $criteria;
        }
        $query = new DestinationHostSelectorQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   DestinationHostSelector|DestinationHostSelector[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = DestinationHostSelectorPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(DestinationHostSelectorPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 DestinationHostSelector A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 DestinationHostSelector A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `afi_id`, `amh_id` FROM `dest_host_sel` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new DestinationHostSelector();
            $obj->hydrate($row);
            DestinationHostSelectorPeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return DestinationHostSelector|DestinationHostSelector[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|DestinationHostSelector[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return DestinationHostSelectorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(DestinationHostSelectorPeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return DestinationHostSelectorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(DestinationHostSelectorPeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return DestinationHostSelectorQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(DestinationHostSelectorPeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(DestinationHostSelectorPeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(DestinationHostSelectorPeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the afi_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAfiId(1234); // WHERE afi_id = 1234
     * $query->filterByAfiId(array(12, 34)); // WHERE afi_id IN (12, 34)
     * $query->filterByAfiId(array('min' => 12)); // WHERE afi_id >= 12
     * $query->filterByAfiId(array('max' => 12)); // WHERE afi_id <= 12
     * </code>
     *
     * @see       filterByAlarmForwardingInstruction()
     *
     * @param     mixed $afiId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return DestinationHostSelectorQuery The current query, for fluid interface
     */
    public function filterByAfiId($afiId = null, $comparison = null)
    {
        if (is_array($afiId)) {
            $useMinMax = false;
            if (isset($afiId['min'])) {
                $this->addUsingAlias(DestinationHostSelectorPeer::AFI_ID, $afiId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($afiId['max'])) {
                $this->addUsingAlias(DestinationHostSelectorPeer::AFI_ID, $afiId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(DestinationHostSelectorPeer::AFI_ID, $afiId, $comparison);
    }

    /**
     * Filter the query on the amh_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAmhId(1234); // WHERE amh_id = 1234
     * $query->filterByAmhId(array(12, 34)); // WHERE amh_id IN (12, 34)
     * $query->filterByAmhId(array('min' => 12)); // WHERE amh_id >= 12
     * $query->filterByAmhId(array('max' => 12)); // WHERE amh_id <= 12
     * </code>
     *
     * @see       filterByAlarmingManagementHost()
     *
     * @param     mixed $amhId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return DestinationHostSelectorQuery The current query, for fluid interface
     */
    public function filterByAmhId($amhId = null, $comparison = null)
    {
        if (is_array($amhId)) {
            $useMinMax = false;
            if (isset($amhId['min'])) {
                $this->addUsingAlias(DestinationHostSelectorPeer::AMH_ID, $amhId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($amhId['max'])) {
                $this->addUsingAlias(DestinationHostSelectorPeer::AMH_ID, $amhId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(DestinationHostSelectorPeer::AMH_ID, $amhId, $comparison);
    }

    /**
     * Filter the query by a related AlarmForwardingInstruction object
     *
     * @param   AlarmForwardingInstruction|PropelObjectCollection $alarmForwardingInstruction The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 DestinationHostSelectorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmForwardingInstruction($alarmForwardingInstruction, $comparison = null)
    {
        if ($alarmForwardingInstruction instanceof AlarmForwardingInstruction) {
            return $this
                ->addUsingAlias(DestinationHostSelectorPeer::AFI_ID, $alarmForwardingInstruction->getId(), $comparison);
        } elseif ($alarmForwardingInstruction instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(DestinationHostSelectorPeer::AFI_ID, $alarmForwardingInstruction->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmForwardingInstruction() only accepts arguments of type AlarmForwardingInstruction or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmForwardingInstruction relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return DestinationHostSelectorQuery The current query, for fluid interface
     */
    public function joinAlarmForwardingInstruction($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmForwardingInstruction');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmForwardingInstruction');
        }

        return $this;
    }

    /**
     * Use the AlarmForwardingInstruction relation AlarmForwardingInstruction object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmForwardingInstructionQuery A secondary query class using the current class as primary query
     */
    public function useAlarmForwardingInstructionQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmForwardingInstruction($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmForwardingInstruction', 'AlarmForwardingInstructionQuery');
    }

    /**
     * Filter the query by a related AlarmingManagementHost object
     *
     * @param   AlarmingManagementHost|PropelObjectCollection $alarmingManagementHost The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 DestinationHostSelectorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmingManagementHost($alarmingManagementHost, $comparison = null)
    {
        if ($alarmingManagementHost instanceof AlarmingManagementHost) {
            return $this
                ->addUsingAlias(DestinationHostSelectorPeer::AMH_ID, $alarmingManagementHost->getId(), $comparison);
        } elseif ($alarmingManagementHost instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(DestinationHostSelectorPeer::AMH_ID, $alarmingManagementHost->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmingManagementHost() only accepts arguments of type AlarmingManagementHost or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmingManagementHost relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return DestinationHostSelectorQuery The current query, for fluid interface
     */
    public function joinAlarmingManagementHost($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmingManagementHost');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmingManagementHost');
        }

        return $this;
    }

    /**
     * Use the AlarmingManagementHost relation AlarmingManagementHost object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmingManagementHostQuery A secondary query class using the current class as primary query
     */
    public function useAlarmingManagementHostQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmingManagementHost($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmingManagementHost', 'AlarmingManagementHostQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   DestinationHostSelector $destinationHostSelector Object to remove from the list of results
     *
     * @return DestinationHostSelectorQuery The current query, for fluid interface
     */
    public function prune($destinationHostSelector = null)
    {
        if ($destinationHostSelector) {
            $this->addUsingAlias(DestinationHostSelectorPeer::ID, $destinationHostSelector->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
