<?php


/**
 * Base class that represents a query for the 'esc_host_sel' table.
 *
 *
 *
 * @method EscalationHostSelectorQuery orderById($order = Criteria::ASC) Order by the id column
 * @method EscalationHostSelectorQuery orderByAbmId($order = Criteria::ASC) Order by the abm_id column
 * @method EscalationHostSelectorQuery orderByAmhId($order = Criteria::ASC) Order by the amh_id column
 *
 * @method EscalationHostSelectorQuery groupById() Group by the id column
 * @method EscalationHostSelectorQuery groupByAbmId() Group by the abm_id column
 * @method EscalationHostSelectorQuery groupByAmhId() Group by the amh_id column
 *
 * @method EscalationHostSelectorQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method EscalationHostSelectorQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method EscalationHostSelectorQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method EscalationHostSelectorQuery leftJoinAlarmBalanceMonitor($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmBalanceMonitor relation
 * @method EscalationHostSelectorQuery rightJoinAlarmBalanceMonitor($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmBalanceMonitor relation
 * @method EscalationHostSelectorQuery innerJoinAlarmBalanceMonitor($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmBalanceMonitor relation
 *
 * @method EscalationHostSelectorQuery leftJoinAlarmingManagementHost($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmingManagementHost relation
 * @method EscalationHostSelectorQuery rightJoinAlarmingManagementHost($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmingManagementHost relation
 * @method EscalationHostSelectorQuery innerJoinAlarmingManagementHost($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmingManagementHost relation
 *
 * @method EscalationHostSelector findOne(PropelPDO $con = null) Return the first EscalationHostSelector matching the query
 * @method EscalationHostSelector findOneOrCreate(PropelPDO $con = null) Return the first EscalationHostSelector matching the query, or a new EscalationHostSelector object populated from the query conditions when no match is found
 *
 * @method EscalationHostSelector findOneByAbmId(int $abm_id) Return the first EscalationHostSelector filtered by the abm_id column
 * @method EscalationHostSelector findOneByAmhId(int $amh_id) Return the first EscalationHostSelector filtered by the amh_id column
 *
 * @method array findById(int $id) Return EscalationHostSelector objects filtered by the id column
 * @method array findByAbmId(int $abm_id) Return EscalationHostSelector objects filtered by the abm_id column
 * @method array findByAmhId(int $amh_id) Return EscalationHostSelector objects filtered by the amh_id column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseEscalationHostSelectorQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseEscalationHostSelectorQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'EscalationHostSelector';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new EscalationHostSelectorQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   EscalationHostSelectorQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return EscalationHostSelectorQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof EscalationHostSelectorQuery) {
            return $criteria;
        }
        $query = new EscalationHostSelectorQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   EscalationHostSelector|EscalationHostSelector[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = EscalationHostSelectorPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(EscalationHostSelectorPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 EscalationHostSelector A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 EscalationHostSelector A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `abm_id`, `amh_id` FROM `esc_host_sel` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new EscalationHostSelector();
            $obj->hydrate($row);
            EscalationHostSelectorPeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return EscalationHostSelector|EscalationHostSelector[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|EscalationHostSelector[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return EscalationHostSelectorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(EscalationHostSelectorPeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return EscalationHostSelectorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(EscalationHostSelectorPeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return EscalationHostSelectorQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(EscalationHostSelectorPeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(EscalationHostSelectorPeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(EscalationHostSelectorPeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the abm_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAbmId(1234); // WHERE abm_id = 1234
     * $query->filterByAbmId(array(12, 34)); // WHERE abm_id IN (12, 34)
     * $query->filterByAbmId(array('min' => 12)); // WHERE abm_id >= 12
     * $query->filterByAbmId(array('max' => 12)); // WHERE abm_id <= 12
     * </code>
     *
     * @see       filterByAlarmBalanceMonitor()
     *
     * @param     mixed $abmId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return EscalationHostSelectorQuery The current query, for fluid interface
     */
    public function filterByAbmId($abmId = null, $comparison = null)
    {
        if (is_array($abmId)) {
            $useMinMax = false;
            if (isset($abmId['min'])) {
                $this->addUsingAlias(EscalationHostSelectorPeer::ABM_ID, $abmId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($abmId['max'])) {
                $this->addUsingAlias(EscalationHostSelectorPeer::ABM_ID, $abmId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(EscalationHostSelectorPeer::ABM_ID, $abmId, $comparison);
    }

    /**
     * Filter the query on the amh_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAmhId(1234); // WHERE amh_id = 1234
     * $query->filterByAmhId(array(12, 34)); // WHERE amh_id IN (12, 34)
     * $query->filterByAmhId(array('min' => 12)); // WHERE amh_id >= 12
     * $query->filterByAmhId(array('max' => 12)); // WHERE amh_id <= 12
     * </code>
     *
     * @see       filterByAlarmingManagementHost()
     *
     * @param     mixed $amhId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return EscalationHostSelectorQuery The current query, for fluid interface
     */
    public function filterByAmhId($amhId = null, $comparison = null)
    {
        if (is_array($amhId)) {
            $useMinMax = false;
            if (isset($amhId['min'])) {
                $this->addUsingAlias(EscalationHostSelectorPeer::AMH_ID, $amhId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($amhId['max'])) {
                $this->addUsingAlias(EscalationHostSelectorPeer::AMH_ID, $amhId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(EscalationHostSelectorPeer::AMH_ID, $amhId, $comparison);
    }

    /**
     * Filter the query by a related AlarmBalanceMonitor object
     *
     * @param   AlarmBalanceMonitor|PropelObjectCollection $alarmBalanceMonitor The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 EscalationHostSelectorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmBalanceMonitor($alarmBalanceMonitor, $comparison = null)
    {
        if ($alarmBalanceMonitor instanceof AlarmBalanceMonitor) {
            return $this
                ->addUsingAlias(EscalationHostSelectorPeer::ABM_ID, $alarmBalanceMonitor->getId(), $comparison);
        } elseif ($alarmBalanceMonitor instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(EscalationHostSelectorPeer::ABM_ID, $alarmBalanceMonitor->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmBalanceMonitor() only accepts arguments of type AlarmBalanceMonitor or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmBalanceMonitor relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return EscalationHostSelectorQuery The current query, for fluid interface
     */
    public function joinAlarmBalanceMonitor($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmBalanceMonitor');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmBalanceMonitor');
        }

        return $this;
    }

    /**
     * Use the AlarmBalanceMonitor relation AlarmBalanceMonitor object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmBalanceMonitorQuery A secondary query class using the current class as primary query
     */
    public function useAlarmBalanceMonitorQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmBalanceMonitor($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmBalanceMonitor', 'AlarmBalanceMonitorQuery');
    }

    /**
     * Filter the query by a related AlarmingManagementHost object
     *
     * @param   AlarmingManagementHost|PropelObjectCollection $alarmingManagementHost The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 EscalationHostSelectorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmingManagementHost($alarmingManagementHost, $comparison = null)
    {
        if ($alarmingManagementHost instanceof AlarmingManagementHost) {
            return $this
                ->addUsingAlias(EscalationHostSelectorPeer::AMH_ID, $alarmingManagementHost->getId(), $comparison);
        } elseif ($alarmingManagementHost instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(EscalationHostSelectorPeer::AMH_ID, $alarmingManagementHost->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmingManagementHost() only accepts arguments of type AlarmingManagementHost or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmingManagementHost relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return EscalationHostSelectorQuery The current query, for fluid interface
     */
    public function joinAlarmingManagementHost($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmingManagementHost');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmingManagementHost');
        }

        return $this;
    }

    /**
     * Use the AlarmingManagementHost relation AlarmingManagementHost object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmingManagementHostQuery A secondary query class using the current class as primary query
     */
    public function useAlarmingManagementHostQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmingManagementHost($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmingManagementHost', 'AlarmingManagementHostQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   EscalationHostSelector $escalationHostSelector Object to remove from the list of results
     *
     * @return EscalationHostSelectorQuery The current query, for fluid interface
     */
    public function prune($escalationHostSelector = null)
    {
        if ($escalationHostSelector) {
            $this->addUsingAlias(EscalationHostSelectorPeer::ID, $escalationHostSelector->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
