<?php


/**
 * Base class that represents a query for the 'forw_evt_sel' table.
 *
 *
 *
 * @method ForwardingEventSelectorQuery orderById($order = Criteria::ASC) Order by the id column
 * @method ForwardingEventSelectorQuery orderByAfiId($order = Criteria::ASC) Order by the afi_id column
 * @method ForwardingEventSelectorQuery orderByAedId($order = Criteria::ASC) Order by the aed_id column
 *
 * @method ForwardingEventSelectorQuery groupById() Group by the id column
 * @method ForwardingEventSelectorQuery groupByAfiId() Group by the afi_id column
 * @method ForwardingEventSelectorQuery groupByAedId() Group by the aed_id column
 *
 * @method ForwardingEventSelectorQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method ForwardingEventSelectorQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method ForwardingEventSelectorQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method ForwardingEventSelectorQuery leftJoinAlarmForwardingInstruction($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmForwardingInstruction relation
 * @method ForwardingEventSelectorQuery rightJoinAlarmForwardingInstruction($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmForwardingInstruction relation
 * @method ForwardingEventSelectorQuery innerJoinAlarmForwardingInstruction($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmForwardingInstruction relation
 *
 * @method ForwardingEventSelectorQuery leftJoinAlarmEventDescriptor($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmEventDescriptor relation
 * @method ForwardingEventSelectorQuery rightJoinAlarmEventDescriptor($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmEventDescriptor relation
 * @method ForwardingEventSelectorQuery innerJoinAlarmEventDescriptor($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmEventDescriptor relation
 *
 * @method ForwardingEventSelector findOne(PropelPDO $con = null) Return the first ForwardingEventSelector matching the query
 * @method ForwardingEventSelector findOneOrCreate(PropelPDO $con = null) Return the first ForwardingEventSelector matching the query, or a new ForwardingEventSelector object populated from the query conditions when no match is found
 *
 * @method ForwardingEventSelector findOneByAfiId(int $afi_id) Return the first ForwardingEventSelector filtered by the afi_id column
 * @method ForwardingEventSelector findOneByAedId(int $aed_id) Return the first ForwardingEventSelector filtered by the aed_id column
 *
 * @method array findById(int $id) Return ForwardingEventSelector objects filtered by the id column
 * @method array findByAfiId(int $afi_id) Return ForwardingEventSelector objects filtered by the afi_id column
 * @method array findByAedId(int $aed_id) Return ForwardingEventSelector objects filtered by the aed_id column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseForwardingEventSelectorQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseForwardingEventSelectorQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'ForwardingEventSelector';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ForwardingEventSelectorQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   ForwardingEventSelectorQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return ForwardingEventSelectorQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof ForwardingEventSelectorQuery) {
            return $criteria;
        }
        $query = new ForwardingEventSelectorQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   ForwardingEventSelector|ForwardingEventSelector[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = ForwardingEventSelectorPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(ForwardingEventSelectorPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 ForwardingEventSelector A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 ForwardingEventSelector A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `afi_id`, `aed_id` FROM `forw_evt_sel` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new ForwardingEventSelector();
            $obj->hydrate($row);
            ForwardingEventSelectorPeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return ForwardingEventSelector|ForwardingEventSelector[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|ForwardingEventSelector[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return ForwardingEventSelectorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(ForwardingEventSelectorPeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return ForwardingEventSelectorQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(ForwardingEventSelectorPeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ForwardingEventSelectorQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(ForwardingEventSelectorPeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(ForwardingEventSelectorPeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ForwardingEventSelectorPeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the afi_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAfiId(1234); // WHERE afi_id = 1234
     * $query->filterByAfiId(array(12, 34)); // WHERE afi_id IN (12, 34)
     * $query->filterByAfiId(array('min' => 12)); // WHERE afi_id >= 12
     * $query->filterByAfiId(array('max' => 12)); // WHERE afi_id <= 12
     * </code>
     *
     * @see       filterByAlarmForwardingInstruction()
     *
     * @param     mixed $afiId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ForwardingEventSelectorQuery The current query, for fluid interface
     */
    public function filterByAfiId($afiId = null, $comparison = null)
    {
        if (is_array($afiId)) {
            $useMinMax = false;
            if (isset($afiId['min'])) {
                $this->addUsingAlias(ForwardingEventSelectorPeer::AFI_ID, $afiId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($afiId['max'])) {
                $this->addUsingAlias(ForwardingEventSelectorPeer::AFI_ID, $afiId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ForwardingEventSelectorPeer::AFI_ID, $afiId, $comparison);
    }

    /**
     * Filter the query on the aed_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAedId(1234); // WHERE aed_id = 1234
     * $query->filterByAedId(array(12, 34)); // WHERE aed_id IN (12, 34)
     * $query->filterByAedId(array('min' => 12)); // WHERE aed_id >= 12
     * $query->filterByAedId(array('max' => 12)); // WHERE aed_id <= 12
     * </code>
     *
     * @see       filterByAlarmEventDescriptor()
     *
     * @param     mixed $aedId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ForwardingEventSelectorQuery The current query, for fluid interface
     */
    public function filterByAedId($aedId = null, $comparison = null)
    {
        if (is_array($aedId)) {
            $useMinMax = false;
            if (isset($aedId['min'])) {
                $this->addUsingAlias(ForwardingEventSelectorPeer::AED_ID, $aedId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($aedId['max'])) {
                $this->addUsingAlias(ForwardingEventSelectorPeer::AED_ID, $aedId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ForwardingEventSelectorPeer::AED_ID, $aedId, $comparison);
    }

    /**
     * Filter the query by a related AlarmForwardingInstruction object
     *
     * @param   AlarmForwardingInstruction|PropelObjectCollection $alarmForwardingInstruction The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 ForwardingEventSelectorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmForwardingInstruction($alarmForwardingInstruction, $comparison = null)
    {
        if ($alarmForwardingInstruction instanceof AlarmForwardingInstruction) {
            return $this
                ->addUsingAlias(ForwardingEventSelectorPeer::AFI_ID, $alarmForwardingInstruction->getId(), $comparison);
        } elseif ($alarmForwardingInstruction instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(ForwardingEventSelectorPeer::AFI_ID, $alarmForwardingInstruction->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmForwardingInstruction() only accepts arguments of type AlarmForwardingInstruction or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmForwardingInstruction relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ForwardingEventSelectorQuery The current query, for fluid interface
     */
    public function joinAlarmForwardingInstruction($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmForwardingInstruction');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmForwardingInstruction');
        }

        return $this;
    }

    /**
     * Use the AlarmForwardingInstruction relation AlarmForwardingInstruction object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmForwardingInstructionQuery A secondary query class using the current class as primary query
     */
    public function useAlarmForwardingInstructionQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmForwardingInstruction($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmForwardingInstruction', 'AlarmForwardingInstructionQuery');
    }

    /**
     * Filter the query by a related AlarmEventDescriptor object
     *
     * @param   AlarmEventDescriptor|PropelObjectCollection $alarmEventDescriptor The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 ForwardingEventSelectorQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmEventDescriptor($alarmEventDescriptor, $comparison = null)
    {
        if ($alarmEventDescriptor instanceof AlarmEventDescriptor) {
            return $this
                ->addUsingAlias(ForwardingEventSelectorPeer::AED_ID, $alarmEventDescriptor->getId(), $comparison);
        } elseif ($alarmEventDescriptor instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(ForwardingEventSelectorPeer::AED_ID, $alarmEventDescriptor->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmEventDescriptor() only accepts arguments of type AlarmEventDescriptor or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmEventDescriptor relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ForwardingEventSelectorQuery The current query, for fluid interface
     */
    public function joinAlarmEventDescriptor($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmEventDescriptor');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmEventDescriptor');
        }

        return $this;
    }

    /**
     * Use the AlarmEventDescriptor relation AlarmEventDescriptor object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmEventDescriptorQuery A secondary query class using the current class as primary query
     */
    public function useAlarmEventDescriptorQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmEventDescriptor($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmEventDescriptor', 'AlarmEventDescriptorQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   ForwardingEventSelector $forwardingEventSelector Object to remove from the list of results
     *
     * @return ForwardingEventSelectorQuery The current query, for fluid interface
     */
    public function prune($forwardingEventSelector = null)
    {
        if ($forwardingEventSelector) {
            $this->addUsingAlias(ForwardingEventSelectorPeer::ID, $forwardingEventSelector->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
