<?php


/**
 * Base class that represents a query for the 'moc_dscr' table.
 *
 * 
 *
 * @method     ManagedObjectClassDescriptorQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     ManagedObjectClassDescriptorQuery orderByMod($order = Criteria::ASC) Order by the mod column
 * @method     ManagedObjectClassDescriptorQuery orderByIntern($order = Criteria::ASC) Order by the intern column
 * @method     ManagedObjectClassDescriptorQuery orderByExtern($order = Criteria::ASC) Order by the extern column
 *
 * @method     ManagedObjectClassDescriptorQuery groupById() Group by the id column
 * @method     ManagedObjectClassDescriptorQuery groupByMod() Group by the mod column
 * @method     ManagedObjectClassDescriptorQuery groupByIntern() Group by the intern column
 * @method     ManagedObjectClassDescriptorQuery groupByExtern() Group by the extern column
 *
 * @method     ManagedObjectClassDescriptorQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ManagedObjectClassDescriptorQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ManagedObjectClassDescriptorQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ManagedObjectClassDescriptorQuery leftJoinAtdc($relationAlias = null) Adds a LEFT JOIN clause to the query using the Atdc relation
 * @method     ManagedObjectClassDescriptorQuery rightJoinAtdc($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Atdc relation
 * @method     ManagedObjectClassDescriptorQuery innerJoinAtdc($relationAlias = null) Adds a INNER JOIN clause to the query using the Atdc relation
 *
 * @method     ManagedObjectClassDescriptor findOne(PropelPDO $con = null) Return the first ManagedObjectClassDescriptor matching the query
 * @method     ManagedObjectClassDescriptor findOneOrCreate(PropelPDO $con = null) Return the first ManagedObjectClassDescriptor matching the query, or a new ManagedObjectClassDescriptor object populated from the query conditions when no match is found
 *
 * @method     ManagedObjectClassDescriptor findOneById(int $id) Return the first ManagedObjectClassDescriptor filtered by the id column
 * @method     ManagedObjectClassDescriptor findOneByMod(int $mod) Return the first ManagedObjectClassDescriptor filtered by the mod column
 * @method     ManagedObjectClassDescriptor findOneByIntern(string $intern) Return the first ManagedObjectClassDescriptor filtered by the intern column
 * @method     ManagedObjectClassDescriptor findOneByExtern(string $extern) Return the first ManagedObjectClassDescriptor filtered by the extern column
 *
 * @method     array findById(int $id) Return ManagedObjectClassDescriptor objects filtered by the id column
 * @method     array findByMod(int $mod) Return ManagedObjectClassDescriptor objects filtered by the mod column
 * @method     array findByIntern(string $intern) Return ManagedObjectClassDescriptor objects filtered by the intern column
 * @method     array findByExtern(string $extern) Return ManagedObjectClassDescriptor objects filtered by the extern column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseManagedObjectClassDescriptorQuery extends ModelCriteria
{

	/**
	 * Initializes internal state of BaseManagedObjectClassDescriptorQuery object.
	 *
	 * @param     string $dbName The dabase name
	 * @param     string $modelName The phpName of a model, e.g. 'Book'
	 * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
	 */
	public function __construct($dbName = 'sysal', $modelName = 'ManagedObjectClassDescriptor', $modelAlias = null)
	{
		parent::__construct($dbName, $modelName, $modelAlias);
	}

	/**
	 * Returns a new ManagedObjectClassDescriptorQuery object.
	 *
	 * @param     string $modelAlias The alias of a model in the query
	 * @param     Criteria $criteria Optional Criteria to build the query from
	 *
	 * @return    ManagedObjectClassDescriptorQuery
	 */
	public static function create($modelAlias = null, $criteria = null)
	{
		if ($criteria instanceof ManagedObjectClassDescriptorQuery) {
			return $criteria;
		}
		$query = new ManagedObjectClassDescriptorQuery();
		if (null !== $modelAlias) {
			$query->setModelAlias($modelAlias);
		}
		if ($criteria instanceof Criteria) {
			$query->mergeWith($criteria);
		}
		return $query;
	}

	/**
	 * Find object by primary key
	 * Use instance pooling to avoid a database query if the object exists
	 * <code>
	 * $obj  = $c->findPk(12, $con);
	 * </code>
	 * @param     mixed $key Primary key to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    ManagedObjectClassDescriptor|array|mixed the result, formatted by the current formatter
	 */
	public function findPk($key, $con = null)
	{
		if ((null !== ($obj = ManagedObjectClassDescriptorPeer::getInstanceFromPool((string) $key))) && $this->getFormatter()->isObjectFormatter()) {
			// the object is alredy in the instance pool
			return $obj;
		} else {
			// the object has not been requested yet, or the formatter is not an object formatter
			$criteria = $this->isKeepQuery() ? clone $this : $this;
			$stmt = $criteria
				->filterByPrimaryKey($key)
				->getSelectStatement($con);
			return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
		}
	}

	/**
	 * Find objects by primary key
	 * <code>
	 * $objs = $c->findPks(array(12, 56, 832), $con);
	 * </code>
	 * @param     array $keys Primary keys to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    PropelObjectCollection|array|mixed the list of results, formatted by the current formatter
	 */
	public function findPks($keys, $con = null)
	{	
		$criteria = $this->isKeepQuery() ? clone $this : $this;
		return $this
			->filterByPrimaryKeys($keys)
			->find($con);
	}

	/**
	 * Filter the query by primary key
	 *
	 * @param     mixed $key Primary key to use for the query
	 *
	 * @return    ManagedObjectClassDescriptorQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKey($key)
	{
		return $this->addUsingAlias(ManagedObjectClassDescriptorPeer::ID, $key, Criteria::EQUAL);
	}

	/**
	 * Filter the query by a list of primary keys
	 *
	 * @param     array $keys The list of primary key to use for the query
	 *
	 * @return    ManagedObjectClassDescriptorQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKeys($keys)
	{
		return $this->addUsingAlias(ManagedObjectClassDescriptorPeer::ID, $keys, Criteria::IN);
	}

	/**
	 * Filter the query on the id column
	 * 
	 * @param     int|array $id The value to use as filter.
	 *            Accepts an associative array('min' => $minValue, 'max' => $maxValue)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ManagedObjectClassDescriptorQuery The current query, for fluid interface
	 */
	public function filterById($id = null, $comparison = null)
	{
		if (is_array($id) && null === $comparison) {
			$comparison = Criteria::IN;
		}
		return $this->addUsingAlias(ManagedObjectClassDescriptorPeer::ID, $id, $comparison);
	}

	/**
	 * Filter the query on the mod column
	 * 
	 * @param     int|array $mod The value to use as filter.
	 *            Accepts an associative array('min' => $minValue, 'max' => $maxValue)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ManagedObjectClassDescriptorQuery The current query, for fluid interface
	 */
	public function filterByMod($mod = null, $comparison = null)
	{
		if (is_array($mod)) {
			$useMinMax = false;
			if (isset($mod['min'])) {
				$this->addUsingAlias(ManagedObjectClassDescriptorPeer::MOD, $mod['min'], Criteria::GREATER_EQUAL);
				$useMinMax = true;
			}
			if (isset($mod['max'])) {
				$this->addUsingAlias(ManagedObjectClassDescriptorPeer::MOD, $mod['max'], Criteria::LESS_EQUAL);
				$useMinMax = true;
			}
			if ($useMinMax) {
				return $this;
			}
			if (null === $comparison) {
				$comparison = Criteria::IN;
			}
		}
		return $this->addUsingAlias(ManagedObjectClassDescriptorPeer::MOD, $mod, $comparison);
	}

	/**
	 * Filter the query on the intern column
	 * 
	 * @param     string $intern The value to use as filter.
	 *            Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ManagedObjectClassDescriptorQuery The current query, for fluid interface
	 */
	public function filterByIntern($intern = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($intern)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $intern)) {
				$intern = str_replace('*', '%', $intern);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(ManagedObjectClassDescriptorPeer::INTERN, $intern, $comparison);
	}

	/**
	 * Filter the query on the extern column
	 * 
	 * @param     string $extern The value to use as filter.
	 *            Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ManagedObjectClassDescriptorQuery The current query, for fluid interface
	 */
	public function filterByExtern($extern = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($extern)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $extern)) {
				$extern = str_replace('*', '%', $extern);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(ManagedObjectClassDescriptorPeer::EXTERN, $extern, $comparison);
	}

	/**
	 * Filter the query by a related AttributeDescriptor object
	 *
	 * @param     AttributeDescriptor $attributeDescriptor  the related object to use as filter
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ManagedObjectClassDescriptorQuery The current query, for fluid interface
	 */
	public function filterByAtdc($attributeDescriptor, $comparison = null)
	{
		return $this
			->addUsingAlias(ManagedObjectClassDescriptorPeer::ID, $attributeDescriptor->getMocdId(), $comparison);
	}

	/**
	 * Adds a JOIN clause to the query using the Atdc relation
	 * 
	 * @param     string $relationAlias optional alias for the relation
	 * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
	 *
	 * @return    ManagedObjectClassDescriptorQuery The current query, for fluid interface
	 */
	public function joinAtdc($relationAlias = null, $joinType = Criteria::INNER_JOIN)
	{
		$tableMap = $this->getTableMap();
		$relationMap = $tableMap->getRelation('Atdc');
		
		// create a ModelJoin object for this join
		$join = new ModelJoin();
		$join->setJoinType($joinType);
		$join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
		if ($previousJoin = $this->getPreviousJoin()) {
			$join->setPreviousJoin($previousJoin);
		}
		
		// add the ModelJoin to the current object
		if($relationAlias) {
			$this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
			$this->addJoinObject($join, $relationAlias);
		} else {
			$this->addJoinObject($join, 'Atdc');
		}
		
		return $this;
	}

	/**
	 * Use the Atdc relation AttributeDescriptor object
	 *
	 * @see       useQuery()
	 * 
	 * @param     string $relationAlias optional alias for the relation,
	 *                                   to be used as main alias in the secondary query
	 * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
	 *
	 * @return    AttributeDescriptorQuery A secondary query class using the current class as primary query
	 */
	public function useAtdcQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
	{
		return $this
			->joinAtdc($relationAlias, $joinType)
			->useQuery($relationAlias ? $relationAlias : 'Atdc', 'AttributeDescriptorQuery');
	}

	/**
	 * Exclude object from result
	 *
	 * @param     ManagedObjectClassDescriptor $managedObjectClassDescriptor Object to remove from the list of results
	 *
	 * @return    ManagedObjectClassDescriptorQuery The current query, for fluid interface
	 */
	public function prune($managedObjectClassDescriptor = null)
	{
		if ($managedObjectClassDescriptor) {
			$this->addUsingAlias(ManagedObjectClassDescriptorPeer::ID, $managedObjectClassDescriptor->getId(), Criteria::NOT_EQUAL);
	  }
	  
		return $this;
	}

} // BaseManagedObjectClassDescriptorQuery
