<?php


/**
 * Base class that represents a query for the 'probable_cause' table.
 *
 * 
 *
 * @method     ProbableCauseQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     ProbableCauseQuery orderBySelector($order = Criteria::ASC) Order by the selector column
 * @method     ProbableCauseQuery orderByValue($order = Criteria::ASC) Order by the value column
 *
 * @method     ProbableCauseQuery groupById() Group by the id column
 * @method     ProbableCauseQuery groupBySelector() Group by the selector column
 * @method     ProbableCauseQuery groupByValue() Group by the value column
 *
 * @method     ProbableCauseQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ProbableCauseQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ProbableCauseQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ProbableCauseQuery leftJoinProbCause($relationAlias = null) Adds a LEFT JOIN clause to the query using the ProbCause relation
 * @method     ProbableCauseQuery rightJoinProbCause($relationAlias = null) Adds a RIGHT JOIN clause to the query using the ProbCause relation
 * @method     ProbableCauseQuery innerJoinProbCause($relationAlias = null) Adds a INNER JOIN clause to the query using the ProbCause relation
 *
 * @method     ProbableCause findOne(PropelPDO $con = null) Return the first ProbableCause matching the query
 * @method     ProbableCause findOneOrCreate(PropelPDO $con = null) Return the first ProbableCause matching the query, or a new ProbableCause object populated from the query conditions when no match is found
 *
 * @method     ProbableCause findOneById(int $id) Return the first ProbableCause filtered by the id column
 * @method     ProbableCause findOneBySelector(string $selector) Return the first ProbableCause filtered by the selector column
 * @method     ProbableCause findOneByValue(string $value) Return the first ProbableCause filtered by the value column
 *
 * @method     array findById(int $id) Return ProbableCause objects filtered by the id column
 * @method     array findBySelector(string $selector) Return ProbableCause objects filtered by the selector column
 * @method     array findByValue(string $value) Return ProbableCause objects filtered by the value column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseProbableCauseQuery extends ModelCriteria
{

	/**
	 * Initializes internal state of BaseProbableCauseQuery object.
	 *
	 * @param     string $dbName The dabase name
	 * @param     string $modelName The phpName of a model, e.g. 'Book'
	 * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
	 */
	public function __construct($dbName = 'alarm_balance', $modelName = 'ProbableCause', $modelAlias = null)
	{
		parent::__construct($dbName, $modelName, $modelAlias);
	}

	/**
	 * Returns a new ProbableCauseQuery object.
	 *
	 * @param     string $modelAlias The alias of a model in the query
	 * @param     Criteria $criteria Optional Criteria to build the query from
	 *
	 * @return    ProbableCauseQuery
	 */
	public static function create($modelAlias = null, $criteria = null)
	{
		if ($criteria instanceof ProbableCauseQuery) {
			return $criteria;
		}
		$query = new ProbableCauseQuery();
		if (null !== $modelAlias) {
			$query->setModelAlias($modelAlias);
		}
		if ($criteria instanceof Criteria) {
			$query->mergeWith($criteria);
		}
		return $query;
	}

	/**
	 * Find object by primary key
	 * Use instance pooling to avoid a database query if the object exists
	 * <code>
	 * $obj  = $c->findPk(12, $con);
	 * </code>
	 * @param     mixed $key Primary key to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    ProbableCause|array|mixed the result, formatted by the current formatter
	 */
	public function findPk($key, $con = null)
	{
		if ((null !== ($obj = ProbableCausePeer::getInstanceFromPool((string) $key))) && $this->getFormatter()->isObjectFormatter()) {
			// the object is alredy in the instance pool
			return $obj;
		} else {
			// the object has not been requested yet, or the formatter is not an object formatter
			$criteria = $this->isKeepQuery() ? clone $this : $this;
			$stmt = $criteria
				->filterByPrimaryKey($key)
				->getSelectStatement($con);
			return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
		}
	}

	/**
	 * Find objects by primary key
	 * <code>
	 * $objs = $c->findPks(array(12, 56, 832), $con);
	 * </code>
	 * @param     array $keys Primary keys to use for the query
	 * @param     PropelPDO $con an optional connection object
	 *
	 * @return    PropelObjectCollection|array|mixed the list of results, formatted by the current formatter
	 */
	public function findPks($keys, $con = null)
	{	
		$criteria = $this->isKeepQuery() ? clone $this : $this;
		return $this
			->filterByPrimaryKeys($keys)
			->find($con);
	}

	/**
	 * Filter the query by primary key
	 *
	 * @param     mixed $key Primary key to use for the query
	 *
	 * @return    ProbableCauseQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKey($key)
	{
		return $this->addUsingAlias(ProbableCausePeer::ID, $key, Criteria::EQUAL);
	}

	/**
	 * Filter the query by a list of primary keys
	 *
	 * @param     array $keys The list of primary key to use for the query
	 *
	 * @return    ProbableCauseQuery The current query, for fluid interface
	 */
	public function filterByPrimaryKeys($keys)
	{
		return $this->addUsingAlias(ProbableCausePeer::ID, $keys, Criteria::IN);
	}

	/**
	 * Filter the query on the id column
	 * 
	 * @param     int|array $id The value to use as filter.
	 *            Accepts an associative array('min' => $minValue, 'max' => $maxValue)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ProbableCauseQuery The current query, for fluid interface
	 */
	public function filterById($id = null, $comparison = null)
	{
		if (is_array($id) && null === $comparison) {
			$comparison = Criteria::IN;
		}
		return $this->addUsingAlias(ProbableCausePeer::ID, $id, $comparison);
	}

	/**
	 * Filter the query on the selector column
	 * 
	 * @param     string $selector The value to use as filter.
	 *            Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ProbableCauseQuery The current query, for fluid interface
	 */
	public function filterBySelector($selector = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($selector)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $selector)) {
				$selector = str_replace('*', '%', $selector);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(ProbableCausePeer::SELECTOR, $selector, $comparison);
	}

	/**
	 * Filter the query on the value column
	 * 
	 * @param     string $value The value to use as filter.
	 *            Accepts wildcards (* and % trigger a LIKE)
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ProbableCauseQuery The current query, for fluid interface
	 */
	public function filterByValue($value = null, $comparison = null)
	{
		if (null === $comparison) {
			if (is_array($value)) {
				$comparison = Criteria::IN;
			} elseif (preg_match('/[\%\*]/', $value)) {
				$value = str_replace('*', '%', $value);
				$comparison = Criteria::LIKE;
			}
		}
		return $this->addUsingAlias(ProbableCausePeer::VALUE, $value, $comparison);
	}

	/**
	 * Filter the query by a related CurrentAlarmCondition object
	 *
	 * @param     CurrentAlarmCondition $currentAlarmCondition  the related object to use as filter
	 * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
	 *
	 * @return    ProbableCauseQuery The current query, for fluid interface
	 */
	public function filterByProbCause($currentAlarmCondition, $comparison = null)
	{
		return $this
			->addUsingAlias(ProbableCausePeer::ID, $currentAlarmCondition->getPcId(), $comparison);
	}

	/**
	 * Adds a JOIN clause to the query using the ProbCause relation
	 * 
	 * @param     string $relationAlias optional alias for the relation
	 * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
	 *
	 * @return    ProbableCauseQuery The current query, for fluid interface
	 */
	public function joinProbCause($relationAlias = null, $joinType = Criteria::INNER_JOIN)
	{
		$tableMap = $this->getTableMap();
		$relationMap = $tableMap->getRelation('ProbCause');
		
		// create a ModelJoin object for this join
		$join = new ModelJoin();
		$join->setJoinType($joinType);
		$join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
		if ($previousJoin = $this->getPreviousJoin()) {
			$join->setPreviousJoin($previousJoin);
		}
		
		// add the ModelJoin to the current object
		if($relationAlias) {
			$this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
			$this->addJoinObject($join, $relationAlias);
		} else {
			$this->addJoinObject($join, 'ProbCause');
		}
		
		return $this;
	}

	/**
	 * Use the ProbCause relation CurrentAlarmCondition object
	 *
	 * @see       useQuery()
	 * 
	 * @param     string $relationAlias optional alias for the relation,
	 *                                   to be used as main alias in the secondary query
	 * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
	 *
	 * @return    CurrentAlarmConditionQuery A secondary query class using the current class as primary query
	 */
	public function useProbCauseQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
	{
		return $this
			->joinProbCause($relationAlias, $joinType)
			->useQuery($relationAlias ? $relationAlias : 'ProbCause', 'CurrentAlarmConditionQuery');
	}

	/**
	 * Exclude object from result
	 *
	 * @param     ProbableCause $probableCause Object to remove from the list of results
	 *
	 * @return    ProbableCauseQuery The current query, for fluid interface
	 */
	public function prune($probableCause = null)
	{
		if ($probableCause) {
			$this->addUsingAlias(ProbableCausePeer::ID, $probableCause->getId(), Criteria::NOT_EQUAL);
	  }
	  
		return $this;
	}

} // BaseProbableCauseQuery
