<?php


/**
 * Base class that represents a query for the 'thr_asev_asgt_rule' table.
 *
 *
 *
 * @method ThresholdAlarmSeverityAssignmentRuleQuery orderById($order = Criteria::ASC) Order by the id column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery orderByMod($order = Criteria::ASC) Order by the mod column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery orderByName($order = Criteria::ASC) Order by the name column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery orderByAedId($order = Criteria::ASC) Order by the aed_id column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery orderByCntValClear($order = Criteria::ASC) Order by the cnt_val_clear column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery orderByCntValWarn($order = Criteria::ASC) Order by the cnt_val_warn column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery orderByCntValMin($order = Criteria::ASC) Order by the cnt_val_min column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery orderByCntValMaj($order = Criteria::ASC) Order by the cnt_val_maj column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery orderByCntValCrit($order = Criteria::ASC) Order by the cnt_val_crit column
 *
 * @method ThresholdAlarmSeverityAssignmentRuleQuery groupById() Group by the id column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery groupByMod() Group by the mod column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery groupByName() Group by the name column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery groupByAedId() Group by the aed_id column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery groupByCntValClear() Group by the cnt_val_clear column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery groupByCntValWarn() Group by the cnt_val_warn column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery groupByCntValMin() Group by the cnt_val_min column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery groupByCntValMaj() Group by the cnt_val_maj column
 * @method ThresholdAlarmSeverityAssignmentRuleQuery groupByCntValCrit() Group by the cnt_val_crit column
 *
 * @method ThresholdAlarmSeverityAssignmentRuleQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method ThresholdAlarmSeverityAssignmentRuleQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method ThresholdAlarmSeverityAssignmentRuleQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method ThresholdAlarmSeverityAssignmentRuleQuery leftJoinAlarmEventDescriptor($relationAlias = null) Adds a LEFT JOIN clause to the query using the AlarmEventDescriptor relation
 * @method ThresholdAlarmSeverityAssignmentRuleQuery rightJoinAlarmEventDescriptor($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AlarmEventDescriptor relation
 * @method ThresholdAlarmSeverityAssignmentRuleQuery innerJoinAlarmEventDescriptor($relationAlias = null) Adds a INNER JOIN clause to the query using the AlarmEventDescriptor relation
 *
 * @method ThresholdAlarmSeverityAssignmentRule findOne(PropelPDO $con = null) Return the first ThresholdAlarmSeverityAssignmentRule matching the query
 * @method ThresholdAlarmSeverityAssignmentRule findOneOrCreate(PropelPDO $con = null) Return the first ThresholdAlarmSeverityAssignmentRule matching the query, or a new ThresholdAlarmSeverityAssignmentRule object populated from the query conditions when no match is found
 *
 * @method ThresholdAlarmSeverityAssignmentRule findOneByMod(int $mod) Return the first ThresholdAlarmSeverityAssignmentRule filtered by the mod column
 * @method ThresholdAlarmSeverityAssignmentRule findOneByName(string $name) Return the first ThresholdAlarmSeverityAssignmentRule filtered by the name column
 * @method ThresholdAlarmSeverityAssignmentRule findOneByAedId(int $aed_id) Return the first ThresholdAlarmSeverityAssignmentRule filtered by the aed_id column
 * @method ThresholdAlarmSeverityAssignmentRule findOneByCntValClear(int $cnt_val_clear) Return the first ThresholdAlarmSeverityAssignmentRule filtered by the cnt_val_clear column
 * @method ThresholdAlarmSeverityAssignmentRule findOneByCntValWarn(int $cnt_val_warn) Return the first ThresholdAlarmSeverityAssignmentRule filtered by the cnt_val_warn column
 * @method ThresholdAlarmSeverityAssignmentRule findOneByCntValMin(int $cnt_val_min) Return the first ThresholdAlarmSeverityAssignmentRule filtered by the cnt_val_min column
 * @method ThresholdAlarmSeverityAssignmentRule findOneByCntValMaj(int $cnt_val_maj) Return the first ThresholdAlarmSeverityAssignmentRule filtered by the cnt_val_maj column
 * @method ThresholdAlarmSeverityAssignmentRule findOneByCntValCrit(int $cnt_val_crit) Return the first ThresholdAlarmSeverityAssignmentRule filtered by the cnt_val_crit column
 *
 * @method array findById(int $id) Return ThresholdAlarmSeverityAssignmentRule objects filtered by the id column
 * @method array findByMod(int $mod) Return ThresholdAlarmSeverityAssignmentRule objects filtered by the mod column
 * @method array findByName(string $name) Return ThresholdAlarmSeverityAssignmentRule objects filtered by the name column
 * @method array findByAedId(int $aed_id) Return ThresholdAlarmSeverityAssignmentRule objects filtered by the aed_id column
 * @method array findByCntValClear(int $cnt_val_clear) Return ThresholdAlarmSeverityAssignmentRule objects filtered by the cnt_val_clear column
 * @method array findByCntValWarn(int $cnt_val_warn) Return ThresholdAlarmSeverityAssignmentRule objects filtered by the cnt_val_warn column
 * @method array findByCntValMin(int $cnt_val_min) Return ThresholdAlarmSeverityAssignmentRule objects filtered by the cnt_val_min column
 * @method array findByCntValMaj(int $cnt_val_maj) Return ThresholdAlarmSeverityAssignmentRule objects filtered by the cnt_val_maj column
 * @method array findByCntValCrit(int $cnt_val_crit) Return ThresholdAlarmSeverityAssignmentRule objects filtered by the cnt_val_crit column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseThresholdAlarmSeverityAssignmentRuleQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseThresholdAlarmSeverityAssignmentRuleQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'sysal';
        }
        if (null === $modelName) {
            $modelName = 'ThresholdAlarmSeverityAssignmentRule';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ThresholdAlarmSeverityAssignmentRuleQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   ThresholdAlarmSeverityAssignmentRuleQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof ThresholdAlarmSeverityAssignmentRuleQuery) {
            return $criteria;
        }
        $query = new ThresholdAlarmSeverityAssignmentRuleQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   ThresholdAlarmSeverityAssignmentRule|ThresholdAlarmSeverityAssignmentRule[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = ThresholdAlarmSeverityAssignmentRulePeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(ThresholdAlarmSeverityAssignmentRulePeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 ThresholdAlarmSeverityAssignmentRule A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 ThresholdAlarmSeverityAssignmentRule A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `mod`, `name`, `aed_id`, `cnt_val_clear`, `cnt_val_warn`, `cnt_val_min`, `cnt_val_maj`, `cnt_val_crit` FROM `thr_asev_asgt_rule` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new ThresholdAlarmSeverityAssignmentRule();
            $obj->hydrate($row);
            ThresholdAlarmSeverityAssignmentRulePeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return ThresholdAlarmSeverityAssignmentRule|ThresholdAlarmSeverityAssignmentRule[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|ThresholdAlarmSeverityAssignmentRule[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the mod column
     *
     * Example usage:
     * <code>
     * $query->filterByMod(1234); // WHERE mod = 1234
     * $query->filterByMod(array(12, 34)); // WHERE mod IN (12, 34)
     * $query->filterByMod(array('min' => 12)); // WHERE mod >= 12
     * $query->filterByMod(array('max' => 12)); // WHERE mod <= 12
     * </code>
     *
     * @param     mixed $mod The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByMod($mod = null, $comparison = null)
    {
        if (is_array($mod)) {
            $useMinMax = false;
            if (isset($mod['min'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::MOD, $mod['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($mod['max'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::MOD, $mod['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::MOD, $mod, $comparison);
    }

    /**
     * Filter the query on the name column
     *
     * Example usage:
     * <code>
     * $query->filterByName('fooValue');   // WHERE name = 'fooValue'
     * $query->filterByName('%fooValue%'); // WHERE name LIKE '%fooValue%'
     * </code>
     *
     * @param     string $name The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByName($name = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($name)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $name)) {
                $name = str_replace('*', '%', $name);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::NAME, $name, $comparison);
    }

    /**
     * Filter the query on the aed_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAedId(1234); // WHERE aed_id = 1234
     * $query->filterByAedId(array(12, 34)); // WHERE aed_id IN (12, 34)
     * $query->filterByAedId(array('min' => 12)); // WHERE aed_id >= 12
     * $query->filterByAedId(array('max' => 12)); // WHERE aed_id <= 12
     * </code>
     *
     * @see       filterByAlarmEventDescriptor()
     *
     * @param     mixed $aedId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByAedId($aedId = null, $comparison = null)
    {
        if (is_array($aedId)) {
            $useMinMax = false;
            if (isset($aedId['min'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::AED_ID, $aedId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($aedId['max'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::AED_ID, $aedId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::AED_ID, $aedId, $comparison);
    }

    /**
     * Filter the query on the cnt_val_clear column
     *
     * Example usage:
     * <code>
     * $query->filterByCntValClear(1234); // WHERE cnt_val_clear = 1234
     * $query->filterByCntValClear(array(12, 34)); // WHERE cnt_val_clear IN (12, 34)
     * $query->filterByCntValClear(array('min' => 12)); // WHERE cnt_val_clear >= 12
     * $query->filterByCntValClear(array('max' => 12)); // WHERE cnt_val_clear <= 12
     * </code>
     *
     * @param     mixed $cntValClear The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByCntValClear($cntValClear = null, $comparison = null)
    {
        if (is_array($cntValClear)) {
            $useMinMax = false;
            if (isset($cntValClear['min'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_CLEAR, $cntValClear['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($cntValClear['max'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_CLEAR, $cntValClear['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_CLEAR, $cntValClear, $comparison);
    }

    /**
     * Filter the query on the cnt_val_warn column
     *
     * Example usage:
     * <code>
     * $query->filterByCntValWarn(1234); // WHERE cnt_val_warn = 1234
     * $query->filterByCntValWarn(array(12, 34)); // WHERE cnt_val_warn IN (12, 34)
     * $query->filterByCntValWarn(array('min' => 12)); // WHERE cnt_val_warn >= 12
     * $query->filterByCntValWarn(array('max' => 12)); // WHERE cnt_val_warn <= 12
     * </code>
     *
     * @param     mixed $cntValWarn The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByCntValWarn($cntValWarn = null, $comparison = null)
    {
        if (is_array($cntValWarn)) {
            $useMinMax = false;
            if (isset($cntValWarn['min'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_WARN, $cntValWarn['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($cntValWarn['max'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_WARN, $cntValWarn['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_WARN, $cntValWarn, $comparison);
    }

    /**
     * Filter the query on the cnt_val_min column
     *
     * Example usage:
     * <code>
     * $query->filterByCntValMin(1234); // WHERE cnt_val_min = 1234
     * $query->filterByCntValMin(array(12, 34)); // WHERE cnt_val_min IN (12, 34)
     * $query->filterByCntValMin(array('min' => 12)); // WHERE cnt_val_min >= 12
     * $query->filterByCntValMin(array('max' => 12)); // WHERE cnt_val_min <= 12
     * </code>
     *
     * @param     mixed $cntValMin The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByCntValMin($cntValMin = null, $comparison = null)
    {
        if (is_array($cntValMin)) {
            $useMinMax = false;
            if (isset($cntValMin['min'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_MIN, $cntValMin['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($cntValMin['max'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_MIN, $cntValMin['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_MIN, $cntValMin, $comparison);
    }

    /**
     * Filter the query on the cnt_val_maj column
     *
     * Example usage:
     * <code>
     * $query->filterByCntValMaj(1234); // WHERE cnt_val_maj = 1234
     * $query->filterByCntValMaj(array(12, 34)); // WHERE cnt_val_maj IN (12, 34)
     * $query->filterByCntValMaj(array('min' => 12)); // WHERE cnt_val_maj >= 12
     * $query->filterByCntValMaj(array('max' => 12)); // WHERE cnt_val_maj <= 12
     * </code>
     *
     * @param     mixed $cntValMaj The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByCntValMaj($cntValMaj = null, $comparison = null)
    {
        if (is_array($cntValMaj)) {
            $useMinMax = false;
            if (isset($cntValMaj['min'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_MAJ, $cntValMaj['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($cntValMaj['max'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_MAJ, $cntValMaj['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_MAJ, $cntValMaj, $comparison);
    }

    /**
     * Filter the query on the cnt_val_crit column
     *
     * Example usage:
     * <code>
     * $query->filterByCntValCrit(1234); // WHERE cnt_val_crit = 1234
     * $query->filterByCntValCrit(array(12, 34)); // WHERE cnt_val_crit IN (12, 34)
     * $query->filterByCntValCrit(array('min' => 12)); // WHERE cnt_val_crit >= 12
     * $query->filterByCntValCrit(array('max' => 12)); // WHERE cnt_val_crit <= 12
     * </code>
     *
     * @param     mixed $cntValCrit The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function filterByCntValCrit($cntValCrit = null, $comparison = null)
    {
        if (is_array($cntValCrit)) {
            $useMinMax = false;
            if (isset($cntValCrit['min'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_CRIT, $cntValCrit['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($cntValCrit['max'])) {
                $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_CRIT, $cntValCrit['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::CNT_VAL_CRIT, $cntValCrit, $comparison);
    }

    /**
     * Filter the query by a related AlarmEventDescriptor object
     *
     * @param   AlarmEventDescriptor|PropelObjectCollection $alarmEventDescriptor The related object(s) to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return                 ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     * @throws PropelException - if the provided filter is invalid.
     */
    public function filterByAlarmEventDescriptor($alarmEventDescriptor, $comparison = null)
    {
        if ($alarmEventDescriptor instanceof AlarmEventDescriptor) {
            return $this
                ->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::AED_ID, $alarmEventDescriptor->getId(), $comparison);
        } elseif ($alarmEventDescriptor instanceof PropelObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::AED_ID, $alarmEventDescriptor->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAlarmEventDescriptor() only accepts arguments of type AlarmEventDescriptor or PropelCollection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AlarmEventDescriptor relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function joinAlarmEventDescriptor($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AlarmEventDescriptor');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AlarmEventDescriptor');
        }

        return $this;
    }

    /**
     * Use the AlarmEventDescriptor relation AlarmEventDescriptor object
     *
     * @see       useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   AlarmEventDescriptorQuery A secondary query class using the current class as primary query
     */
    public function useAlarmEventDescriptorQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAlarmEventDescriptor($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AlarmEventDescriptor', 'AlarmEventDescriptorQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   ThresholdAlarmSeverityAssignmentRule $thresholdAlarmSeverityAssignmentRule Object to remove from the list of results
     *
     * @return ThresholdAlarmSeverityAssignmentRuleQuery The current query, for fluid interface
     */
    public function prune($thresholdAlarmSeverityAssignmentRule = null)
    {
        if ($thresholdAlarmSeverityAssignmentRule) {
            $this->addUsingAlias(ThresholdAlarmSeverityAssignmentRulePeer::ID, $thresholdAlarmSeverityAssignmentRule->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
