<?php

// imports
require_once 'GenericAdmin/DataTypes/EnumType.php';

class AlarmSevty extends EnumType {

	/** the possible values for attribute alarm severity - important: must be consistent with AlarmStatus */
	const AS_CLEAR = 0; // cleared
	const AS_WARN  = 1; // warning
	const AS_MIN   = 2; // minor
	const AS_MAJ   = 3; // major
	const AS_CRIT  = 4; // critical
	const AS_INDET = 5; // indeterminate
	
	// (string representations of) defined values
	public static $defd_vals = array (
		self::AS_CLEAR => 'cleared',
		self::AS_WARN  => 'warning',
		self::AS_MIN   => 'minor',
		self::AS_MAJ   => 'major',
		self::AS_CRIT  => 'critical',
		self::AS_INDET => 'indeterminate'
	);

	public function __construct($value = self::AS_INDET) {
		$this->initInstance('AlarmSevty', self::$defd_vals, $value);
	}
}
